#!/usr/bin/perl
###############################################################################
# Setup.cgi                                                                   #
###############################################################################
# UltraBoard 2000 by UltraScripts.com, Inc.                                   #
# Scripts written by Jacky Wing Wa Yung, WebMaster@UltraScripts.com           #
# Available from http://www.UltraBoard.org/                                   #
# =========================================================================== #
# COPYRIGHT NOTICE :                                                          #
#                                                                             #
# Copyright (c) 1999-2000 UltraScripts.com, Inc. All Rights Reserved.         #
#                                                                             #
# This program is being distributed as shareware. It may be used and modified #
# free for personal, government or non-profit. Any commercial use must be     #
# registered. However, modified versions cannot be sold or distributed. You   #
# cannot alter the copyright and "powered by" notices throughout the scripts. #
# These notices must be clearly visible to the end users.                     #
#                                                                             #
# WARRANTY DISCLAIMER:                                                        #
#                                                                             #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT #
# ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR       #
# FITNESS FOR A PARTICULAR PURPOSE.                                           #
###############################################################################
# 媩																	  #
# W١GUltraBoard2000 媩												  #
# GCGI/Qװ														  #
# ҡGWindows9x/NT/Unix/Linux											  #
# ʽGӤHKO														  #
# Ghttp://www.ub2k.com												  #
# ơGthreesecond														  #
# EmailGsa8641012@scc3.scc.edu.tw										  #
###############################################################################

use strict;

package UB;

BEGIN {
  # if you having problem on the script, set $UB::PATH to the full path to your
  # ultraboard directory.
  $UB::PATH    = ".";

  $SYSTEM::EXT = $ENV{'SCRIPT_NAME'} || $ENV{'SCRIPT_FILENAME'} || $0;
  $SYSTEM::EXT =~s/^.+\.(\w+)$/$1/g;

  ($0 =~ m/(.*)\/[^\/]+/) && unshift (@INC, "$1");
  ($0 =~ m/(.*)\\[^\\]+/) && unshift (@INC, "$1");

  eval {
    unless (-e $UB::PATH."/Setup.$SYSTEM::EXT") {
      foreach my $P ( $ENV{'SCRIPT_FILENAME'}, $ENV{'PATH_TRANSLATED'}, $ENV{'DOCUMENT_ROOT'}.$ENV{'SCRIPT_NAME'}, $0 ) {
        $P =~s/\\/\//g;
        $P =~s/(.*)\/[^\/]+/$1/g;
        if (-e $P."/Setup.$SYSTEM::EXT") {
          $UB::PATH = $P;
          last;
        }
      }
    }
  };

  unshift (@INC, "$UB::PATH");
}

# required using at least perl v5.004.
eval {
  require 5.004;
} || &UB::CGIError("LkJ Perl 5.004 Χs. $@", "");

###############################################################################
# Variables

$| = 1;

$UB::VERSION     = "2.00";

%UB::QUERY       = &Standard::Parse();

$UB::USERNAME    = "";
$UB::PASSWORD    = "";
$UB::HOSTNAME    = "";
$UB::DIRECTORY   = "";
$UB::IMAGES_PATH = "http://www.ultraboard.org/ultraboard/setup";

if ($ENV{'SERVER_ADMIN'}) {
  $UB::PASSWORD = $ENV{'SERVER_ADMIN'};
}

###############################################################################

print "Content-type: text/html\n\n";

# error running main function
eval { &UB::Main } || &UB::CGIError("LkznD. $@", "");

exit;

###############################################################################
# Main function
sub Main {

  if (-e "$UB::PATH/setup.lock") {
    open (LOCK, "$UB::PATH/setup.lock");
      my $time = join ("", <LOCK>);
    close(LOCK);

    if (($time) && ($time < (time - 3600))) {
      #&Lock();
    }
  } else {
    #&Lock();
  }

  if ($UB::QUERY{'Category'} eq "Setup") {
    if ($UB::QUERY{'Step'} eq "1") {
      &Setup::Setup();
    } elsif ($UB::QUERY{'Step'} eq "#1") {
      &Setup::DoSetup();
    } elsif ($UB::QUERY{'Step'} eq "2") {
      &Setup::CfgSystem();
    } elsif ($UB::QUERY{'Step'} eq "#2") {
      &Setup::DoCfgSystem();
    } elsif ($UB::QUERY{'Step'} eq "3") {
      &Setup::CreateAdministrator();
    } elsif ($UB::QUERY{'Step'} eq "#3") {
      &Setup::DoCreateAdministrator();
    }
  } elsif ($UB::QUERY{'Category'} eq "Upgrade") {
    if ($UB::QUERY{'Action'} eq "Process") {
      &Upgrade::Process();
    } else {
      &Upgrade::Upgrade();
    }
  } elsif ($UB::QUERY{'Category'} eq "Uninstall") {
    if ($UB::QUERY{'Action'} eq "Process") {
      &Uninstall::Process();
    } else {
      &Uninstall::Uninstall();
    }
  } elsif ($UB::QUERY{'Category'} eq "SetPermission") {
    if ($UB::QUERY{'Action'} eq "Process") {
      &Permission::Set::DoSet();
    } else {
      &Permission::Set::Set();
    }
  } elsif ($UB::QUERY{'Category'} eq "UnsetPermission") {
    if ($UB::QUERY{'Action'} eq "Process") {
      &Permission::Unset::DoUnset();
    } else {
      &Permission::Unset::Unset();
    }
  } else {
    &Menu();
  }
}

###############################################################################
# Menu function
sub Menu {
  print<<HTML;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<html>
<head>
  <title>UltraBoard 2000 w˺F</title>
</head>

<body text="#333333" link="#0033CC">
<table width="100%" cellspacing="0" cellpadding="0" align="center">
  <tr>
    <td>
      <font face="Verdana,Geneva,Arial,Helvetica,sans-serif" size="2"><h2><b><a href="Setup.$SYSTEM::EXT?Category=Setup&Step=1">w UltraBoard 2000</a></b></h2>
      Uo̶}lw UltraBoard 2000. |z]wn UltraBoard 2000, åB|qڭ̪ UltraScripts.com WUҦɮ. Uɮרæw˨zAjݭn 15 .</font><p>
    </td>
  </tr>
  <tr>
    <td>
      <font face="Verdana,Geneva,Arial,Helvetica,sans-serif" size="2"><h2><b><a href="Setup.$SYSTEM::EXT?Category=Upgrade">ɯ UltraBoard 1.6x</a></b></h2>
      Uo̶}lN UltraBoard 1.6x ɯŬ UltraBoard 2000. |zN UltraBoard 1.6x ഫ UltraBoard 2000 ƥ榡. <font color="Red">zƥw˦n UltraBoard 2000!! bzഫƥ榡, ظƫ, ziHq UltraBoard 2000 xN_.</font></font><p>
    </td>
  </tr>
  <tr>
    <td>
      <font face="Verdana,Geneva,Arial,Helvetica,sans-serif" size="2"><h2><b><a href="Setup.$SYSTEM::EXT?Category=Uninstall"> UltraBoard 2000</a></b></h2>
      Uo̶}l UltraBoard 2000 . |zҦ UltraBoard 2000 ɮ. Ҧɮ׳|QR, ]AƥMGDD... <font color="Red">OoqxNҦɮ׳ƥ, åBU^zۤvq̭s.</font></font><p>
    </td>
  </tr>
  <tr>
    <td>
      <font face="Verdana,Geneva,Arial,Helvetica,sans-serif" size="2"><h2><b><a href="Setup.$SYSTEM::EXT?Category=SetPermission">]w UltraBoard 2000 v</a></b></h2>
      Uo̶}l]w UltraBoard 2000 v. |z]wҦɮתv, ҦHLkŪ/goɮ.</font></font><p>
    </td>
  </tr>
  <tr>
    <td>
      <font face="Verdana,Geneva,Arial,Helvetica,sans-serif" size="2"><h2><b><a href="Setup.$SYSTEM::EXT?Category=UnsetPermission">Ѱ]w UltraBoard 2000 v</a></b></h2>
      Uo̶}lѰ]w  UltraBoard 2000 v. |zѰ]wҦɮתv, ҦHŪ/goɮ.</font></font><p>
    </td>
  </tr>
  <tr>
    <td>
      <font face="Verdana,Geneva,Arial,Helvetica,sans-serif" size="2">
      <hr width="100%" size="2">
      <b>Copyright Notice (vŧi )</b><p>
      Copyright (c) 1999-2000 <a href="http://www.ultrascripts.com" target="_blank">UltraScripts.com, Inc</a>. All Rights Reserved.<p>
      This program is being distributed as shareware. It may be used and modified free for personal, government or non-profit. Any commercial use must be registered. However, modified versions cannot be sold or distributed. You cannot alter the copyright and "powered by" notices throughout the scripts. These notices must be clearly visible to the end users.
      <p>
      <b>Usage Disclaimer</b><br>
      THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.<p>
      </font>
    </td>
  </tr>
</table>
</body>
</html>
HTML
  exit;
}

###############################################################################
# Lock function
sub Lock {
  &HTML::Top("(disabled)", "Disabled");
  &HTML::Description (
    "p, UltraBoard 2000 w˺FwQ. zsW setup.lock ~Ұʦw˺F."
  );

  &HTML::Bottom();

  exit;
}

###############################################################################
# CGIError function
# - function of display error message with form and environment information during internal error.
sub CGIError {
  my ($message, $path) = @_;

  my ($key, $space);

  print "<html>\n";
  print "<head>\n";
  print "<title>CGI yk~</title>\n";
  print "</head>\n";
  print "<body>\n";
  print "<font face=\"Verdana\">\n";
  print "<font size=\"4\"><b>CGI yk~</b></font><p>\n";
  print "<font size=\"2\">\n";

  # printing error message
  $message =~ s/\n/<br>\n/g;
  $message and print $message;
  print "<p>";

  # printing general infomation
  print "<font size=\"4\"><b>@T</b></font><p>\n";
  print "<table cellpadding=\"0\" cellspacing=\"0\">\n";

  if ($path) {
    $path =~ s/\\/\//g;
    print "<tr>\n";
    print "<td width=\"200\" valign=\"TOP\"><font face=\"Verdana\" size=\"2\"><b>~|</b></font></td>\n";
    print "<td><font face=\"Verdana\" size=\"2\">$path</font></td>\n";
    print "</tr>\n";
  }
  if ($0) {
    $0 =~ s/\\/\//g;
    print "<tr>\n";
    print "<td width=\"200\" valign=\"TOP\"><font face=\"Verdana\" size=\"2\"><b>yk|</b></font></td>\n";
    print "<td><font face=\"Verdana\" size=\"2\">$0</font></td>\n";
    print "</tr>\n";
  }
  if ($]) {
    print "<tr>\n";
    print "<td width=\"200\" valign=\"TOP\"><font face=\"Verdana\" size=\"2\"><b>Perl </b></font></td>\n";
    print "<td><font face=\"Verdana\" size=\"2\">$]</font></td>\n";
    print "</tr>\n";
  }
  if ($CGI::VERSION) {
    print "<tr>\n";
    print "<td width=\"200\" valign=\"TOP\"><font face=\"Verdana\" size=\"2\"><b>CGI.pm </b></font></td>\n";
    print "<td><font face=\"Verdana\" size=\"2\">$CGI::VERSION</font></td>\n";
    print "</tr>\n";
  }
  print "</table><p>\n";

  if (defined %UB::QUERY) {
    # printing form variables
    print "<font size=\"4\"><b>ܼ</b></font><p>\n";
    print "<table cellpadding=\"0\" cellspacing=\"0\">\n";
    foreach my $KEY (sort keys %UB::QUERY) {
      print "<tr>\n";
      print "<td width=\"200\" valign=\"TOP\"><font face=\"Verdana\" size=\"2\"><b>$KEY</b></font></td>\n";
      print "<td><font face=\"Verdana\" size=\"2\">".$UB::QUERY{$KEY}."</font></td>\n";
      print "</tr>\n";
    }
    print "</table><p>\n";
  }

  # printing environment variables
  print "<font size=\"4\"><b>ܼ</b></font><p>\n";
  print "<table cellpadding=\"0\" cellspacing=\"0\">\n";
  foreach $key (sort keys %ENV) {
    print "<tr>\n";
    print "<td width=\"200\" valign=\"TOP\"><font face=\"Verdana\" size=\"2\"><b>$key</b></font></td>\n";
    print "<td><font face=\"Verdana\" size=\"2\">".$ENV{$key}."</font></td>\n";
    print "</tr>\n";
  }
  print "</table><p>\n";
  print "</font>\n";
  print "</font>\n";
  print "</body>\n";
  print "</html>\n";

  exit;
}

###############################################################################
package Setup;

use File::Path;
use File::Copy;

###############################################################################
# Setup function
sub Setup {
  my ($ERROR) = @_;

  if ($UB::PATH eq ".") {
    foreach my $P ( $ENV{'SCRIPT_FILENAME'}, $ENV{'PATH_TRANSLATED'}, $ENV{'DOCUMENT_ROOT'}.$ENV{'SCRIPT_NAME'}, $0 ) {
      $P =~s/\\/\//g;
      $P =~s/(.*)\/[^\/]+/$1/g;
      if (-e $P."/Setup.$SYSTEM::EXT") {
        $SYSTEM::SCRIPTS_PATH = $P;
        last;
      }
    }
  } else {
    $SYSTEM::SCRIPTS_PATH = $UB::PATH;
  }

  $SYSTEM::PRIVATE_PATH    = "$SYSTEM::SCRIPTS_PATH/Private";

  $SYSTEM::PUBLIC_PATH     = "$SYSTEM::SCRIPTS_PATH/Public";

  if ($SYSTEM::PUBLIC_PATH =~ /\/cgi-bin/i) {
    $SYSTEM::PUBLIC_PATH =~ s/\/cgi-bin//ig;
  }

  &HTML::Top("(BJ 3  1)", "w˸T");
  &HTML::Description (
    "жJҦХܤF (<font color=\"Red\"><b>*</b></font>) .",
    "wɮ׮, oͤFUC~."                  , $ERROR
  );

  print qq~<form method="post">\n~;
  print qq~<input type="hidden" name="Category" value="Setup">\n~;
  print qq~<input type="hidden" name="Step" value="#1">\n~;

  &HTML::Category("Absolute Path");

  print &HTML::FORM::TextField (
    TITLE       => "UltraBoard ؿ",
    DESCRIPTION => "zn Ultraboard 2000 w˦bӥؿ? пJzҭnw˪m|. (e.g. \"/home/yourdomain/cgi-bin/UltraBoard\") zƥإߦn@ /UltraBoard ؿ!!",
    NAME        => "SCRIPTS_PATH",
    VALUE       => $UB::QUERY{'SCRIPTS_PATH'} || $SYSTEM::SCRIPTS_PATH,
    REQUIRED    => "1", MAXLENGTH => "", SIZE => "45"
  );

  &HTML::Blank();

  print &HTML::FORM::TextField (
    TITLE       => "pHؿ",
    DESCRIPTION => "пJzҭnw˩ҦlXP ascii m|. (e.g. \"/home/yourdomain/cgi-bin/UltraBoard/Private\") zƥإߦn@ /UltraBoard/Private ؿ!!",
    NAME        => "PRIVATE_PATH",
    VALUE       => $UB::QUERY{'PRIVATE_PATH'} || $SYSTEM::PRIVATE_PATH,
    REQUIRED    => "1", MAXLENGTH => "", SIZE => "45"
  );

  print &HTML::FORM::TextField (
    TITLE       => "}ؿ",
    DESCRIPTION => "пJzҭnw˩ҦGi(binary)ɪm|. (e.g. \"/home/yourdomain//UltraBoard/Public\") zƥإߦn@ /UltraBoard/Public ؿ!!",
    NAME        => "PUBLIC_PATH",
    VALUE       => $UB::QUERY{'PUBLIC'} || $SYSTEM::PUBLIC_PATH,
    REQUIRED    => "1", MAXLENGTH => "", SIZE => "45"
  );

  &HTML::Blank();

  print qq~<tr>\n<td width="250" valign="top" nowrap>&nbsp;</td>\n~;
  print qq~<td colspan="2" valign="top" bgcolor="#EEEEEE"><input type="submit" value="}lw" class="Button"> <input type="Reset" value="" class="Button"></td>\n~;
  print qq~</tr>\n</table>\n~;
  print qq~<table width="100%" border="0" cellspacing="0" cellpadding="0"><tr><td nowrap></form></td></tr></table>\n~;

  &HTML::Bottom();

  exit;
}

###############################################################################
# DoSetup function
sub DoSetup {

  $SYSTEM::PATHS{'SCRIPTS'}    = $UB::QUERY{'SCRIPTS_PATH'}  ;
  $SYSTEM::PATHS{'PRIVATE'}    = $UB::QUERY{'PRIVATE_PATH'}  ;
  $SYSTEM::PATHS{'PUBLIC'}     = $UB::QUERY{'PUBLIC_PATH'}   ;

  $SYSTEM::PATHS{'VARIABLES'}  = $SYSTEM::PATHS{'PRIVATE'}."/Variables";

  $SYSTEM::PATHS{'SOURCES'}    = $SYSTEM::PATHS{'PRIVATE'}."/Sources";
  $SYSTEM::PATHS{'LIBRARIES'}  = $SYSTEM::PATHS{'SOURCES'}."/Libraries";

  $SYSTEM::PATHS{'DATABASE'}   = $SYSTEM::PATHS{'PRIVATE'}."/Database";
  $SYSTEM::PATHS{'BACKUPS'}    = $SYSTEM::PATHS{'PRIVATE'}."/Backups";
  $SYSTEM::PATHS{'UPLOADS'}    = $SYSTEM::PATHS{'PUBLIC'}."/Uploads";

  $SYSTEM::PATHS{'THEMES'}     = $SYSTEM::PATHS{'PRIVATE'}."/Themes";
  $SYSTEM::PATHS{'INTERFACES'} = $SYSTEM::PATHS{'PRIVATE'}."/Interfaces";
  $SYSTEM::PATHS{'IMAGES'}     = $SYSTEM::PATHS{'PUBLIC'}."/Images";

  foreach my $KEY (keys %SYSTEM::PATHS) {
    $SYSTEM::PATHS{ $KEY } =~s/^\s+//g;
    $SYSTEM::PATHS{ $KEY } =~s/\s+$//g;
    $SYSTEM::PATHS{ $KEY } =~s/^\$SCRIPTS_PATH/$SYSTEM::PATHS{'SCRIPTS'}/ig;
    $SYSTEM::PATHS{ $KEY } =~s/\\/\//g;
    $SYSTEM::PATHS{ $KEY } =~s/\/$//g;
    $SYSTEM::PATHS{ $KEY } =~s/\s+$//g;
  }

  my @Paths = ();
  foreach my $KEY (keys %SYSTEM::PATHS) {
    unless ((-e $SYSTEM::PATHS{ $KEY }) && (-d $SYSTEM::PATHS{ $KEY })) {
      if (my @Created = mkpath ($SYSTEM::PATHS{ $KEY }, 0, 0777)) {
        push (@Paths, @Created);
        chmod (0777, @Created);
      } else {
        &Setup("Lkإ $SYSTEM::PATHS{ $KEY } ؿ. $!");
      }
    }
  }
  chmod (0755, $SYSTEM::PATHS{'SCRIPTS'});
  chmod (0755, $SYSTEM::PATHS{'SOURCES'});
  chmod (0755, $SYSTEM::PATHS{'LIBRARIES_PATH'});

  &HTML::Top("(BJ 3  1)", "w˸T");
  &HTML::Description (
    "UCؿMɮפwgw˦bzAWF, ЦCLX, Hi|Ψ."
  );

  print qq~<form method="post">\n~;
  print qq~<input type="hidden" name="Category" value="Setup">\n~;
  print qq~<input type="hidden" name="Step" value="2">\n~;
  print qq~<table width="100%" border="0" cellspacing="2" cellpadding="2">\n~;
  print qq~<tr><td width="100%"><font class="title"><b>files</b></font></td><td width="20" nowrap>&nbsp;</td></tr>\n~;

  &Copying (1, "$UB::PATH", "/ascii", "$SYSTEM::PATHS{'SCRIPTS'}");
  if ($SYSTEM::PATHS{'PRIVATE'} !~ /^$SYSTEM::PATHS{'SCRIPTS'}/) {
    &Copying (1, "$UB::PATH", "/ascii/Private", "$SYSTEM::PATHS{'PRIVATE'}");
  }
  &Copying (1, "$UB::PATH", "/binary/Private", "$SYSTEM::PATHS{'PRIVATE'}");
  &Copying (1, "$UB::PATH", "/binary/Public", "$SYSTEM::PATHS{'PUBLIC'}");

  print qq~</table>\n<table width="100%" border="0" cellspacing="2" cellpadding="2">\n~;
  print qq~<tr>\n<td width="250" valign="top" nowrap>&nbsp;</td>\n~;
  print qq~<td colspan="3" valign="top" bgcolor="#EEEEEE"><input type="submit" value="U@B (stβպA) >" class="Button"> <input type="Reset" value="" class="Button"></td>\n~;
  print qq~</tr>\n</table>\n~;
  print qq~<table width="100%" border="0" cellspacing="0" cellpadding="0"><tr><td nowrap></form></td></tr></table>\n~;

  &HTML::Bottom();

  chmod (0766, "$UB::PATH/setup.cfg");

  open (SETUP, ">$UB::PATH/setup.cfg");
    print SETUP qq~package SETUP;\n\n~;
    print SETUP qq~\$SETUP::PATHS{'SCRIPTS'}    = "$SYSTEM::PATHS{'SCRIPTS'}";\n~;
    print SETUP qq~\$SETUP::PATHS{'PRIVATE'}    = "$SYSTEM::PATHS{'PRIVATE'}";\n\n~;
    print SETUP qq~\$SETUP::PATHS{'PUBLIC'}     = "$SYSTEM::PATHS{'PUBLIC'}";\n\n~;
    print SETUP qq~\$SETUP::PATHS{'VARIABLES'}  = "$SYSTEM::PATHS{'VARIABLES'}";\n\n~;

    print SETUP qq~\$SETUP::PATHS{'SOURCES'}    = "$SYSTEM::PATHS{'SOURCES'}";\n~;
    print SETUP qq~\$SETUP::PATHS{'LIBRARIES'}  = "$SYSTEM::PATHS{'LIBRARIES'}";\n~;

    print SETUP qq~\$SETUP::PATHS{'DATABASE'}   = "$SYSTEM::PATHS{'DATABASE'}";\n~;
    print SETUP qq~\$SETUP::PATHS{'BACKUPS'}    = "$SYSTEM::PATHS{'BACKUPS'}";\n~;
    print SETUP qq~\$SETUP::PATHS{'UPLOADS'}    = "$SYSTEM::PATHS{'UPLOADS'}";\n\n~;

    print SETUP qq~\$SETUP::PATHS{'THEMES'}     = "$SYSTEM::PATHS{'THEMES'}";\n~;
    print SETUP qq~\$SETUP::PATHS{'INTERFACES'} = "$SYSTEM::PATHS{'INTERFACES'}";\n~;
    print SETUP qq~\$SETUP::PATHS{'IMAGES'}     = "$SYSTEM::PATHS{'IMAGES'}";\n\n~;

    print SETUP qq~\$SETUP::FILES = [\n~;

    foreach my $FILE (@SYSTEM::FILES) {
      print SETUP "  \"$FILE\",\n";
    }

    print SETUP qq~];\n\n~;

    print SETUP qq~\@SETUP::DIRECTORIES = (\n~;

    foreach my $Path (@Paths) {
      print SETUP qq~  "$Path",\n~;
    }

    print SETUP qq~);\n\n~;

    print SETUP qq~1;~;

  close (SETUP);

  copy ("$UB::PATH/setup.cfg", "$SYSTEM::PATHS{'VARIABLES'}/setup.cfg");
  chmod (0766, "$SYSTEM::PATHS{'VARIABLES'}/setup.cfg");

  exit;
}

###############################################################################
# Copying function
sub Copying {
  my ($LEVEL, $ROOT, $FROM, $TO) = @_;

  opendir (DIRECTORY, $ROOT.$FROM);
    my @FILES = readdir (DIRECTORY);
  closedir(DIRECTORY);

  foreach my $FILE (@FILES) {
    next if ($FILE =~ /^\.\.?$/);
    if (-d $ROOT.$FROM."/".$FILE) {
      my $Space = "<img src=\"$UB::IMAGES_PATH/blank.gif\" align=\"absmiddle\" width=\"16\" height=\"16\" border=\"0\">" x $LEVEL;

      print qq~<tr><td>$Space<img src="$UB::IMAGES_PATH/folder.gif" align="absmiddle" width="16" height="16" border="0" alt=""> <font class="title">$FILE</font></td><td width="20" nowrap>~;

      (mkdir ($TO."/".$FILE, 0777) || (print qq~<img src="$UB::IMAGES_PATH/error.gif" border="0" alt="$!"></td></tr>\n~ and return)) unless ((-e $TO."/".$FILE) && (-d $TO."/".$FILE));
      chmod (0777, $TO."/".$FILE);

      print qq~&nbsp;</td></tr>\n~;

      &Copying ($LEVEL + 1, $ROOT, $FROM."/".$FILE, $TO."/".$FILE);
    } else {
      my $Space = "<img src=\"$UB::IMAGES_PATH/blank.gif\" align=\"absmiddle\" width=\"18\" height=\"14\" border=\"0\">" x $LEVEL;

      print qq~<tr><td>$Space<img src="$UB::IMAGES_PATH/file.gif" align="absmiddle" width="14" height="14" border="0" alt=""> <font class="title">$FILE</font></td><td width="20" nowrap>~;

      if (copy ($ROOT.$FROM."/".$FILE, $TO."/".$FILE)) {
        if ($FILE =~ /^([^\.]+)\.(cgi)$/i) {
          my $FILENAME = $1;
          my $FILEEXT  = $2;

          rename ($TO."/".$FILE, $TO."/".$FILENAME.".".$SYSTEM::EXT);
          $FILE = $FILENAME.".".$SYSTEM::EXT;

          my $Variables = &SCRIPT::Variables(\%SYSTEM::PATHS);
          &SCRIPT::Parse($TO."/".$FILE, $Variables);
        }

        if ($FILE =~ /\.(cgi|pl|pm)/) {
          chmod (0755, $TO."/".$FILE);
        } else {
          chmod (0766, $TO."/".$FILE);
        }
      } else {
        print qq~<img src="$UB::IMAGES_PATH/error.gif" border="0" alt="$!"></td></tr>\n~;
        next;
      }

      print qq~&nbsp;</td></tr>\n~;

      push (@SYSTEM::FILES, $FROM."/".$FILE);
    }
  }

  return 1;
}

###############################################################################
# CfgSystem function
sub CfgSystem {
  my ($ERROR) = @_;

  require "$UB::PATH/setup.cfg";

  &HTML::Top("(BJ 3  2)", "stβպA");
  &HTML::Description (
    "жJҦХܤF (<font color=\"Red\"><b>*</b></font>) .",
    "stβպA, oͤFUC~."           , $ERROR
  );

  print qq~<form method="post">\n~;
  print qq~<input type="hidden" name="Category" value="Setup">\n~;
  print qq~<input type="hidden" name="Step" value="#2">\n~;

  $SYSTEM::CGI_URL = $ENV{'SCRIPT_NAME'};
  $SYSTEM::CGI_URL =~s/\/[^\/]+$//isg;
  $SYSTEM::CGI_URL = "http://" . $ENV{'HTTP_HOST'} . $SYSTEM::CGI_URL;
  $SYSTEM::CGI_URL =~s/\/UBSetup/\/UltraBoard/ig;

  $SYSTEM::IMAGE_URL  = $SYSTEM::CGI_URL . "/Public/Images";
  $SYSTEM::UPLOAD_URL = $SYSTEM::CGI_URL . "/Public/Uploads";

  $SYSTEM::IMAGE_URL  =~s/\/cgi-bin//ig;
  $SYSTEM::UPLOAD_URL =~s/\/cgi-bin//ig;

  &HTML::Category("URL }");

  print &HTML::FORM::TextField (
    TITLE       => "CGI }",
    DESCRIPTION => "*.cgi Ҧb}. (e.g. \"http://www.yourdomain.com/cgi-bin/UltraBoard\")",
    NAME        => "CGI_URL",
    VALUE       => $UB::QUERY{'CGI_URL'} || $SYSTEM::CGI_URL,
    REQUIRED    => "1", MAXLENGTH => "", SIZE => "45"
  );

  print &HTML::FORM::TextField (
    TITLE       => "Ϥ}",
    DESCRIPTION => "ҦϤɩҦb}. (e.g. \"/home/yourdomain/UltraBoard/Public/Images\")",
    NAME        => "IMAGE_URL",
    VALUE       => $UB::QUERY{'IMAGE_URL'} || $SYSTEM::IMAGE_URL,
    REQUIRED    => "1", MAXLENGTH => "", SIZE => "45"
  );

  print &HTML::FORM::TextField (
    TITLE       => "Uploads }",
    DESCRIPTION => "ҦWɮשҦb}. (e.g. \"/home/yourdomain/UltraBoard/Public/Uploads\")",
    NAME        => "UPLOAD_URL",
    VALUE       => $UB::QUERY{'UPLOAD_URL'} || $SYSTEM::UPLOAD_URL,
    REQUIRED    => "1", MAXLENGTH => "" , SIZE => "45"
  );

  print qq~</table><p>\n~;

  $SYSTEM::ADMIN_EMAIL = $ENV{'SERVER_ADMIN'};

  if (-e "/usr/lib/sendmail") {
    $SYSTEM::SENDMAIL_PATH = "/usr/lib/sendmail";
  } elsif (-e "/usr/bin/sendmail") {
    $SYSTEM::SENDMAIL_PATH = "/usr/bin/sendmail";
  } elsif (-e "/var/qmail/bin/qmail-inject") {
    $SYSTEM::SENDMAIL_PATH = "/var/qmail/bin/qmail-inject";
  } elsif (-e "/usr/sbin/sendmail") {
    $SYSTEM::SENDMAIL_PATH = "/usr/sbin/sendmail";
  }

  if ($SYSTEM::SENDMAIL_PATH) {
    $SYSTEM::SENDMAIL    = 1;
    $SYSTEM::MAIL_SYSTEM = "SENDMAIL";
  }

  if ($SYSTEM::ADMIN_EMAIL) {
    $SYSTEM::SMTP_PATH = $SYSTEM::ADMIN_EMAIL;
    $SYSTEM::SMTP_PATH =~s/^.+\@//g;
  }

  &HTML::Category("Email ﶵ");

  print &HTML::FORM::TextField (
    TITLE       => "޲z Email",
    DESCRIPTION => "z Email, ou|Ψӱq Ultraboard HXH. (e.g. \"webmaster\@yourdomain.com\")",
    NAME        => "ADMIN_EMAIL",
    VALUE       => $UB::QUERY{'ADMIN_EMAIL'} || $SYSTEM::ADMIN_EMAIL,
    REQUIRED    => "1", MAXLENGTH => "64" , SIZE => "45"
  );

  print &HTML::FORM::Radio (
    TITLE       => "HH\\",
    DESCRIPTION => "znb Ultraboard 2000 ϥαHH\\?",
    NAME        => "SENDMAIL",
    VALUE       => [
      { VALUE => "1", TITLE => "ҥ"  },
      { VALUE => "0", TITLE => "" }
    ],
    SELECT      => $UB::QUERY{'SENDMAIL'} || $SYSTEM::SENDMAIL || 0,
    WRAP        => 0
  );

  print &HTML::FORM::Radio (
    TITLE       => "HHt",
    DESCRIPTION => "znϥέ@رHHt? pGzAϥ Windows t, ziH SMTP A.",
    NAME        => "MAIL_SYSTEM",
    VALUE       => [
      { VALUE => "SMTP"    , TITLE => "SMTP A" },
      { VALUE => "SENDMAIL", TITLE => "HH (Sendmail) {" }
    ],
    SELECT      => $UB::QUERY{'MAIL_SYSTEM'} || $SYSTEM::MAIL_SYSTEM || "SMTP"
  );

  print &HTML::FORM::TextField (
    TITLE       => "SMTP A}",
    DESCRIPTION => "zAҦb}. (e.g. \"smtp.yourdomain.com\")",
    NAME        => "SMTP_PATH",
    VALUE       => $UB::QUERY{'SMTP_PATH'} || $SYSTEM::SMTP_PATH,
    REQUIRED    => "0", MAXLENGTH => "", SIZE => "45"
  );

  print &HTML::FORM::TextField (
    TITLE       => "HH{|",
    DESCRIPTION => "HH{bA| (e.g. \"/usr/bin/sendmail\")",
    NAME        => "SENDMAIL_PATH",
    VALUE       => $UB::QUERY{'SENDMAIL_PATH'} || $SYSTEM::SENDMAIL_PATH,
    REQUIRED    => "0", MAXLENGTH => "", SIZE => "45"
  );

  print qq~</table><p>\n~;

  my $epoch = time;
  my ($lHours, $lDays) = (localtime ($epoch))[2, 3];
  my ($gHours, $gDays) = (gmtime    ($epoch))[2, 3];

  $lHours += $lDays * 24;
  $gHours += $gDays * 24;

  my $tHours = $lHours - $gHours;

  my $TZ = "GMT";
  if ($tHours < 1) {
    $TZ = abs ($tHours)." hours before GMT";
  } elsif ($tHours > 1) {
    $TZ = $tHours." hours after GMT";
  } elsif ($tHours == -1) {
    $TZ = "1 hour before GMT";
  } elsif ($tHours ==  1) {
    $TZ = "1 hour after GMT";
  }

  &HTML::Category("/ɶﶵ");

  print &HTML::FORM::TextField (
    TITLE       => "ɰϦW",
    DESCRIPTION => "zҦbmɰ. (e.g. \"GMT\", \"EST\") (Ķ: xWaϬ ROC)",
    NAME        => "TIMEZONE",
    VALUE       => $UB::QUERY{'TIMEZONE'} || $ENV{'TZ'} || $TZ,
    REQUIRED    => "1", MAXLENGTH => "32", SIZE => "45"
  );

  print &HTML::FORM::TextField (
    TITLE       => "ɮt",
    DESCRIPTION => "zҦbaϻPAɮt. (Ķ: pGAPzҦbxW,  0 Yi.)",
    NAME        => "LOCALTIME_OFFSET",
    VALUE       => $UB::QUERY{'LOCALTIME_OFFSET'} || $SYSTEM::LOCALTIME_OFFSET || "0",
    REQUIRED    => "1", MAXLENGTH => "3", SIZE => "45"
  );

  print &HTML::FORM::Radio (
    TITLE       => "榡",
    DESCRIPTION => "ܤ@ӱzw榡.",
    NAME        => "DATE_FORMAT",
    VALUE       => [
      { VALUE => "US" , TITLE => "榡 (MM-DD-YYYY)"                    },
      { VALUE => "USE", TITLE => "榡 (Month DD, YYYY)"       },
      { VALUE => "EU" , TITLE => "ڦ榡 (DD-MM-YYYY)"              },
      { VALUE => "EUE", TITLE => "ڦ榡 (DD Month, YYYY)" }
    ],
    SELECT      => $UB::QUERY{'DATE_FORMAT'} || "US",
    REQUIRED    => "0"
  );

  print &HTML::FORM::Radio (
    TITLE       => "ɶ榡",
    DESCRIPTION => "ܤ@ӱzwɶ榡.",
    NAME        => "TIME_FORMAT",
    VALUE       => [
      { VALUE => "12", TITLE => "AM/PM 榡"   },
      { VALUE => "24", TITLE => "24 pɮ榡" }
    ],
    SELECT      => $UB::QUERY{'TIME_FORMAT'} || "24",
    REQUIRED    => "0"
  );

  print qq~</table><p>\n~;
  &HTML::Category("L]w");

  print &HTML::FORM::TextField (
    TITLE       => "ȯdɨɶ",
    DESCRIPTION => "Cjh֮ɶR@ϥΪ̼ȯd? (H)",
    NAME        => "SESSIONS_EXPIRE",
    VALUE       => $UB::QUERY{'SESSIONS_EXPIRE'} || 60 * 60 * 24,
    REQUIRED    => "1", MAXLENGTH => "8", SIZE => "45"
  );

  print &HTML::FORM::TextArea (
    TITLE       => "uT",
    DESCRIPTION => "Qװuɷ|X{T.",
    NAME        => "OFFLINE_MESSAGE",
    VALUE       => $UB::QUERY{'OFFLINE_MESSAGE'} || "p, ڭ̥bw/]w UltraBoard 2000, еyA.  !!",
    REQUIRED    => "0", COLS => "30", ROWS => "3"
  );

  print &HTML::FORM::Radio (
    TITLE       => "ɮw (flock()) \\",
    DESCRIPTION => "pGzA䴩ɮw, ڭ̫ĳzҥγoӥ\\. (Windows UAn餣䴩ɮw\\)",
    NAME        => "FLOCK",
    VALUE       => [
      { VALUE => "1", TITLE => "ҥ"  },
      { VALUE => "0", TITLE => "" }
    ],
    SELECT      => $UB::QUERY{'FLOCK'} || ((eval "flock()") ? 1 : 0),
    WRAP        => 0
  );

  print &HTML::FORM::Radio (
    TITLE       => "ݪOA",
    DESCRIPTION => "pGzQDCp/C/CӤ릳h֤HyXzQװ, Nγoӿﶵ.",
    NAME        => "STATS",
    VALUE       => [
      { VALUE => "1", TITLE => "ҥ"  },
      { VALUE => "0", TITLE => "" }
    ],
    SELECT      => $UB::QUERY{'STATS'} || 0,
    WRAP        => 0
  );

  print &HTML::FORM::Radio (
    TITLE       => "O",
    DESCRIPTION => "pGzQOҦϥΪ̨ϥΰQװϪT, Nγoӿﶵ.",
    NAME        => "LOGS",
    VALUE       => [
      { VALUE => "1", TITLE => "ҥ"  },
      { VALUE => "0", TITLE => "" }
    ],
    SELECT      => $UB::QUERY{'LOGS'} || 0,
    WRAP        => 0
  );

  &HTML::Blank();

  print qq~<tr>\n<td width="250" valign="top" nowrap>&nbsp;</td>\n~;
  print qq~<td colspan="2" valign="top" bgcolor="#EEEEEE"><input type="submit" value="xs" class="Button"> <input type="Reset" value="" class="Button"></td>\n~;
  print qq~</tr>\n</table>\n~;
  print qq~<table width="100%" border="0" cellspacing="0" cellpadding="0"><tr><td nowrap></form></td></tr></table>\n~;

  &HTML::Bottom();
  exit;
}

###############################################################################
# DoCfgSystem function
sub DoCfgSystem {

  require "$UB::PATH/setup.cfg";

# =========================================================================== #
# Assign Variables
  my %FORM;

  $FORM{'DB_PATH'}           = $SETUP::PATHS{'DATABASE'};
  $FORM{'BACKUP'}            = $SETUP::PATHS{'BACKUPS'};
  $FORM{'THEME_PATH'}        = $SETUP::PATHS{'THEMES'};
  $FORM{'IMAGE_PATH'}        = $SETUP::PATHS{'IMAGES'};
  $FORM{'UPLOAD_PATH'}       = $SETUP::PATHS{'UPLOADS'};

  $FORM{'CP_URL'}            = $UB::QUERY{'CGI_URL'};
  chop ($FORM{'CP_URL'})       if $FORM{'CP_URL'} =~ /\/$/;

  $FORM{'UB_URL'}            = $UB::QUERY{'CGI_URL'};
  chop ($FORM{'UB_URL'})       if $FORM{'UB_URL'} =~ /\/$/;

  $FORM{'UPLOAD_URL'}        = $UB::QUERY{'UPLOAD_URL'};
  chop ($FORM{'UPLOAD_URL'})   if $FORM{'UPLOAD_URL'} =~ /\/$/;

  $FORM{'IMAGE_URL'}         = $UB::QUERY{'IMAGE_URL'};
  chop ($FORM{'IMAGE_URL'})    if $FORM{'IMAGE_URL'} =~ /\/$/;

  $FORM{'ADMIN_EMAIL'}       = $UB::QUERY{'ADMIN_EMAIL'};

  $FORM{'SENDMAIL'}          = $UB::QUERY{'SENDMAIL'};
  $FORM{'SENDMAIL'}          = 0 if $FORM{'SENDMAIL'} ne "1";

  $FORM{'MAIL_SYSTEM'}       = $UB::QUERY{'MAIL_SYSTEM'};
  $FORM{'MAIL_SYSTEM'}       = "SENDMAIL" if $FORM{'MAIL_SYSTEM'} ne "SMTP";

  $FORM{'SMTP_PATH'}         = $UB::QUERY{'SMTP_PATH'};

  $FORM{'SENDMAIL_PATH'}     = $UB::QUERY{'SENDMAIL_PATH'};
  $FORM{'SENDMAIL_PATH'}     =~s/\\/\//g;

  $FORM{'TIMEZONE'}          = $UB::QUERY{'TIMEZONE'};

  $FORM{'LOCALTIME_OFFSET'}  = $UB::QUERY{'LOCALTIME_OFFSET'};
  $FORM{'LOCALTIME_OFFSET'}  =~s/[^\d\-\+]//g;

  $FORM{'DATE_FORMAT'}       = $UB::QUERY{'DATE_FORMAT'};
  $FORM{'DATE_FORMAT'}       = "US" if ($FORM{'DATE_FORMAT'} ne "USE") and ($FORM{'DATE_FORMAT'} ne "EU") and ($FORM{'DATE_FORMAT'} ne "EUE");

  $FORM{'TIME_FORMAT'}       = $UB::QUERY{'TIME_FORMAT'};
  $FORM{'TIME_FORMAT'}       = "24" if $FORM{'TIME_FORMAT'} ne "12";

  $FORM{'DEFAULT_THEME'}     = "Default";

  $FORM{'SESSIONS_EXPIRE'}   = $UB::QUERY{'SESSIONS_EXPIRE'};
  $FORM{'SESSIONS_EXPIRE'}   =~s/\D//g;
  $FORM{'SESSIONS_EXPIRE'}   = 60 if $FORM{'SESSIONS_EXPIRE'} < 60;

  $FORM{'OFFLINE_MESSAGE'}   = $UB::QUERY{'OFFLINE_MESSAGE'};

  $FORM{'FLOCK'}             = $UB::QUERY{'FLOCK'};
  $FORM{'FLOCK'}             = 0 if $FORM{'FLOCK'} ne "1";

  $FORM{'STATS'}             = $UB::QUERY{'STATS'};
  $FORM{'STATS'}             = 0 if $FORM{'STATS'} ne "1";

  $FORM{'LOGS'}              = $UB::QUERY{'LOGS'};
  $FORM{'LOGS'}              = 0 if $FORM{'LOGS'} ne "1";

  %FORM = %{ &Standard::Encode (\%FORM) };

# =========================================================================== #
# Verify Variables

  # checking missing fields
  if ($UB::QUERY{'CGI_URL'}   eq "") { &CfgSystem("zѤFJ \"CGI }\".")           };
  if ($FORM{'UPLOAD_URL'}     eq "") { &CfgSystem("zѤFJ \"WǦ}\".")        };
  if ($FORM{'IMAGE_URL'}      eq "") { &CfgSystem("zѤFJ \"Ϥ}\".")        };

  # checking invalid email
  if ($FORM{'ADMIN_EMAIL'} !~ /[\.\w\-]+\\\@[\.\w\-]+\.[\.\w\-]+/)  {
    &CfgSystem("޲z Email u]t^rBƦr '_' r.");
  }

  if ($FORM{'SENDMAIL'}) {
    if ($FORM{'MAIL_SYSTEM'} eq "SMTP") {
      if ($FORM{'SMTP_PATH'}     eq "") { &CfgSystem("zѤFJ \"SMTP A}\".") };
    } else {
      if ($FORM{'SENDMAIL_PATH'} eq "") { &CfgSystem("zѤFJ \"HH{|\".") };
    }
  }

# =========================================================================== #
# Update the System.cfg

  chmod (0766, "$SETUP::PATHS{'VARIABLES'}/System.cfg");

  open(CFG, ">$SETUP::PATHS{'VARIABLES'}/System.cfg") || &UB::CGIError("Lkxstܼ. $!", "$UB::VARIABLES_PATH/System.cfg");;
    print CFG <<TEXT;
package SYSTEM;

\$SYSTEM::UB_URL           = "$FORM{'UB_URL'}";
\$SYSTEM::CP_URL           = "$FORM{'CP_URL'}";
\$SYSTEM::IMAGE_URL        = "$FORM{'IMAGE_URL'}";
\$SYSTEM::UPLOAD_URL       = "$FORM{'UPLOAD_URL'}";

\$SYSTEM::BACKUP           = "$FORM{'BACKUP'}";
\$SYSTEM::DB_PATH          = "$FORM{'DB_PATH'}";
\$SYSTEM::LOGS_PATH        = "$FORM{'DB_PATH'}/Logs";
\$SYSTEM::TEMP_PATH        = "$FORM{'DB_PATH'}/Temp";
\$SYSTEM::UPLOAD_PATH      = "$FORM{'UPLOAD_PATH'}";
\$SYSTEM::IMAGE_PATH       = "$FORM{'IMAGE_PATH'}";
\$SYSTEM::THEME_PATH       = "$FORM{'THEME_PATH'}";

\$SYSTEM::FLOCK            = "$FORM{'FLOCK'}";
\$SYSTEM::PERMISSION       = 0777;

\$SYSTEM::SENDMAIL         = "$FORM{'SENDMAIL'}";
\$SYSTEM::MAIL_SYSTEM      = "$FORM{'MAIL_SYSTEM'}";
\$SYSTEM::SMTP_PATH        = "$FORM{'SMTP_PATH'}";
\$SYSTEM::SENDMAIL_PATH    = "$FORM{'SENDMAIL_PATH'}";

\$SYSTEM::ADMIN_EMAIL      = "$FORM{'ADMIN_EMAIL'}";

\$SYSTEM::LOCALTIME_OFFSET = "$FORM{'LOCALTIME_OFFSET'}";
\$SYSTEM::TIMEZONE         = "$FORM{'TIMEZONE'}";
\$SYSTEM::DATE_FORMAT      = "$FORM{'DATE_FORMAT'}";
\$SYSTEM::TIME_FORMAT      = "$FORM{'TIME_FORMAT'}";

\$SYSTEM::STATS            = "$FORM{'STATS'}";
\$SYSTEM::LOGS             = "$FORM{'LOGS'}";
\$SYSTEM::SESSIONS_EXPIRE  = "$FORM{'SESSIONS_EXPIRE'}";
\$SYSTEM::OFFLINE_MESSAGE  = "$FORM{'OFFLINE_MESSAGE'}";

\$SYSTEM::DEFAULT_THEME    = "$FORM{'DEFAULT_THEME'}";

\%SYSTEM::MINE = (
  "application/astound"             => ["asd", "asn"],
  "application/autocad"             => ["dwg"],
  "application/futuresplash"        => ["spl"],
  "application/mac-binhex40"        => ["hqx"],
  "application/mac-compactpro"      => ["cpt"],
  "application/msword"              => ["doc"],
  "application/octet-stream"        => ["bin", "class", "dms", "dll", "exe", "lha", "lzh", "z"],
  "application/pdf"                 => ["pdf"],
  "application/postscript"          => ["ai", "eps", "ps"],
  "application/powerpoint"          => ["ppt"],
  "application/vocaltec-media-desc" => ["vmd"],
  "application/vocaltec-media-file" => ["vmf"],
  "application/x-asap"              => ["asp"],
  "application/x-cdlink"            => ["vcd"],
  "application/x-chat"              => ["chat"],
  "application/x-compress"          => ["Z"],
  "application/x-cpio"              => ["cpio"],
  "application/x-director"          => ["dcr", "dir", "dxr", "fgd"],
  "application/x-gtar"              => ["gtar"],
  "application/x-gzip"              => ["gz"],
  "application/x-hdf"               => ["hdf"],
  "application/x-install"           => ["inst"],
  "application/x-javascript"        => ["js"],
  "application/x-netcdf"            => ["cdf", "nc"],
  "application/x-sh"                => ["sh"],
  "application/x-shockwave-flash"   => ["swf"],
  "application/x-tar"               => ["tar"],
  "application/x-tardist"           => ["tardist"],
  "application/x-wais-source"       => ["src"],
  "application/x-zip-compressed"    => ["zip"],

  "audio/mpeg"                  => ["mp2", "mpga"],
  "audio/x-mpeg"                => ["mp3"],
  "audio/x-mpegurl"             => ["m3u", "mp3url"],
  "audio/tsplayer"              => ["tsi"],
  "audio/voxware"               => ["vox"],
  "audio/x-aiff"                => ["aif", "aifc", "aiff"],
  "audio/x-midi"                => ["mid"],
  "audio/x-mpeg2"               => ["mp2a", "mpa2"],
  "audio/x-pn-realaudio"        => ["ram"],
  "audio/x-pn-realaudio-plugin" => ["rpm"],
  "audio/x-realaudio"           => ["ra"],
  "audio/x-pn-realaudio"        => ["rm"],
  "audio/x-wav"                 => ["wav"],

  "image/gif"         => ["gif"],
  "image/pjpeg"        => ["jpeg", "jpg"],
  "image/jpeg"        => ["jpeg", "jpg"],
  "image/ico"         => ["ico"],
  "image/tiff"        => ["tif", "tiff"],
  "image/x-png"       => ["png"],
  "image/x-MS-bmp"    => ["bmp"],
  "image/x-freehand"  => ["fh4", "fh5", "fh7", "fh", "fhc"],
  "image/x-photo-cd"  => ["pcd"],
  "image/x-rgb"       => ["rgb"],

  "text/html"       => ["htm", "html", "stm", "shtml"],
  "text/plain"      => ["txt"],
  "text/richtext"   => ["rtx"],
  "text/warez-info" => ["nfo"],
  "text/x-sgml"     => ["sgm", "sgml"],

  "video/mpeg"        => ["mpe", "mpeg", "mpg"],
  "video/quicktime"   => ["mov", "qt"],
  "video/vivo"        => ["viv", "vivo"],
  "video/x-msvideo"   => ["avi"],
  "video/x-sgi-movie" => ["movie", "mv"],

  "x-conference/x-cooltalk" => ["ice"],

  "x-world/x-vrml" => ["vrml", "wrl"]
);

1;
TEXT
  close (CFG);

  &HTML::Top("(BJ 3  2)", "stβպA");
  &HTML::Description (
    "tβպAwgxs."
  );

  print qq~<form method="post">\n~;
  print qq~<input type="hidden" name="Category" value="Setup">\n~;
  print qq~<input type="hidden" name="Step" value="3">\n~;
  print qq~<table width="100%" border="0" cellspacing="2" cellpadding="2">\n~;

  print qq~<tr>\n<td width="250" valign="top" nowrap>&nbsp;</td>\n~;
  print qq~<td valign="top" bgcolor="#EEEEEE"><input type="submit" value="U@B (إߺ޲z) >" class="Button"> <input type="Reset" value="" class="Button"></td>\n~;
  print qq~</tr>\n</table>\n~;
  print qq~<table width="100%" border="0" cellspacing="0" cellpadding="0"><tr><td nowrap></form></td></tr></table>\n~;

  &HTML::Bottom();
  exit;
}

###############################################################################
# CreateAdministrator function
sub CreateAdministrator {
  my ($ERROR) = @_;

  &HTML::Top("(BJ 3  3)", "إߺ޲z");
  &HTML::Description (
    "жJҦХܤF (<font color=\"Red\"><b>*</b></font>) .",
    "إߺ޲zƮ, oͤFUC~."    , $ERROR
  );

  print qq~<form method="post">\n~;
  print qq~<input type="hidden" name="Category" value="Setup">\n~;
  print qq~<input type="hidden" name="Step" value="#3">\n~;
  print qq~<table width="100%" border="0" cellspacing="2" cellpadding="2">\n~;

  print &HTML::FORM::TextField (
    TITLE       => "ϥΪ̦W",
    DESCRIPTION => "޲zϥΪ̦W",
    NAME        => "FORM_USERNAME",
    VALUE       => $UB::QUERY{'FORM_USERNAME'},
    REQUIRED    => "1", MAXLENGTH => "", SIZE => "45"
  );

  print &HTML::FORM::PasswordField (
    TITLE       => "KX",
    DESCRIPTION => "޲zKX",
    NAME        => "FORM_PASSWORD",
    VALUE       => $UB::QUERY{'FORM_PASSWORD'},
    REQUIRED    => "1", MAXLENGTH => "", SIZE => "45"
  );

  print &HTML::FORM::PasswordField (
    TITLE       => "T{KX",
    DESCRIPTION => "ЦAJ@޲zKX",
    NAME        => "FORM_VERIFY_PASSWORD",
    VALUE       => $UB::QUERY{'FORM_VERIFY_PASSWORD'},
    REQUIRED    => "1", MAXLENGTH => "", SIZE => "45"
  );

  print qq~<tr>\n~;
  print qq~<td width="150" valign="top" nowrap><font class="title"><b>ϥΪ̸s</b></font></td>\n~;
  print qq~<td width="60%" valign="top"><font class="title">w]ϥΪ̸s</font></td>\n~;
  print qq~<td width="40%" valign="top">&nbsp;</td>\n~;
  print qq~</tr>\n~;

  print &HTML::FORM::TextField (
    TITLE       => "ʺ",
    DESCRIPTION => "zʺ",
    NAME        => "FORM_NICKNAME",
    VALUE       => $UB::QUERY{'FORM_NICKNAME'},
    REQUIRED    => "1", MAXLENGTH => "", SIZE => "45"
  );

  print &HTML::FORM::TextField (
    TITLE       => "Email",
    DESCRIPTION => "z Email",
    NAME        => "FORM_EMAIL",
    VALUE       => $UB::QUERY{'FORM_EMAIL'},
    REQUIRED    => "1", MAXLENGTH => "", SIZE => "45"
  );

  print qq~<tr>\n<td width="250" valign="top" nowrap>&nbsp;</td>\n~;
  print qq~<td valign="top" bgcolor="#EEEEEE"><input type="submit" value="إ߸" class="Button"> <input type="Reset" value="" class="Button"></td>\n~;
  print qq~</tr>\n</table>\n~;
  print qq~<table width="100%" border="0" cellspacing="0" cellpadding="0"><tr><td nowrap></form></td></tr></table>\n~;

  &HTML::Bottom();
  exit;
}

###############################################################################
# DoCreateAdministrator function
sub DoCreateAdministrator {

  require "$UB::PATH/setup.cfg";

  unless (my $Return = do "$SETUP::PATHS{'VARIABLES'}/System.cfg") {
    &UB::CGIError("Couldn't parse system variables. $@", "$SETUP::PATHS{'VARIABLES'}/System.cfg") if ($@);
    &UB::CGIError("Couldn't do system variables. $_"   , "$SETUP::PATHS{'VARIABLES'}/System.cfg") unless (defined $Return);
    &UB::CGIError("Couldn't run system variables."     , "$SETUP::PATHS{'VARIABLES'}/System.cfg") unless ($Return);
  }

  eval { require "$SETUP::PATHS{'LIBRARIES'}/Standard.lib.pl" } || &UB::CGIError("Can't load standard libraries for setup wizard. $@", "$SETUP::PATHS{'LIBRARIES'}/Standard.lib.pl");
  eval { require "$SETUP::PATHS{'LIBRARIES'}/Database.lib.pl" } || &UB::CGIError("Can't load database libraries for setup wizard. $@", "$SETUP::PATHS{'LIBRARIES'}/Database.lib.pl");

  $UB::SOURCES_PATH    = $SETUP::PATHS{'SOURCES'};
  $UB::VARIABLES_PATH  = $SETUP::PATHS{'VARIABLES'};
  $UB::LIBRARIES_PATH  = $SETUP::PATHS{'LIBRARIES'};
  $UB::INTERFACES_PATH = $SETUP::PATHS{'INTERFACES'};

# =========================================================================== #
# Verify Variables

  # checking missing fields
  if ($UB::QUERY{'FORM_USERNAME'}        eq "") { &CreateAdministrator("zѤFJ \"ϥΪ̦W\"."          ) };
  if ($UB::QUERY{'FORM_NICKNAME'}        eq "") { &CreateAdministrator("zѤFJ \"ʺ\"."          ) };
  if ($UB::QUERY{'FORM_PASSWORD'}        eq "") { &CreateAdministrator("zѤFJ \"KX\"."          ) };
  if ($UB::QUERY{'FORM_VERIFY_PASSWORD'} eq "") { &CreateAdministrator("zѤFJ \"T{KX\"."  ) };
  if ($UB::QUERY{'FORM_EMAIL'}           eq "") { &CreateAdministrator("zѤFJ \"Email\"."             ) };

  # checking invalid username
  if (
      ($UB::QUERY{'FORM_USERNAME'} =~ /\W/)       ||
      (length ($UB::QUERY{'FORM_USERNAME'}) > 16) ||
      (length ($UB::QUERY{'FORM_USERNAME'}) <  2)
     )
  {
    &CreateAdministrator("ϥΪ̦W٥uϥέ^rBƦr\"_\", åB 2  16 Ӧr.");
  }

  # checking invalid nickname
  if (
      ($UB::QUERY{'FORM_NICKNAME'} !~ /^[A-Za-z0-9_-\s]+$/) ||
      (length ($UB::QUERY{'FORM_NICKNAME'}) > 32)           ||
      (length ($UB::QUERY{'FORM_NICKNAME'}) <  2)
     )
  {
    &CreateAdministrator("ʺ٥ 2  32 Ӧr.");
  }

  # checking invalid password
  if (
      ($UB::QUERY{'FORM_PASSWORD'} !~ /^[A-Za-z0-9]+$/) ||
      (length ($UB::QUERY{'FORM_PASSWORD'}) > 16)       ||
      (length ($UB::QUERY{'FORM_PASSWORD'}) <  4)
     )
  {
    &CreateAdministrator("KXuϥέ^rμƦr, åB 4  16 Ӧr.");
  }

  # checking unmatch password
  if ($UB::QUERY{'FORM_PASSWORD'} ne $UB::QUERY{'FORM_VERIFY_PASSWORD'})  {
    &CreateAdministrator("zĤGJKXPĤ@JŦX.");
  }

  # checking invalid email
  if (
    ($UB::QUERY{'FORM_EMAIL'} !~ /[\.\w\-]+\@[\.\w\-]+\.[\.\w\-]+/) ||
    (length ($UB::QUERY{'FORM_EMAIL'}) > 64)
  ) {
    &CreateAdministrator("Email uϥέ^rBƦr\"_\", åB֩ 64 Ӧr.");
  }

  (
    my $ID = &DB::Insert (
      TABLE  => "Groups",
      VALUES => {
        TITLE       => "w]ϥΪ̸s",
        DESCRIPTION => "UltraBoard 2000 w]ϥΪ̸s."
      }
    )
  ) || &UB::CGIError($DB::Error);

# =========================================================================== #
# Assign Variables

  my %FORM;

  $FORM{'USERNAME'}   = lc ($UB::QUERY{'FORM_USERNAME'});

  my $Password        = $UB::QUERY{'FORM_PASSWORD'};
  $FORM{'PASSWORD'}   = &Standard::CryptPassword($FORM{'USERNAME'}, $Password);

  $FORM{'NICKNAME'}   = $UB::QUERY{'FORM_NICKNAME'};
  $FORM{'NICKNAME'}   = &Standard::EncodeHTML($FORM{'NICKNAME'});

  $FORM{'EMAIL'}      = lc ($UB::QUERY{'FORM_EMAIL'});

  $FORM{'LEVEL'}      = 100;                    # id of administrator member level

  $FORM{'LEVEL_TEXT'} = "Administrator";

  $FORM{'GROUP'}      = $ID;

  $FORM{'GROUP_TEXT'} = "Default Member Group";

  $FORM{'STATUS'}     = 50;                   # id of activated status

  $FORM{'REGISTERED_SECOND'} = time;

  $FORM{'REGISTERED_DATE'}   = &Standard::ConvertEpochToDate($FORM{'REGISTERED_SECOND'});
  $FORM{'REGISTERED_TIME'}   = &Standard::ConvertEpochToTime($FORM{'REGISTERED_SECOND'});

  $FORM{'HIDE_EMAIL'} = 1;
  $FORM{'APROVED'}    = 1;

  $FORM{'IP'}         = $ENV{'REMOTE_ADDR'};

  $FORM{'HOST'}       = $ENV{'REMOTE_HOST'};

# =========================================================================== #
# Add Member to Database

  ( # insert member information into accounts database
    &DB::Insert (
      TABLE  => "Accounts",
      VALUES => \%FORM
    )
  ) || &UB::CGIError($DB::Error);

  ( # insert member information into profile database
    &DB::Insert (
      TABLE  => "Profiles",
      VALUES => \%FORM
    )
  ) || &UB::CGIError($DB::Error);

  (
    &DB::Update (
      TABLE   => "Groups",
      VALUES  => {
        TOTAL_MEMBERS => "++\${TOTAL_MEMBERS}"
      },
      KEY     => $ID
    )
  ) || &UB::CGIError($DB::Error);

  &Standard::InsertToList($SETUP::PATHS{'DATABASE'}."/accounts.username", $FORM{'USERNAME'});
  &Standard::InsertToList($SETUP::PATHS{'DATABASE'}."/accounts.nickname", $FORM{'NICKNAME'});
  &Standard::InsertToList($SETUP::PATHS{'DATABASE'}."/accounts.email"   , $FORM{'EMAIL'}   );

  &Conclusion();
}

###############################################################################
# Conclusion function
sub Conclusion {
  require "setup.cfg";

  unless (my $Return = do "$SETUP::PATHS{'VARIABLES'}/System.cfg") {
    &UB::CGIError("Couldn't parse system variables. $@", "$SETUP::PATHS{'VARIABLES'}/System.cfg") if ($@);
    &UB::CGIError("Couldn't do system variables. $_"   , "$SETUP::PATHS{'VARIABLES'}/System.cfg") unless (defined $Return);
    &UB::CGIError("Couldn't run system variables."     , "$SETUP::PATHS{'VARIABLES'}/System.cfg") unless ($Return);
  }

  &HTML::Top("()", "߱z!!");

  print<<HTML;
<font class="title">
zwgTaw˧÷ǳƶiJ <a href=\"$SYSTEM::CP_URL/Panel.$SYSTEM::EXT\" target="_blank">UltraBoard x (Control Panel)</a><p>

pGzQN UltraBoard 1.6x ഫ UltraBoard 2000 ƥƮ榡, ЫU <a href="Setup.$SYSTEM::EXT?Category=Upgrade">o</a>Ӥɯ.

HUBJ|az]wzݪO.
<ol type="1">
<li><b>@޲z</b> > <b>s@ﶵ</b>.<br>
  o̬OݪO@ﶵ, rLoa.<p>
<li><b>@޲z</b> > <b>s~[ﶵ</b>.<br>
  o̬Oܥ~[BCBrBϥܵa.<p>
<li><b>@ﶵ</b> > <b>ק޲z</b>.<br>
  o̥iHzקzӤH.<p>
<li><b>ݪO޲z</b> > <b>إ߷s</b>.<br>
  pGݭn, ziHإߤ@ӷs. äO, pGzQצUؼsxDD, zӫإߦUؤP.<p>
<li><b>ݪO޲z</b> > <b>إ߷sݪO</b>.<br>
  o̬Oإ߷sݪOa.<p>
<li><b>@޲z</b> > <b>stβպA</b>.<br>
  bzQװϤw`B@, zi|ݭnק@Ƿ]wna.  z]iHbo̾ױڵӤ᪺D/IP.<p>
<li><b>uc</b> > <b>sĶGDD</b>.<br>
  ]wإH, Oon@ӧGDDӽsĶ!! _hzNLkϥ UltraBoard.
</ol>

{bz UltraBoard wg]w! s} <a href="$SYSTEM::UB_URL/UltraBoard.$SYSTEM::EXT" target="_blank">UltraBoard.$SYSTEM::EXT</a> եάݬݧa.<p>
pGzuw UltraBoard 2000, еڭ̤@I <a href="http://cgi.resourceindex.com/detail/03326.html" target="_blank"></a> or <a href="http://cgi.resourceindex.com/detail/03326.html" target="_blank">dU@ǫĳ</a>LϥΪ̾\\Ū.
<blockquote>
<form method=POST action="http://cgi-resources.com/rate/index.cgi" target="_blank">
  <input type=hidden name="referer" value="http://cgi-resources.com/">
  <input type=hidden name="link_code" value="03326">
  <input type=hidden name="category_name" value="Programs and Scripts/Perl/Bulletin Board Message Systems/">
  <input type=hidden name="link_name" value="UltraBoard">
  <b>{:</b><br>
  <select name="rating" style="font-family : Verdana; font-size : 9pt;">
    <option selected>--
    <option>10
    <option>9
    <option>8
    <option>7
    <option>6
    <option>5
    <option>4
    <option>3
    <option>2
    <option>1
</select> <input type="Submit" value="eX" style="font-family : Verdana; font-size : 9pt;">
</blockquote>
<p>

  <b>Copyright Notice (vŧi)</b><br>
  This program is being distributed as shareware. It may be used and modified free for personal, government or non-profit. Any commercial use must be registered. However, modified versions cannot be sold or distributed. You cannot alter the copyright and "powered by" notices throughout the scripts. These notices must be clearly visible to the end users.
  <p>
  <b>Usage Disclaimer</b><br>
  THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
</font>
HTML

  print qq~</table>\n~;
  &HTML::Bottom();

  open (LOCK, ">$UB::PATH/setup.lock");
    print LOCK time;
  close(LOCK);

  exit;
}

###############################################################################
package Uninstall;

use File::Path;

###############################################################################
# Uninstall function
sub Uninstall {
  require "$UB::PATH/setup.cfg";

  &HTML::Top("( UltraBoard 2000)", " UltraBoard 2000");
  &HTML::Description (
    "UCؿNQR."
  );

  print qq~<form method="post">\n~;
  print qq~<input type="hidden" name="Category" value="Uninstall">\n~;
  print qq~<input type="hidden" name="Action" value="Process">\n~;

  print qq~<table width="100%" border="0" cellspacing="2" cellpadding="2">\n~;
  print qq~<tr><td width="100%"><font class="title"><b>ؿ</b></font></td></tr>\n~;

  if (scalar (@SETUP::DIRECTORIES) > 0) {
    foreach my $PATH (@SETUP::DIRECTORIES) {
      print qq~<tr><td><img src="$UB::IMAGES_PATH/folder.gif" align="absmiddle" width="16" height="16" border="0" alt=""> <font class="title">$PATH</font></td></tr>\n~;
    }
  } else {
    foreach my $PATH (values %SETUP::PATHS) {
      print qq~<tr><td><img src="$UB::IMAGES_PATH/folder.gif" align="absmiddle" width="16" height="16" border="0" alt=""> <font class="title">$PATH</font></td></tr>\n~;
    }
  }

  print qq~</table>\n<table width="100%" border="0" cellspacing="2" cellpadding="2">\n~;
  print qq~<tr>\n<td width="250" valign="top" nowrap>&nbsp;</td>\n~;
  print qq~<td colspan="3" valign="top" bgcolor="#EEEEEE"><input type="submit" value="Uninstall" class="Button"> <input type="Reset" value="Cancel" class="Button"></td>\n~;
  print qq~</tr>\n</table>\n~;
  print qq~<table width="100%" border="0" cellspacing="0" cellpadding="0"><tr><td nowrap></form></td></tr></table>\n~;

  &HTML::Bottom();

  exit;
}

###############################################################################
# Process function
sub Process {
  require "$UB::PATH/setup.cfg";

  &HTML::Top("(UltraBoard 2000 Uninstall)", "UltraBoard 2000 Uninstall");
  &HTML::Description (
    "Following directories were removed."
  );

  print qq~<table width="100%" border="0" cellspacing="2" cellpadding="2">\n~;

  if (scalar (@SETUP::DIRECTORIES) > 0) {
    foreach my $PATH (@SETUP::DIRECTORIES) {
      print qq~<tr><td width="100%"><font class="title"><b>$PATH</b></font></td><td width="20" nowrap>~;
      if (rmtree($PATH)) {
        print qq~&nbsp;~;
      } else {
        print qq~<img src="$UB::IMAGES_PATH/error.gif" border="0" alt="$!">~;
      }
      print qq~</td></tr>~;
    }
  } else {
    foreach my $PATH (values %SETUP::PATHS) {
      print qq~<tr><td width="100%"><font class="title"><b>$PATH</b></font></td><td width="20" nowrap>~;
      if (rmtree($PATH)) {
        print qq~&nbsp;~;
      } else {
        print qq~<img src="$UB::IMAGES_PATH/error.gif" border="0" alt="$!">~;
      }
      print qq~</td></tr>~;
    }
  }

  print qq~</table>\n~;

  &HTML::Bottom();

  open (LOCK, ">$UB::PATH/setup.lock");
    print LOCK time;
  close(LOCK);

  exit;
}

###############################################################################
package Upgrade;

use File::Copy;

###############################################################################
# Upgrade function
sub Upgrade {
  my ($ERROR) = @_;

  require "$UB::PATH/setup.cfg";

  &HTML::Top("(UltraBoard 2000 Upgrade)", "Upgrade Information");
  &HTML::Description (
    "жJҦХܤF (<font color=\"Red\"><b>*</b></font>) .",
    ", oͤFUC~ during upgrading files."                   , $ERROR
  );

  print qq~<form method="post">\n~;
  print qq~<input type="hidden" name="Category" value="Upgrade">\n~;
  print qq~<input type="hidden" name="Action" value="Process">\n~;

  &HTML::Category("Absolute Path");

  print &HTML::FORM::TextField (
    TITLE       => "Backup Directory",
    DESCRIPTION => "the absolute path of directory where you want to all the converted files to be save (e.g. \"/home/yourdomain/cgi-bin/UltraBoard/Backups\")",
    NAME        => "BACKUPS_PATH",
    VALUE       => $UB::QUERY{'BACKUPS_PATH'} || $SETUP::PATHS{'BACKUPS'},
    REQUIRED    => "1", MAXLENGTH => "", SIZE => "45"
  );

  &HTML::Blank();

  print &HTML::FORM::TextField (
    TITLE       => "Old Database Directory",
    DESCRIPTION => "the absolute path of directory where your old (1.6x) data files located. (e.g. \"/home/yourdomain/cgi-bin/OldUltraBoard/UBData\")",
    NAME        => "OLD_DB_PATH",
    VALUE       => $UB::QUERY{'OLD_DB_PATH'},
    REQUIRED    => "1", MAXLENGTH => "", SIZE => "45"
  );

  print &HTML::FORM::TextField (
    TITLE       => "Old Member Database Directory",
    DESCRIPTION => "the absolute path of directory where your old (1.6x) member data files located. (e.g. \"/home/yourdomain/cgi-bin/OldUltraBoard/UBData/Members\")",
    NAME        => "OLD_MEMBER_PATH",
    VALUE       => $UB::QUERY{'OLD_MEMBER_PATH'},
    REQUIRED    => "1", MAXLENGTH => "", SIZE => "45"
  );

  &HTML::Category("Administrator");

  print &HTML::FORM::TextField (
    TITLE       => "Administrator Username",
    DESCRIPTION => "what is the administrator username in ultraboard 1.6x database? this will be the administrator in UltraBoard 2000.",
    NAME        => "ADMIN_USERNAME",
    VALUE       => $UB::QUERY{'ADMIN_USERNAME'},
    REQUIRED    => "1", MAXLENGTH => "", SIZE => "45"
  );

  &HTML::Blank();

  print qq~<tr>\n<td width="250" valign="top" nowrap>&nbsp;</td>\n~;
  print qq~<td colspan="2" valign="top" bgcolor="#EEEEEE"><input type="submit" value="Upgrade" class="Button"> <input type="Reset" value="Cancel" class="Button"></td>\n~;
  print qq~</tr>\n</table>\n~;
  print qq~<table width="100%" border="0" cellspacing="0" cellpadding="0"><tr><td nowrap></form></td></tr></table>\n~;

  &HTML::Bottom();

  exit;
}

###############################################################################
# Process function
sub Process {
  $UB::QUERY{'BACKUPS_PATH'} =~ s/\\/\//g;
  $UB::QUERY{'BACKUPS_PATH'} =~ s/\/$//g;
  $UB::QUERY{'OLD_DB_PATH'} =~ s/\\/\//g;
  $UB::QUERY{'OLD_DB_PATH'} =~ s/\/$//g;
  $UB::QUERY{'OLD_MEMBER_PATH'} =~ s/\\/\//g;
  $UB::QUERY{'OLD_MEMBER_PATH'} =~ s/\/$//g;

  unless (-e $UB::QUERY{'BACKUPS_PATH'}) {
    &Upgrade("Can't find the $UB::QUERY{'BACKUPS_PATH'}. $!");
  }

  unless (-e $UB::QUERY{'OLD_DB_PATH'}) {
    &Upgrade("Can't find the $UB::QUERY{'OLD_DB_PATH'}. $!");
  }

  unless (-e $UB::QUERY{'OLD_MEMBER_PATH'}) {
    &Upgrade("Can't find the $UB::QUERY{'OLD_MEMBER_PATH'}. $!");
  }

  unless ($UB::QUERY{'ADMIN_USERNAME'}) {
    &Upgrade("You have to fill the administrator username.");
  }

  my $TIME = time;

  my $OLD_DB_PATH      = $UB::QUERY{'OLD_DB_PATH'};
  my $OLD_MEMBERS_PATH = $UB::QUERY{'OLD_MEMBER_PATH'};

  print "<font size=\"2\">\n";
  print "- Begin backup UltraBoard 1.6x to UltraBoard 2000 format<p>\n\n";

  print "- Creating a directory for backup 'UB2K-$TIME'... ";
  my $NEW_BACKUP_DIR = $UB::QUERY{'BACKUPS_PATH'}."/UB2K-$TIME";
  mkdir ($NEW_BACKUP_DIR, 0777) || (print "error: $!<p>\n\n" and exit);
  chmod (0777, $NEW_BACKUP_DIR);
  print "done.<p>\n\n";

  mkdir ("$NEW_BACKUP_DIR/Password", 0777);
  mkdir ("$NEW_BACKUP_DIR/Sessions", 0777);

  opendir (DIRECTORY, $UB::PATH."/ascii/Private/Database");
    my @FILES = readdir (DIRECTORY);
  closedir(DIRECTORY);

  foreach my $FILE (@FILES) {
    next if $FILE =~ /^\.\.?$/;
    unless (-d $UB::PATH."/ascii/Private/Database/".$FILE) {
      copy ($UB::PATH."/ascii/Private/Database/$FILE", "$NEW_BACKUP_DIR/$FILE");
    }
  }

  # MEMBER GROUPS #############################################################

  print "- <b>Backing up the member groups data...</b><br>\n";

  print "- - Creating a directory for member groups... ";
  mkdir ($NEW_BACKUP_DIR."/Groups", 0777) || (print "error: $!<br>\n" and exit);
  chmod (0777, $NEW_BACKUP_DIR."/Groups");
  print "done.<br>\n";

  print "- - Creating a file 'Groups.export' for UltraBoard 2000... ";
  open (GROUPS, ">$NEW_BACKUP_DIR/Groups/Groups.export") || (print "error: $!<br>\n" and exit);
    print GROUPS "ID|TITLE|DESCRIPTION|MAX_FILE_SIZE|TOTAL_MEMBERS\n";
  close(GROUPS);
  print "done.<br>\n";

  print "- - Opening the file 'Group.db' from UltraBoard 1.6x... ";
  open(GROUPS, "$OLD_MEMBERS_PATH/Groups.db") || (print "error: $!<br>\n" and exit);
    my @OLD_GROUPS = <GROUPS>;
  close(GROUPS);
  chomp(@OLD_GROUPS);
  print "done.<br>\n";

  my %OLD_GROUP_ID_TO_NEW; # for converting member account use
  my %OLD_ACCOUNTS;        # for converting member account use

  # [FORMAT OF GROUPS]
  # UB 1.6X: ID, NAME
  # UB 2000: ID, TITLE, DESCRIPTION, MAX_FILE_SIZE, TOTAL_MEMBERS
  my $Counter = 0;
  for (my $i = 0; $i <= $#OLD_GROUPS; $i++) {
    my @OLD_GROUP = &Upgrade_16X::DecodeDBOutput($OLD_GROUPS[$i]);
       @OLD_GROUP = &Upgrade_16X::DecodeHTMLTags(@OLD_GROUP);

    print "- - - Opening the file '$OLD_GROUP[0].grp' from UltraBoard 1.6x... ";
    open(GROUP,"$OLD_MEMBERS_PATH/$OLD_GROUP[0].grp") || (print "error: $!\n" and exit);
      my @OLD_USERNAMES = <GROUP>; # TOTAL_MEMBERS
    close(GROUP);
    chomp(@OLD_USERNAMES);
    shift(@OLD_USERNAMES);
    print "done.<br>\n";

    my %NEW_FORM;
    $NEW_FORM{'TITLE'}         = &Upgrade_2000_Standard::EncodeHTML($OLD_GROUP[1]);
    $NEW_FORM{'TOTAL_MEMBERS'} = scalar( @OLD_USERNAMES ) || 0;

    my $Export = &Upgrade_2000_DB::EncodeData (
      ++$Counter,
      $NEW_FORM{'TITLE'},
      "", "0",
      $NEW_FORM{'TOTAL_MEMBERS'}
    );

    $OLD_GROUP_ID_TO_NEW{ $OLD_GROUP[0] } = $Counter;
    $OLD_ACCOUNTS       { $OLD_GROUP[0] } = \@OLD_USERNAMES;

    print "- - - Appending the information to 'Groups.export' for UltraBoard 2000... ";
    open (GROUPS, ">>$NEW_BACKUP_DIR/Groups/Groups.export") || (print "error: $!\n" and exit);
      print GROUPS $Counter."|~|".$Export."\n";
    close(GROUPS);
    print "done.<p>\n";
  }

  print "- - Creating a file 'Groups.counter' for UltraBoard 2000... ";
  open (GROUPS, ">$NEW_BACKUP_DIR/Groups/Groups.counter") || (print "error: $!\n" and exit);
    print GROUPS $Counter;
  close(GROUPS);
  print "done.<p>\n";

  print "\n";

  # MEMBER ACCOUNTS ###########################################################
  print "- <b>Backing up the member account data...</b><br>\n";

  print "- - Creating a directory for member accounts... ";
  mkdir ($NEW_BACKUP_DIR."/Accounts", 0777) || (print "error: $!\n" and exit);
  chmod (0777, $NEW_BACKUP_DIR."/Accounts");
  print "done.<br>\n";

  print "- - Creating a file 'Accounts.export' for UltraBoard 2000... ";
  open (ACCOUNTS, ">$NEW_BACKUP_DIR/Accounts/Accounts.export") || (print "error: $!<br>\n" and exit);
    print ACCOUNTS "USERNAME|PASSWORD|STATUS|LEVEL|GROUP|LEVEL_TEXT|GROUP_TEXT|NICKNAME|EMAIL|TOTAL_POSTS|REGISTERED_SECOND|REGISTERED_DATE|REGISTERED_TIME|LAST_POST_SECOND|LAST_POST_DATE|LAST_POST_TIME|LAST_LOGIN_SECOND|LAST_LOGIN_DATE|LAST_LOGIN_TIME|HOST|IP|HIDE_EMAIL|APROVED\n";
  close(ACCOUNTS);
  print "done.<br>\n";

  print "- - Creating a directory for member profile... ";
  mkdir ($NEW_BACKUP_DIR."/Profiles", 0777) || (print "error: $!<br>\n" and exit);
  chmod (0777, $NEW_BACKUP_DIR."/Profiles");
  print "done.<br>\n";

  print "- - Creating a file 'Profiles.export' for UltraBoard 2000... ";
  open (PROFILES, ">$NEW_BACKUP_DIR/Profiles/Profiles.export") || (print "error: $!<br>\n" and exit);
    print PROFILES "USERNAME|HOMEPAGE|LOCATION|OCCUPATION|INTEREST|ICQ|AGE|COMMENTS|SIGNATURE|PHOTO\n";
  close(PROFILES);
  print "done.<br>\n";

  print "- - Creating a file 'accounts.username' for UltraBoard 2000... ";
  open (USERNAME, ">$NEW_BACKUP_DIR/accounts.username") || (print "error: $!<br>\n" and exit);
  close(USERNAME);
  print "done.<br>\n";

  print "- - Creating a file 'accounts.nickname' for UltraBoard 2000... ";
  open (NICKNAME, ">$NEW_BACKUP_DIR/accounts.nickname") || (print "error: $!<br>\n" and exit);
  close(NICKNAME);
  print "done.<br>\n";

  print "- - Creating a file 'accounts.email' for UltraBoard 2000... ";
  open (EMAIL, ">$NEW_BACKUP_DIR/accounts.email") || (print "error: $!<br>\n" and exit);
  close(EMAIL);
  print "done.<p>\n\n";

  # [FORMAT OF ACCOUNTS]
  # UB 1.6X: USERNAME, NICKNAME, PASSWORD, GROUP, EMAIL, TOTAL_POSTS, STATUS,
  #          LAST_POST_SECOND, HOEMPAGE, LOCATION, AGE, OCCUPATION, INTERESTS,
  #          ICQ, COMMENTS, SIGNATURE, REGISTERED_SECOND, SHOW_EMAIL, I
  # UB 2000: USERNAME, PASSWORD, STATUS, LEVEL, GROUP, LEVEL_TEXT, GROUP_TEXT,
  #          NICKNAME, EMAIL, TOTAL_POSTS, REGISTERED_SECOND, REGISTERED_DATE,
  #          REGISTERED_TIME, LAST_POST_SECOND, LAST_POST_DATE, LAST_POST_TIME,
  #          LAST_LOGIN_SECOND, LAST_LOGIN_DATE, LAST_LOGIN_TIME, HOST, IP,
  #          HIDE_EMAIL, APROVED
  # [FORMAT OF PROFILES]
  # UB 2000: USERNAME, HOMEPAGE, LOCATION, OCCUPATION, INTEREST, ICQ, AGE,
  #          COMMENTS, SIGNATURE, PHOTO
  $Counter = 0;
  foreach my $OLD_GROUP (keys %OLD_ACCOUNTS) {
    foreach my $OLD_USERNAME ( @{ $OLD_ACCOUNTS{ $OLD_GROUP } } ) {
      print "- - Converting '$OLD_USERNAME.info' account... ";
      (my @OLD_ACCOUNT = &Upgrade_16X::GetMemberData($OLD_MEMBERS_PATH, $OLD_USERNAME)) || (print "error: $!... " and exit);

      my %NEW_FORM;
      $NEW_FORM{'USERNAME'}          = lc ($OLD_ACCOUNT[0]);
      $NEW_FORM{'NICKNAME'}          = &Upgrade_2000_Standard::EncodeHTML($OLD_ACCOUNT[1]);
      $NEW_FORM{'PASSWORD'}          = $OLD_ACCOUNT[2];
      $NEW_FORM{'GROUP'}             = $OLD_GROUP_ID_TO_NEW{ $OLD_ACCOUNT[3] };
      $NEW_FORM{'LEVEL'}             = 30;
      $NEW_FORM{'EMAIL'}             = lc ($OLD_ACCOUNT[4]);
      $NEW_FORM{'TOTAL_POSTS'}       = $OLD_ACCOUNT[5] || 0;
      $NEW_FORM{'STATUS'}            = ($OLD_ACCOUNT[6] eq "Activate") ? 50 : 30;
      $NEW_FORM{'LAST_POST_SECOND'}  = $OLD_ACCOUNT[7];
      $NEW_FORM{'HOEMPAGE'}          = &Upgrade_2000_Standard::EncodeHTML($OLD_ACCOUNT[8]);
      $NEW_FORM{'LOCATION'}          = &Upgrade_2000_Standard::EncodeHTML($OLD_ACCOUNT[9]);
      $NEW_FORM{'AGE'}               = &Upgrade_2000_Standard::EncodeHTML($OLD_ACCOUNT[10]);
      $NEW_FORM{'OCCUPATION'}        = &Upgrade_2000_Standard::EncodeHTML($OLD_ACCOUNT[11]);
      $NEW_FORM{'INTERESTS'}         = &Upgrade_2000_Standard::EncodeHTML($OLD_ACCOUNT[12]);
      $NEW_FORM{'ICQ'}               = &Upgrade_2000_Standard::EncodeHTML($OLD_ACCOUNT[13]);
      $NEW_FORM{'COMMENTS'}          = &Upgrade_2000_Standard::EncodeHTML($OLD_ACCOUNT[14]);
      $NEW_FORM{'SIGNATURE'}         = &Upgrade_2000_Standard::EncodeHTML($OLD_ACCOUNT[15]);
      $NEW_FORM{'REGISTERED_SECOND'} = $OLD_ACCOUNT[16];
      $NEW_FORM{'HIDE_EMAIL'}        = ($OLD_ACCOUNT[17] eq "on") ? 0 : 1;

      if ($NEW_FORM{'USERNAME'} eq lc ($UB::QUERY{'ADMIN_USERNAME'})) {
        $NEW_FORM{'LEVEL'} = 100;
      }

      if ($OLD_ACCOUNT[18] =~ /^[\d\.]+$/) {
        $NEW_FORM{'IP'} = $OLD_ACCOUNT[18];
      } else {
        $NEW_FORM{'HOST'} = $OLD_ACCOUNT[18];
      }

      my $Export = &Upgrade_2000_DB::EncodeData (
        $NEW_FORM{'USERNAME'},
        $NEW_FORM{'PASSWORD'},
        $NEW_FORM{'STATUS'},
        $NEW_FORM{'LEVEL'},
        $NEW_FORM{'GROUP'},
        "", "",
        $NEW_FORM{'NICKNAME'},
        $NEW_FORM{'EMAIL'},
        $NEW_FORM{'TOTAL_POSTS'},
        $NEW_FORM{'REGISTERED_SECOND'},
        "","",
        $NEW_FORM{'LAST_POST_SECOND'},
        "", "",
        "", "", "",
        $NEW_FORM{'HOST'},
        $NEW_FORM{'IP'},
        $NEW_FORM{'HIDE_EMAIL'},
        "1"
      );

      #print "- - - Appending the information to 'Accounts.export' for UltraBoard 2000... ";
      open (ACCOUNTS, ">>$NEW_BACKUP_DIR/Accounts/Accounts.export") || (print "error: $!... " and exit);
        print ACCOUNTS $NEW_FORM{'USERNAME'}."|~|".$Export."\n";
      close(ACCOUNTS);
      #print "done.<br>\n";

      $Export = &Upgrade_2000_DB::EncodeData (
        $NEW_FORM{'USERNAME'},
        $NEW_FORM{'HOMEPAGE'},
        $NEW_FORM{'LOCATION'},
        $NEW_FORM{'OCCUPATION'},
        $NEW_FORM{'INTEREST'},
        $NEW_FORM{'ICQ'},
        $NEW_FORM{'AGE'},
        $NEW_FORM{'COMMENTS'},
        $NEW_FORM{'SIGNATURE'},
        ""
      );

      #print "- - - Appending the information to 'Profiles.export' for UltraBoard 2000... ";
      open (PROFILES, ">>$NEW_BACKUP_DIR/Profiles/Profiles.export") || (print "error: $!... " and exit);
        print PROFILES $NEW_FORM{'USERNAME'}."|~|".$Export."\n";
      close(PROFILES);
      #print "done.<br>\n";

      #print "- - Appending the information to 'accounts.username' for UltraBoard 2000... ";
      open (USERNAME, ">>$NEW_BACKUP_DIR/accounts.username") || (print "error: $!... " and exit);
        print USERNAME $NEW_FORM{'USERNAME'}."\n";
      close(USERNAME);
      #print "done.<br>\n";

      #print "- - Appending the information to 'accounts.nickname' for UltraBoard 2000... ";
      open (NICKNAME, ">>$NEW_BACKUP_DIR/accounts.nickname") || (print "error: $!... " and exit);
        print NICKNAME $NEW_FORM{'NICKNAME'}."\n";
      close(NICKNAME);
      #print "done.<br>\n";

      #print "- - Appending the information to 'accounts.email' for UltraBoard 2000... ";
      open (EMAIL, ">>$NEW_BACKUP_DIR/accounts.email") || (print "error: $!... " and exit);
        print EMAIL $NEW_FORM{'EMAIL'}."\n";
      close(EMAIL);
      #print "done.<p>\n\n";
      print "done.<br>\n";

      ++$Counter;
    }
  }

  print "- - Creating a file 'Accounts.counter' for UltraBoard 2000... ";
  open (ACCOUNTS, ">$NEW_BACKUP_DIR/Accounts/Accounts.counter") || (print "error: $!<br>\n" and exit);
    print ACCOUNTS $Counter;
  close(ACCOUNTS);
  print "done.<br>\n";

  print "- - Creating a file 'Profiles.counter' for UltraBoard 2000... ";
  open (PROFILES, ">$NEW_BACKUP_DIR/Profiles/Profiles.counter") || (print "error: $!<br>\n" and exit);
    print PROFILES $Counter;
  close(PROFILES);
  print "done.<p>\n";

  print "\n";

  # CATEGORIES ################################################################

  print "- <b>Backing up the categories data...</b><br>\n";

  print "- - Creating a directory for categories... ";
  mkdir ($NEW_BACKUP_DIR."/Categories", 0777) || (print "error: $!<br>\n" and exit);
  chmod (0777, $NEW_BACKUP_DIR."/Categories");
  print "done.<br>\n";

  print "- - Creating a file 'Categories.export' for UltraBoard 2000... ";
  open (CATEGORIES, ">$NEW_BACKUP_DIR/Categories/Categories.export") || (print "error: $!<br>\n" and exit);
    print CATEGORIES "ID|TITLE|DESCRIPTION|MAX_FILE_SIZE|TOTAL_MEMBERS\n";
  close(CATEGORIES);
  print "done.<br>\n";

  print "- - Opening the file 'Categories.db' from UltraBoard 1.6x... ";
  open(CATEGORIES, "$OLD_DB_PATH/Categories.db") || (print "error: $!<br>\n" and exit);
    my @OLD_CATEGORIES = <CATEGORIES>;
  close(CATEGORIES);
  chomp(@OLD_CATEGORIES);
  print "done.<p>\n";

  my %OLD_CATEGORY_ID_TO_NEW; # for converting boards use

  # [FORMAT OF CATEGORIES]
  # UB 1.6X: ID, NAME, DESCRIPTION
  # UB 2000: ID, TITLE, DESCRIPTION, TOTAL_BOARDS, TOTAL_POSTS,
  #          TOTAL_TOPICS, LAST_UPDATE_SECOND, LAST_UPDATE_DATE,
  #          LAST_UPDATE_TIME, POSITION
  $Counter = 0;
  for (my $i = 0; $i <= $#OLD_CATEGORIES; $i++) {
    my @OLD_CATEGORY = &Upgrade_16X::DecodeDBOutput($OLD_CATEGORIES[$i]);
       @OLD_CATEGORY = &Upgrade_16X::DecodeHTMLTags(@OLD_CATEGORY);

    print "- - - Opening the file '$OLD_CATEGORY[0].cat' from UltraBoard 1.6x... ";
    open(CATEGORY,"$OLD_DB_PATH/$OLD_CATEGORY[0].cat") || (print "error: $!<br>\n" and exit);
      my @OLD_BOARDS = <CATEGORY>; # TOTAL_BOARDS
    close(CATEGORY);
    chomp(@OLD_BOARDS);
    print "done.<br>\n";

    my %NEW_FORM;
    $NEW_FORM{'TITLE'}         = &Upgrade_2000_Standard::EncodeHTML($OLD_CATEGORY[1]);
    $NEW_FORM{'DESCRIPTION'}   = &Upgrade_2000_Standard::EncodeHTML($OLD_CATEGORY[2]);
    $NEW_FORM{'TOTAL_BOARDS'}  = ( scalar( @OLD_BOARDS ) - 1 ) || 0;

    for (my $b = 1; $b <= $#OLD_BOARDS; $b++) {
      my @OLD_BOARD = &Upgrade_16X::DecodeDBOutput($OLD_BOARDS[$b]);
         @OLD_BOARD = &Upgrade_16X::DecodeHTMLTags(@OLD_BOARD);

      print "- - - Opening the file '$OLD_BOARD[0]/board.count' from UltraBoard 1.6x... ";
      open(BOARD,"$OLD_DB_PATH/$OLD_BOARD[0]/board.count") || (print "error: $!<br>\n" and exit);
        my @OLD_BOARD_STATS = &Upgrade_16X::DecodeDBOutput(<BOARD>);
           @OLD_BOARD_STATS = &Upgrade_16X::DecodeHTMLTags(@OLD_BOARD_STATS);
      close(BOARD);
      print "done.<br>\n";

      # [FORMAT OF BOARD STATS]
      # UB 1.6x: POST_NUMBER, TOTAL_TOPICS, TOTAL_POSTS, LAST_UPDATE_SECOND
      $NEW_FORM{'TOTAL_TOPICS'}       += $OLD_BOARD_STATS[1];
      $NEW_FORM{'TOTAL_POSTS'}        += $OLD_BOARD_STATS[2];
      $NEW_FORM{'LAST_UPDATE_SECOND'}  = $OLD_BOARD_STATS[3] if ($OLD_BOARD_STATS[3] > $NEW_FORM{'LAST_UPDATE_SECOND'});
    }

    my $Export = &Upgrade_2000_DB::EncodeData (
      ++$Counter,
      $NEW_FORM{'TITLE'},
      $NEW_FORM{'DESCRIPTION'},
      $NEW_FORM{'TOTAL_BOARDS'},
      $NEW_FORM{'TOTAL_POSTS'},
      $NEW_FORM{'TOTAL_TOPICS'},
      $NEW_FORM{'LAST_UPDATE_SECOND'},
      "", "", ""
    );

    $OLD_CATEGORY_ID_TO_NEW{ $OLD_CATEGORY[0] } = $Counter;

    print "- - - Appending the information to 'Categories.export' for UltraBoard 2000... ";
    open (CATEGORIES, ">>$NEW_BACKUP_DIR/Categories/Categories.export") || (print "error: $!<br>\n" and exit);
      print CATEGORIES $Counter."|~|".$Export."\n";
    close(CATEGORIES);
    print "done.<p>\n";
  }

  print "- - Creating a file 'Categories.counter' for UltraBoard 2000... ";
  open (CATEGORIES, ">$NEW_BACKUP_DIR/Categories/Categories.counter") || (print "error: $!<br>\n" and exit);
    print CATEGORIES $Counter;
  close(CATEGORIES);
  print "done.<p>\n";

  print "\n";

  # BOARDS ####################################################################

  print "- <b>Backing up the boards data...</b><br>\n";

  print "- - Creating a directory for boards... ";
  mkdir ($NEW_BACKUP_DIR."/Boards", 0777) || (print "error: $!<br>\n" and exit);
  chmod (0777, $NEW_BACKUP_DIR."/Boards");
  print "done.<br>\n";

  print "- - Creating a file 'Boards.export' for UltraBoard 2000... ";
  open (BOARDS, ">$NEW_BACKUP_DIR/Boards/Boards.export") || (print "error: $!<br>\n" and exit);
    print BOARDS "ID|TITLE|DESCRIPTION|CATEGORY|MAJOR_MODERATOR|MAJOR_MODERATOR_NICKNAME|MAJOR_MODERATOR_EMAIL|MINOR_MODERATORS|TOTAL_POSTS|TOTAL_TOPICS|STATUS|UB_CODES|HTML_TAGS|NEED_APROVED|SUBSCRIPTION|FILE_ATTACH|EXPIRE|LAST_POST_SECOND|LAST_POST_DATE|LAST_POST_TIME|LAST_UPDATE_SECOND|LAST_UPDATE_DATE|LAST_UPDATE_TIME|POSITION\n";
  close(BOARDS);
  print "done.<br>\n";

  print "- - Opening the file 'Boards.db' from UltraBoard 1.6x... ";
  open(BOARDS, "$OLD_DB_PATH/Boards.db") || (print "error: $!<br>\n" and exit);
    my @OLD_BOARDS = <BOARDS>;
  close(BOARDS);
  chomp(@OLD_BOARDS);
  print "done.<br>\n";

  my %OLD_BOARD_ID_TO_NEW; # for converting boards use

  # [FORMAT OF BOARDS]
  # UB 1.6X: ID, NAME, DESCRIPTION, CATEGORY, MODERATORS, STATUS, TYPE
  # UB 2000: ID, TITLE, DESCRIPTION, CATEGORY, MAJOR_MODERATOR,
  #          MAJOR_MODERATOR_NICKNAME, MAJOR_MODERATOR_EMAIL, MINOR_MODERATORS,
  #          TOTAL_POSTS, TOTAL_TOPICS, STATUS, UB_CODES, HTML_TAGS, NEED_APROVED,
  #          SUBSCRIPTION, FILE_ATTACH, EXPIRE, LAST_POST_SECOND, LAST_POST_DATE,
  #          LAST_POST_TIME, LAST_UPDATE_SECOND, LAST_UPDATE_DATE, LAST_UPDATE_TIME,
  #          POSITION
  $Counter = 0;
  for (my $i = 0; $i <= $#OLD_BOARDS; $i++) {
    my @OLD_BOARD = &Upgrade_16X::DecodeDBOutput($OLD_BOARDS[$i]);
       @OLD_BOARD = &Upgrade_16X::DecodeHTMLTags(@OLD_BOARD);

    print "- - - Opening the file '$OLD_BOARD[0]/board.count' from UltraBoard 1.6x... ";
    open(BOARD,"$OLD_DB_PATH/$OLD_BOARD[0]/board.count") || (print "error: $!<br>\n" and exit);
      my @OLD_BOARD_STATS = &Upgrade_16X::DecodeDBOutput(<BOARD>);
         @OLD_BOARD_STATS = &Upgrade_16X::DecodeHTMLTags(@OLD_BOARD_STATS);
    close(BOARD);
    print "done.<br>\n";

    my %NEW_FORM;
    $NEW_FORM{'TITLE'}              = &Upgrade_2000_Standard::EncodeHTML($OLD_BOARD[1]);
    $NEW_FORM{'DESCRIPTION'}        = &Upgrade_2000_Standard::EncodeHTML($OLD_BOARD[2]);
    $NEW_FORM{'CATEGORY'}           = $OLD_CATEGORY_ID_TO_NEW{ $OLD_BOARD[3] };

    $NEW_FORM{'TOTAL_POSTS'}        = $OLD_BOARD_STATS[1];
    $NEW_FORM{'TOTAL_TOPICS'}       = $OLD_BOARD_STATS[2];

    $NEW_FORM{'STATUS'}             = ($OLD_BOARD[5] eq "Active") ? 70 : 30;
    $NEW_FORM{'LAST_POST_SECOND'}   = $OLD_BOARD_STATS[3];
    $NEW_FORM{'LAST_UPDATE_SECOND'} = $OLD_BOARD_STATS[3];

    my $Export = &Upgrade_2000_DB::EncodeData (
      ++$Counter,
      $NEW_FORM{'TITLE'},
      $NEW_FORM{'DESCRIPTION'},
      $NEW_FORM{'CATEGORY'},
      "", "", "", "",
      $NEW_FORM{'TOTAL_POSTS'},
      $NEW_FORM{'TOTAL_TOPICS'},
      $NEW_FORM{'STATUS'},
      "0", "0", "0", "0", "0", "0",
      $NEW_FORM{'LAST_POST_SECOND'},
      "", "",
      $NEW_FORM{'LAST_UPDATE_SECOND'},
      "", "", ""
    );

    $OLD_BOARD_ID_TO_NEW{ $OLD_BOARD[0] } = $Counter;

    print "- - - Appending the information to 'Boards.export' for UltraBoard 2000... ";
    open (BOARDS, ">>$NEW_BACKUP_DIR/Boards/Boards.export") || (print "error: $!<br>\n" and exit);
      print BOARDS $Counter."|~|".$Export."\n";
    close(BOARDS);
    print "done.<p>\n";
  }

  print "- - Creating a file 'Boards.counter' for UltraBoard 2000... ";
  open (BOARDS, ">$NEW_BACKUP_DIR/Boards/Boards.counter") || (print "error: $!<br>\n" and exit);
    print BOARDS $Counter;
  close(BOARDS);
  print "done.<p>\n";

  print "\n";

  # BOARDS ####################################################################

  foreach my $OLD_BOARD_ID (sort {$OLD_BOARD_ID_TO_NEW{$a} cmp $OLD_BOARD_ID_TO_NEW{$b}} keys %OLD_BOARD_ID_TO_NEW) {
    print "- <b>Backing up the board id:$OLD_BOARD_ID data...</b><br>\n";

    my $NEW_BOARD_ID = $OLD_BOARD_ID_TO_NEW{ $OLD_BOARD_ID };

    print "- - Creating a directory for board id:$OLD_BOARD_ID... ";
    mkdir ($NEW_BACKUP_DIR."/B$NEW_BOARD_ID", 0777) || (print "error: $!<br>\n" and exit);
    chmod (0777, $NEW_BACKUP_DIR."/B$NEW_BOARD_ID");
    print "done.<br>\n";

    print "- - Creating a file 'B$NEW_BOARD_ID.export' for UltraBoard 2000... ";
    open (BOARD, ">$NEW_BACKUP_DIR/B$NEW_BOARD_ID/B$NEW_BOARD_ID.export") || (print "error: $!<br>\n" and exit);
      print BOARD "ID|SUBJECT|USERNAME|EMAIL|NICKNAME|MEMBER_LEVEL|MEMBER_GROUP|ROOT|REPLIES|NUMBER_REPLIES|POST_SECOND|POST_DATE|POST_TIME|LAST_POST_SECOND|LAST_POST_DATE|LAST_POST_TIME|LAST_UPDATE_SECOND|LAST_UPDATE_DATE|LAST_UPDATE_TIME|TOTAL_MODIFIED|HOST|IP|REPLY_NOTIFY|SIGNATURE|SYMBOL|APROVED|READ_ONLY|ATTACHMENT|HITS\n";
    close(BOARD);
    print "done.<br>\n";

    print "- - Opening the file '$OLD_BOARD_ID/board.list' from UltraBoard 1.6x... ";
    open(BOARD, "$OLD_DB_PATH/$OLD_BOARD_ID/board.list") || (print "error: $!<br>\n" and exit);
      my @OLD_BOARD = <BOARD>;
    close(BOARD);
    chomp(@OLD_BOARD);
    print "done.<br>\n";

    # [FORMAT OF BOARD]
    # UB 1.6X: POST_TIME, ID, NUMBER_REPLIES, SUBJECT, NICKNAME, USERNAME,
    #          CLOSED, SYMBOL
    # UB 2000: ID, SUBJECT, USERNAME, EMAIL, NICKNAME, MEMBER_LEVEL,
    #          MEMBER_GROUP, ROOT, REPLIES, NUMBER_REPLIES, POST_SECOND,
    #          POST_DATE, POST_TIME, LAST_POST_SECOND, LAST_POST_DATE,
    #          LAST_POST_TIME, LAST_UPDATE_SECOND, LAST_UPDATE_DATE,
    #          LAST_UPDATE_TIME, TOTAL_MODIFIED, HOST, IP, REPLY_NOTIFY,
    #          SIGNATURE, SYMBOL, APROVED, READ_ONLY, ATTACHMENT, HITS
    $Counter = 0;
    for (my $i = 1; $i <= $#OLD_BOARD; $i++) {
      my @OLD_TOPIC = &Upgrade_16X::DecodeDBOutput($OLD_BOARD[$i]);
         @OLD_TOPIC = &Upgrade_16X::DecodeHTMLTags(@OLD_TOPIC);
      my $OLD_TOPIC_ID = $OLD_TOPIC[1];

      print "- - - Opening the file '$OLD_BOARD_ID/$OLD_TOPIC_ID.post' from UltraBoard 1.6x... ";
      open(POSTS,"$OLD_DB_PATH/$OLD_BOARD_ID/$OLD_TOPIC_ID.post") || (print "error: $!... " and exit);
        my @OLD_POSTS = <POSTS>;
      close(POSTS);
      #print "done.<br>\n";

      chomp (@OLD_POSTS);

      # [FORMAT OF BOARD]
      # UB 1.6X: SUBJECT, NICKNAME, USERNAME, REPLY_NOTIFY, SIGNATURE, POST_SECOND,
      #          IP, MESSAGE, CLOSED, DESCRIPTION, TOTAL_MODIFIED, SYMBOL
      @OLD_TOPIC    = &Upgrade_16X::DecodeDBOutput($OLD_POSTS[0]);
      my $tmp       = $OLD_TOPIC[7];
      @OLD_TOPIC    = &Upgrade_16X::DecodeHTMLTags(@OLD_TOPIC);
      $OLD_TOPIC[7] = $tmp;

      my @OLD_TOPIC_STATS = &Upgrade_16X::DecodeDBOutput($OLD_POSTS[1]);
         @OLD_TOPIC_STATS = &Upgrade_16X::DecodeHTMLTags(@OLD_TOPIC_STATS);

      my %NEW_FORM;
      $NEW_FORM{'SUBJECT'}        = &Upgrade_2000_Standard::EncodeHTML($OLD_TOPIC[0]);
      $NEW_FORM{'NICKNAME'}       = &Upgrade_2000_Standard::EncodeHTML($OLD_TOPIC[1]);
      $NEW_FORM{'USERNAME'}       = $OLD_TOPIC[2];
      $NEW_FORM{'REPLY_NOTIFY'}   = ($OLD_TOPIC[3] eq "on") ? 1 : 0;
      $NEW_FORM{'SIGNATURE'}      = ($OLD_TOPIC[4] eq "on") ? 1 : 0;
      $NEW_FORM{'POST_SECOND'}    = $OLD_TOPIC[5];

      if ($OLD_TOPIC[6] =~ /^[\d\.]+$/) {
        $NEW_FORM{'IP'} = $OLD_TOPIC[6];
      } else {
        $NEW_FORM{'HOST'} = $OLD_TOPIC[6];
      }

      $NEW_FORM{'MESSAGE'}        = $OLD_TOPIC[7];
      $NEW_FORM{'READ_ONLY'}      = ($OLD_TOPIC[8] eq "on") ? 1 : 0;
      $NEW_FORM{'TOTAL_MODIFIED'} = $OLD_TOPIC[10];

      $NEW_FORM{'NUMBER_REPLIES'}   = $OLD_TOPIC_STATS[0];
      $NEW_FORM{'LAST_POST_SECOND'} = $OLD_TOPIC_STATS[2];

      my $NEW_TOPIC_ID = ++$Counter;
      my @Export = ();
      my @REPLIES;

      for (my $p = 2; $p <= $#OLD_POSTS; $p++) {
        my @OLD_REPLY = &Upgrade_16X::DecodeDBOutput($OLD_POSTS[$p]);
        my $tmp       = $OLD_REPLY[7];
        @OLD_REPLY    = &Upgrade_16X::DecodeHTMLTags(@OLD_REPLY);
        $OLD_REPLY[7] = $tmp;

        my %NEW_FORM;
        $NEW_FORM{'SUBJECT'}        = &Upgrade_2000_Standard::EncodeHTML($OLD_REPLY[0]);
        $NEW_FORM{'NICKNAME'}       = &Upgrade_2000_Standard::EncodeHTML($OLD_REPLY[1]);
        $NEW_FORM{'USERNAME'}       = $OLD_REPLY[2];
        $NEW_FORM{'REPLY_NOTIFY'}   = ($OLD_REPLY[3] eq "on") ? 1 : 0;
        $NEW_FORM{'SIGNATURE'}      = ($OLD_REPLY[4] eq "on") ? 1 : 0;
        $NEW_FORM{'POST_SECOND'}    = $OLD_REPLY[5];

        if ($OLD_REPLY[6] =~ /^[\d\.]+$/) {
          $NEW_FORM{'IP'} = $OLD_REPLY[6];
        } else {
          $NEW_FORM{'HOST'} = $OLD_REPLY[6];
        }

        $NEW_FORM{'MESSAGE'}        = $OLD_REPLY[7];
        $NEW_FORM{'READ_ONLY'}      = ($OLD_REPLY[8] eq "on") ? 1 : 0;
        $NEW_FORM{'TOTAL_MODIFIED'} = $OLD_REPLY[10];

        my $NEW_REPLY_ID = ++$Counter;

        push (
          @Export,
          $NEW_REPLY_ID."|~|".
          &Upgrade_2000_DB::EncodeData (
            $NEW_REPLY_ID,
            $NEW_FORM{'SUBJECT'},
            $NEW_FORM{'USERNAME'},
            "",
            $NEW_FORM{'NICKNAME'},
            "", "",
            $NEW_TOPIC_ID,
            "", "",
            $NEW_FORM{'POST_SECOND'},
            "", "",
            $NEW_FORM{'LAST_POST_SECOND'},
            "", "", "", "", "",
            $NEW_FORM{'TOTAL_MODIFIED'},
            $NEW_FORM{'HOST'},
            $NEW_FORM{'IP'},
            $NEW_FORM{'REPLY_NOTIFY'},
            $NEW_FORM{'SIGNATURE'},
            "", "1",
            $NEW_FORM{'READ_ONLY'},
            "", "0"
          )
        );

        push (@REPLIES, $NEW_REPLY_ID);
        open (POST, ">$NEW_BACKUP_DIR/B$NEW_BOARD_ID/$NEW_REPLY_ID.src");
          print POST $NEW_FORM{'MESSAGE'};
        close(POST);
        open (POST, ">$NEW_BACKUP_DIR/B$NEW_BOARD_ID/$NEW_REPLY_ID.post");
          print POST $NEW_FORM{'MESSAGE'};
        close(POST);
      }

      push (
        @Export,
        $NEW_TOPIC_ID."|~|".
        &Upgrade_2000_DB::EncodeData (
          $NEW_TOPIC_ID,
          $NEW_FORM{'SUBJECT'},
          $NEW_FORM{'USERNAME'},
          "",
          $NEW_FORM{'NICKNAME'},
          "", "", "0",
          ",".join(",", @REPLIES),
          scalar(@REPLIES),
          $NEW_FORM{'POST_SECOND'},
          "", "",
          $NEW_FORM{'LAST_POST_SECOND'},
          "", "",
          $NEW_FORM{'POST_SECOND'},
          "", "",
          $NEW_FORM{'TOTAL_MODIFIED'},
          $NEW_FORM{'HOST'},
          $NEW_FORM{'IP'},
          $NEW_FORM{'REPLY_NOTIFY'},
          $NEW_FORM{'SIGNATURE'},
          "", "1",
          $NEW_FORM{'READ_ONLY'},
          "", "0"
        )
      );

      open (POST, ">$NEW_BACKUP_DIR/B$NEW_BOARD_ID/$NEW_TOPIC_ID.src");
        print POST $NEW_FORM{'MESSAGE'};
      close(POST);
      open (POST, ">$NEW_BACKUP_DIR/B$NEW_BOARD_ID/$NEW_TOPIC_ID.post");
        print POST $NEW_FORM{'MESSAGE'};
      close(POST);

      chomp (@Export);

      #print "- - - Appending the information to 'B$NEW_BOARD_ID/B$NEW_BOARD_ID.export' for UltraBoard 2000... ";
      open (BOARD, ">>$NEW_BACKUP_DIR/B$NEW_BOARD_ID/B$NEW_BOARD_ID.export") || (print "error: $!... " and exit);
        for (my $e = 0; $e <= $#Export; $e++) {
          print BOARD $Export[$e]."\n";
        }
      close(BOARD);
      print "done.<p>\n";
    }

    print "- - Creating a file 'B".$NEW_BOARD_ID.".counter' for UltraBoard 2000... ";
    open (BOARD, ">$NEW_BACKUP_DIR/B$NEW_BOARD_ID/B$NEW_BOARD_ID.counter") || (print "error: $!<br>\n." and exit);
      print BOARD $Counter;
    close(BOARD);
    print "done.<p>\n";

    open (BOARD, ">$NEW_BACKUP_DIR/B$NEW_BOARD_ID.cfg") || (print "error: $!<br>\n." and exit);
      print BOARD <<TEXT;
package DB;

\$DB::Path{'B$NEW_BOARD_ID'} = "\$SYSTEM::DB_PATH/B$NEW_BOARD_ID";

\%{ \$DB::Table{'B$NEW_BOARD_ID'} } = (
  ID                  => [ 0, "autonumber",    32, 1,           ""],
  SUBJECT             => [ 1,     "string",   128, 1,           ""],
  USERNAME            => [ 2,     "string",    16, 0,           ""],
  EMAIL               => [ 3,     "string",    64, 0,           ""],
  NICKNAME            => [ 4,     "string",    32, 0,           ""],
  MEMBER_LEVEL        => [ 5,     "string",    64, 0,           ""],
  MEMBER_GROUP        => [ 6,     "string",    32, 0,           ""],
  ROOT                => [ 7,     "number",     8, 0,          "0"],
  REPLIES             => [ 8,     "string",    -1, 0,           ""],
  NUMBER_REPLIES      => [ 9,     "number",     8, 0,          "0"],
  POST_SECOND         => [10,     "number",    16, 1,           ""],
  POST_DATE           => [11,     "string",    64, 1,           ""],
  POST_TIME           => [12,     "string",    64, 1,           ""],
  LAST_POST_SECOND    => [13,     "number",    16, 0,           ""],
  LAST_POST_DATE      => [14,     "string",    64, 0,           ""],
  LAST_POST_TIME      => [15,     "string",    64, 0,           ""],
  LAST_UPDATE_SECOND  => [16,     "number",    16, 0,           ""],
  LAST_UPDATE_DATE    => [17,     "string",    64, 0,           ""],
  LAST_UPDATE_TIME    => [18,     "string",    64, 0,           ""],
  TOTAL_MODIFIED      => [19,     "number",     3, 0,          "0"],
  HOST                => [20,     "string",   128, 0,           ""],
  IP                  => [21,     "string",    16, 0,           ""],
  REPLY_NOTIFY        => [22,     "number",     1, 0,          "0"],
  SIGNATURE           => [23,     "number",     1, 0,          "0"],
  SYMBOL              => [24,     "string",   256, 0,           ""],
  APROVED             => [25,     "number",     1, 0,          "1"],
  READ_ONLY           => [26,     "number",     1, 0,          "0"],
  ATTACHMENT          => [27,     "string",   512, 0,          "0"],
  HITS                => [28,     "number",     8, 0,          "0"]
);

\$DB::PrimaryKey{'B$NEW_BOARD_ID'} = "ID";

\$DB::Pointer{'B$NEW_BOARD_ID'}   = "";

foreach my \$Key ( sort { \$DB::Table{'B$NEW_BOARD_ID'}->{\$a}[0] <=> \$DB::Table{'B$NEW_BOARD_ID'}->{\$b}[0] } keys \%{ \$DB::Table{'B$NEW_BOARD_ID'} } ) {
  push ( \@{ \$DB::Columns{'B$NEW_BOARD_ID'} }, \$Key );
  if (\$Key eq \$DB::PrimaryKey{'B$NEW_BOARD_ID'}) {
    \$DB::Primary{'B$NEW_BOARD_ID'} = \$DB::Table{'B$NEW_BOARD_ID'}->{\$Key}[0];
  }
}

1;
TEXT
    close(BOARD);

    print "\n";
  }

  print "- Finish convert all the data files!<br>\n";

  print "</font>\n";

  open (LOCK, ">$UB::PATH/setup.lock");
    print LOCK time;
  close(LOCK);

  exit;
}

###############################################################################
package Permission::Set;

use File::Path;

###############################################################################
# Set function
sub Set {
  &HTML::Top("(UltraBoard 2000 Set Permission)", "UltraBoard 2000 Set Permission");
  &HTML::Description (
    "Are you sure to set the permission?"
  );

  print qq~<form method="post">\n~;
  print qq~<input type="hidden" name="Category" value="SetPermission">\n~;
  print qq~<input type="hidden" name="Action" value="Process">\n~;

  print qq~<table width="100%" border="0" cellspacing="2" cellpadding="2">\n~;
  print qq~<tr>\n<td width="250" valign="top" nowrap>&nbsp;</td>\n~;
  print qq~<td colspan="3" valign="top" bgcolor="#EEEEEE"><input type="submit" value="Set Permission" class="Button"> <input type="Reset" value="Cancel" class="Button"></td>\n~;
  print qq~</tr>\n</table>\n~;
  print qq~<table width="100%" border="0" cellspacing="0" cellpadding="0"><tr><td nowrap></form></td></tr></table>\n~;

  &HTML::Bottom();

  exit;
}

###############################################################################
# DoSet function
sub DoSet {
  require "$UB::PATH/setup.cfg";

  &Permission::Permission ($SETUP::PATHS{'SCRIPTS'}, 0755, 0744);
  if ($SETUP::PATHS{'PRIVATE'} =~ /^$SETUP::PATHS{'SCRIPTS'}/) {
    &Permission::Permission ($SETUP::PATHS{'PRIVATE'}, 0755, 0744);
  }
  if ($SETUP::PATHS{'PRIVATE'} =~ /^$SETUP::PATHS{'SCRIPTS'}/) {
    &Permission::Permission ($SETUP::PATHS{'PUBLIC'}, 0755, 0744);
  }

  foreach my $PATH (@SETUP::DIRECTORIES) {
    chmod (0744, $PATH);
  }
  chmod (0755, $SETUP::PATHS{'SCRIPTS'});
  chmod (0755, $SETUP::PATHS{'SOURSES'});

  &HTML::Top("(UltraBoard 2000 Set Permission)", "UltraBoard 2000 Set Permission");
  &HTML::Description (
    "Settled the permission of UltraBoard 2000."
  );

  &HTML::Bottom();

  chmod (0766, "$UB::PATH/setup.lock");
  open (LOCK, ">$UB::PATH/setup.lock");
    print LOCK time;
  close(LOCK);

  exit;
}

###############################################################################
package Permission::Unset;

use File::Path;

###############################################################################
# Unset function
sub Unset {
  &HTML::Top("(UltraBoard 2000 Unset Permission)", "UltraBoard 2000 Unset Permission");
  &HTML::Description (
    "Are you sure to unset the permission?"
  );

  print qq~<form method="post">\n~;
  print qq~<input type="hidden" name="Category" value="UnsetPermission">\n~;
  print qq~<input type="hidden" name="Action" value="Process">\n~;

  print qq~<table width="100%" border="0" cellspacing="2" cellpadding="2">\n~;
  print qq~<tr>\n<td width="250" valign="top" nowrap>&nbsp;</td>\n~;
  print qq~<td colspan="3" valign="top" bgcolor="#EEEEEE"><input type="submit" value="Unset Permission" class="Button"> <input type="Reset" value="Cancel" class="Button"></td>\n~;
  print qq~</tr>\n</table>\n~;
  print qq~<table width="100%" border="0" cellspacing="0" cellpadding="0"><tr><td nowrap></form></td></tr></table>\n~;

  &HTML::Bottom();

  exit;
}

###############################################################################
# DoUnset function
sub DoUnset {
  require "$UB::PATH/setup.cfg";

  &Permission::Permission ($SETUP::PATHS{'SCRIPTS'}, 0777, 0777);
  if ($SETUP::PATHS{'PRIVATE'} =~ /^$SETUP::PATHS{'SCRIPTS'}/) {
    &Permission::Permission ($SETUP::PATHS{'PRIVATE'}, 0777, 0777);
  }
  if ($SETUP::PATHS{'PRIVATE'} =~ /^$SETUP::PATHS{'SCRIPTS'}/) {
    &Permission::Permission ($SETUP::PATHS{'PUBLIC'}, 0777, 0777);
  }

  foreach my $PATH (@SETUP::DIRECTORIES) {
    chmod (0777, $PATH);
  }

  &HTML::Top("(UltraBoard 2000 Unset Permission)", "UltraBoard 2000 Unset Permission");
  &HTML::Description (
    "Unsettled the permission of UltraBoard 2000."
  );

  &HTML::Bottom();

  chmod (0766, "$UB::PATH/setup.lock");
  open (LOCK, ">$UB::PATH/setup.lock");
    print LOCK time;
  close(LOCK);

  exit;
}

###############################################################################
package Permission;

###############################################################################
# Permission
sub Permission {
  my ($ROOT, $CGI_PERMISSION, $OTHER_PERMISSION) = @_;

  chmod (0777, $ROOT);

  opendir (DIRECTORY, $ROOT);
    my @FILES = readdir(DIRECTORY);
  closedir(DIRECTORY);

  foreach my $FILE (@FILES) {
    next if ($FILE =~ /^\.\.?$/);
    unless (-d $ROOT."/".$FILE) {
      if ($FILE =~ /\.(cgi|pl|pm)$/) {
        chmod ($CGI_PERMISSION, $ROOT."/".$FILE);
      } else {
        chmod ($OTHER_PERMISSION, $ROOT."/".$FILE);
      }
    } else {
      &Permission ($ROOT."/".$FILE, $CGI_PERMISSION, $OTHER_PERMISSION);

      chmod ($OTHER_PERMISSION, $ROOT."/".$FILE);
    }
  }

  return 1;
}

###############################################################################
package Upgrade_16X;

###############################################################################
# Variables

$Upgrade_16X::Spliter = "|^|";

###############################################################################
# ChangesChars
sub ChangesChars {
  my (@Chars) = @_;

  for (my $i = 0; $i <= $#Chars; $i++) {
    $Chars[$i] =~ s/\"/\\\"/g;
    $Chars[$i] =~ s/\n\n/\<p\>\\n\\n/g;
    $Chars[$i] =~ s/\n/\<br\>\\\n/g;
    $Chars[$i] =~ s/\@/\\\@/g;
    $Chars[$i] =~ s/^\s+//g;
    $Chars[$i] =~ s/\s+$//g;
  }

  return wantarray ? @Chars : $Chars[0];
}

###############################################################################
# DecodeHTML
sub DecodeHTML {
  my (@Decode) = @_;

  for (my $i = 0; $i <= $#Decode; $i++){
    $Decode[$i] =~ s/\&amp\;/\&/g;
    $Decode[$i] =~ s/\+/ /g;
    $Decode[$i] =~ s/\|EQU\|/\=/g;
    $Decode[$i] =~ s/\|PLS\|/\+/g;
    $Decode[$i] =~ s/\|APO\|/\'/g;
    $Decode[$i] =~ s/\&quot\;/\"/g;
    $Decode[$i] =~ s/\<p\>\\n\\n/\n\n/g;
    $Decode[$i] =~ s/\<br\>\\n/\n/g;
  }

  return wantarray ? @Decode : $Decode[0];
}

###############################################################################
# DecodeHTMLTags
sub DecodeHTMLTags {
  my (@Decode) = @_;

  for (my $i = 0; $i <= $#Decode; $i++){
    $Decode[$i] =~ s/\&lt\;/\</g;
    $Decode[$i] =~ s/\&gt\;/\>/g;
  }

  return wantarray ? @Decode : $Decode[0];
}

###############################################################################
# DecodeDBOutput
sub DecodeDBOutput {
  my ($Output) = @_;
  my (@Outputs);

  chomp ($Output);

  @Outputs = split(/\Q|^|\E/, $Output);

  for (my $i = 0; $i <= $#Outputs; $i++){
    $Outputs[$i] =~ s/\|\&\^\&\|/\|\^\|/g;
  }

  @Outputs = &DecodeHTML(@Outputs);

  return wantarray ? @Outputs : $Outputs[0];
}

###############################################################################
# GetMemberData
sub GetMemberData {
  my ($MEMBER_PATH, $ID) = @_;
                    $ID  = lc($ID);

  open (ACCOUNT, "$MEMBER_PATH/$ID.info") || return;
    my (@ACCOUNT) = <ACCOUNT>;
  close(ACCOUNT);

  chomp(@ACCOUNT);

  @ACCOUNT = &Upgrade_16X::DecodeHTML(@ACCOUNT);
  @ACCOUNT = &Upgrade_16X::DecodeHTMLTags(@ACCOUNT);
  return @ACCOUNT;
}

###############################################################################
package Upgrade_2000_Standard;

###############################################################################
# EncodeHTML function
sub EncodeHTML {
  my ($data) = @_;

  if (ref ($data) eq "ARRAY") {
    for (my $i = 0; $i <= $#{$data}; $i++) {
      $data->[$i] =~ s/\&/\&amp\;/g;
      $data->[$i] =~ s/\</\&lt\;/g;
      $data->[$i] =~ s/\>/\&gt\;/g;
      #$data->[$i]  =~ s/\"/\&quot\;/g;
      #$data->[$i] =~ s/\'/\&\#39\;/g;
      $data->[$i] =~ s/\|/\&\#124\;/g;
      $data->[$i] =~ s/\r//g;
    }
  } elsif (ref ($data) eq "HASH") {
    foreach my $key (keys %{$data}) {
      $data->{$key} =~ s/\&/\&amp\;/g;
      $data->{$key} =~ s/\</\&lt\;/g;
      $data->{$key} =~ s/\>/\&gt\;/g;
      #$data->{$key}  =~ s/\"/\&quot\;/g;
      #$data->{$key} =~ s/\'/\&\#39\;/g;
      $data->{$key} =~ s/\|/\&\#124\;/g;
      $data->{$key} =~ s/\r//g;
    }
  } else {
    $data =~ s/\&/\&amp\;/g;
    $data =~ s/\</\&lt\;/g;
    $data =~ s/\>/\&gt\;/g;
    #$data  =~ s/\"/\&quot\;/g;
    #$data =~ s/\'/\&\#39\;/g;
    $data =~ s/\|/\&\#124\;/g;
    $data =~ s/\r//g;
  }

  return $data;
}

###############################################################################
package Upgrade_2000_DB;

###############################################################################
# Variables

###############################################################################
# myEncodeData function (Private)
# - function of encoding the data from input, and parse it into a line
sub EncodeData {
  my (@Values) = @_;
  my $Return;

  foreach my $Value (@Values) {
    $Value    =~ s/^\s+//g;
    $Value    =~ s/\s+$//g;

    $Value    =~ s/\r//g;
    $Value    =~ s/\n/\\n/g;

    $Value    =~ s/\Q|^|\E/|&|/g;

    $Return .= $Value."|^|";
  }

  $Return =~ s/\Q|^|\E$//g;

  return $Return;
}

###############################################################################
package Standard;

###############################################################################
# Parse function
sub Parse {
  my ($Buffer, @Pairs, $Pair, $Name, $Value);
  my %in;

  if ($ENV{'REQUEST_METHOD'} eq "POST") {
    read (STDIN, $Buffer, $ENV{'CONTENT_LENGTH'});
  } elsif ($ENV{'REQUEST_METHOD'} eq "GET") {
    $Buffer = $ENV{'QUERY_STRING'};
  }

  @Pairs = split(/&/, $Buffer);
  foreach $Pair (@Pairs) {
    ($Name, $Value) = split(/=/, $Pair);
    $Value =~ tr/+/ /;
    $Value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $Value =~ s/\r//g;
    $Value =~ s/^\s+//g;
    $Value =~ s/\s+$//g;

    if (exists ($in{$Name})) {
      $in{$Name} .= "\0".$Value;
    } else {
      $in{$Name} = $Value;
    }
  }

  return %in;
}

###############################################################################
# Encode function
sub Encode {
  my ($data) = @_;

  if (ref ($data) eq "ARRAY") {
    for (my $i = 0; $i <= $#{$data}; $i++) {
      $data->[$i] =~ s/\\/\\\\/g;
      $data->[$i] =~ s/\$/\\\$/g;
      $data->[$i] =~ s/\@/\\\@/g;
      $data->[$i] =~ s/\%/\\\%/g;
      $data->[$i] =~ s/\~/\\\~/g;

      $data->[$i] =~ s/\"/\&quot\;/g;
      $data->[$i] =~ s/\'/\&\#39\;/g;
      $data->[$i] =~ s/\r//g;
      $data->[$i] =~ s/\s+$//;
    }
  } elsif (ref ($data) eq "HASH") {
    foreach my $key (keys %{$data}) {
      $data->{$key} =~ s/\\/\\\\/g;
      $data->{$key} =~ s/\$/\\\$/g;
      $data->{$key} =~ s/\@/\\\@/g;
      $data->{$key} =~ s/\%/\\\%/g;
      $data->{$key} =~ s/\~/\\\~/g;

      $data->{$key} =~ s/\"/\&quot\;/g;
      $data->{$key} =~ s/\'/\&\#39\;/g;
      $data->{$key} =~ s/\r//g;
      $data->{$key} =~ s/\s+$//;
    }
  } else {
    $data =~ s/\\/\\\\/g;
    $data =~ s/\$/\\\$/g;
    $data =~ s/\@/\\\@/g;
    $data =~ s/\%/\\\%/g;
    $data =~ s/\~/\\\~/g;

    $data =~ s/\"/\&quot\;/g;
    $data =~ s/\'/\&\#39\;/g;
    $data =~ s/\r//g;
    $data =~ s/\s+$//;
  }

  return $data;
}

###############################################################################
# ConvertToDate function
# - function of convert epoch second to date, and time.
sub ConvertToDate {
  my ($epoch) = @_;

  $epoch = time unless $epoch;

  my @ShortMonths = ("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");
  my @LongMonths  = ();
  my ($mDay, $mon, $year, $isdst);

  (undef, undef, undef, $mDay, $mon, $year, undef, undef, $isdst) = localtime ($epoch);

  my $Date;

  $year += 1900;

  $Date = sprintf ("%s %02d, %04d", $ShortMonths[$mon], $mDay, $year);

  return $Date;
}

###############################################################################
# ConvertToTime function
# - function of convert epoch second to date, and time.
sub ConvertToTime {
  my ($epoch) = @_;

  $epoch = time unless $epoch;

  my ($sec, $min, $hour, $isdst);

  ($sec, $min, $hour, undef, undef, undef, undef, undef, $isdst) = localtime ($epoch);

  my $Time;

  if ($hour >= 12) {
    $hour -= 12 if ($hour > 12);
    $Time = sprintf ("%02d:%02d p.m.", $hour, $min);
  } else {
    $Time = sprintf ("%02d:%02d a.m.", $hour, $min);
  }

  return $Time;
}

###############################################################################
# Chmod function
sub Chmod {
  my ($D, $Permission) = @_;
  my (@chmods);

  return unless $D;

  if ($Permission eq "r") {
    @chmods = (0766, 0777);
  } elsif ($Permission eq "w") {
    @chmods = (0766, 0777);
  } elsif ($Permission eq "x") {
    @chmods = (0755, 0777);
  }

  if (-d $D) {
    for (my $i = 0; $i <= $#chmods; $i++) {
      if (opendir(TEST, $D)) {
        closedir(TEST);
        last;
      } else {
        if ($! =~ /Permission denied/i) {
          chmod ($chmods[$i], $D);
        } else {
          last;
        }
      }
    }

    unless (opendir(TEST, $D)) {
      closedir(TEST);
      return;
    }
  } else {
    for (my $i = 0; $i <= $#chmods; $i++) {
      if (open(TEST, $D)) {
        close(TEST);
        last;
      } else {
        if ($! =~ /Permission denied/i) {
          my ($Path, $File) = ($D =~ /^(.+)\/([^\/]+)$/);
          DIR: for (my $d = 0; $d <= $#chmods; $d++) {
            chmod ($chmods[$d], $Path);

            FILE: for (my $f = 0; $f <= $#chmods; $f++) {
              unless (-R $File) {
                chmod ($chmods[$f], $File);
              } else {

                last FILE;
              }
            }

            last DIR if (-R $File);
          }
        } else {
          last;
        }
      }
    }
    unless (open(TEST, $D)) {
      close(TEST);
      return;
    }
  }

  if ($Permission eq "r") {
    for (my $i = 0; $i <= $#chmods; $i++) {
      unless (-R $D) {
        chmod ($chmods[$i], $D);
      } else {
        last;
      }
    }
    return unless (-R $D);
  } elsif ($Permission eq "w") {
    for (my $i = 0; $i <= $#chmods; $i++) {
      unless (-W $D) {
        chmod ($chmods[$i], $D);
      } else {
        last;
      }
    }
    return unless (-W $D);
  } elsif ($Permission eq "x") {
    for (my $i = 0; $i <= $#chmods; $i++) {
      unless (-X $D) {
        chmod ($chmods[$i], $D);
      } else {
        last;
      }
    }
    return unless (-X $D);
  }

  return 1;
}

###############################################################################
package SCRIPT;

###############################################################################
# Variables function
sub Variables {
  my ($Variables) = @_;
  open (SCRIPT, $0);
    my @SCRIPT = <SCRIPT>;
  close (SCRIPT);

  my $Perl = $SCRIPT[0];
     $Perl =~s/^#!//;

  my %Parse = (
    "PERL.PATH"          => "$Perl"                      || "/usr/bin/perl",
    "PERL.EXT"           => "$SYSTEM::EXT"               || "cgi",
    "UB.PATH"            => "$Variables->{'SCRIPTS'}"    || ".",
    "UB.CP.PATH"         => "$Variables->{'SCRIPTS'}"    || ".",
    "UB.SOURCES.PATH"    => "$Variables->{'SOURCES'}"    || "\$UB::PATH/Private/Sources",
    "UB.VARIABLES.PATH"  => "$Variables->{'VARIABLES'}"  || "\$UB::PATH/Private/Variables",
    "UB.LIBRARIES.PATH"  => "$Variables->{'LIBRARIES'}"  || "\$UB::PATH/Private/Sources/Libraries",
    "UB.INTERFACES.PATH" => "$Variables->{'INTERFACES'}" || "\$UB::PATH/Private/Interfaces"
  );

  return \%Parse;
}

###############################################################################
# Parse function
sub Parse {
  my ($Script, $Variables) = @_;
  open (SCRIPT, $Script);
    my $CONTENT = join ("", <SCRIPT>);
  close (SCRIPT);

  my $TAG_START = quotemeta("#%");
  my $TAG_END   = quotemeta("%#");

  $CONTENT =~s/$TAG_START([\w\.\-]+)$TAG_END/$Variables->{$1}/igs;

  open (SCRIPT, ">".$Script);
    print SCRIPT $CONTENT;
  close (SCRIPT);

  return 1;
}

###############################################################################
package HTML;

###############################################################################
# Top function
sub Top {
  my ($Step, $Title) = @_;

  my $HTML = <<HTML;
<html>
<head>
  <title>UltraBoard 2000 w˺F $Step</title>
  <meta http-equiv="Content-Type" content="text/html; charset=big5">
  <style type="text/css">
    <!--
      TD {
        font-family : Verdana, Geneva, Helvetica, Sans-Serif;
        color: #333333;
      }

      font.title {
        font-size   : x-small;
      }

      font.description {
        font-size   : x-small;
      }

      a.menu       {
        text-decoration: none;
        color: Black;
      }
      a.menu:hover {
        color: #0033CC;
        text-decoration: underline;
      }
    // -->
  </style>
</head>

<body>

<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td>
      <table width="100%" border="0" cellspacing="0" cellpadding="1" bgcolor="#333333">
        <tr>
          <td>
            <table width="100%" border="0" cellspacing="1" cellpadding="4">
              <tr bgcolor="#EEEEEE">
                <td><table width="100%" border="0" cellspacing="0" cellpadding="0">
                  <tr>
                    <td><font class="title"><b>UltraBoard 2000</b><br><font class="description">w˺F $Step</font></font></td>
                  </tr>
                </table></td>
              </tr>
            </table>
          </td>
        </tr>
      </table>
      <p>
      <table width="100%" border="0" cellspacing="0" cellpadding="1" bgcolor="#333333">
        <tr>
          <td>
            <table width="100%" border="0" cellspacing="1" cellpadding="4">
              <tr bgcolor="#CCCCCC">
                <td><font class="title"><b>$Title</b></font></td>
              </tr>
              <tr bgcolor="#EEEEEE">
                <td>
HTML
  $HTML =~s/\s+(.+\n)/$1/g;
  print $HTML;
}

###############################################################################
# Bottom function
sub Bottom {
  my $HTML = <<HTML;
                </td>
              </tr>
            </table>
          </td>
        </tr>
      </table>
    </td>
  </tr>
</table>

</body>
</html>
HTML
  $HTML =~s/\s+(.+\n)/$1/g;
  print $HTML;
}

###############################################################################
# Description function
sub Description {
  my ($Description, $ErrorDescription, $ErrorMessage) = @_;

  if ($ErrorMessage) {
    print<<HTML;
<font class="title">$ErrorDescription</font><br>
<table width="100%" border="0" cellspacing="2" cellpadding="2">
<tr><td><font class="title"><font color="#FF0000">$ErrorMessage</font></font></td></tr>
</table>
<font class="title">оAקAոլ!</font><p>
HTML
  }

  print<<HTML;
<font class="title">$Description</font>
HTML
}

###############################################################################
# Category function
sub Category {
  my ($Category) = @_;

  print<<HTML;
<table width="100%" border="0" cellspacing="2" cellpadding="2">
<tr>
  <td width="250" valign="top" nowrap>&nbsp;</td>
  <td width="100%" valign="top"><font class="title"><b>$Category</b></font></td>
</tr>
HTML
}

###############################################################################
# Blank function
sub Blank {
  print<<HTML;
<tr>
  <td width="100%" colspan="2" nowrap>&nbsp;</td>
</tr>
HTML
}

###############################################################################
package HTML::FORM;

###############################################################################
# TextField function
sub TextField {
  my %in = (
    TITLE       => "",
    DESCRIPTION => "",
    NAME        => "",
    VALUE       => "",
    REQUIRED    => "",

    MAXLENGTH   => "",
    SIZE        => "",

    @_
  );
  my $HTML;

  if ($in{'REQUIRED'}) {
    $in{'REQUIRED'}  = qq~ <font color="Red"><b>*</b></font>~;
  } else {
    $in{'REQUIRED'}  = qq~~;
  }

  $in{'MAXLENGTH'} = qq~ maxlength="$in{'MAXLENGTH'}"~      if $in{'MAXLENGTH'};
  $in{'SIZE'}      = qq~ size="$in{'SIZE'}"~                if $in{'SIZE'};

  if ($in{'DESCRIPTION'}) {
    $in{'DESCRIPTION'} =~ s/\"/\&quot\;/g;
    $in{'DESCRIPTION'} =~ s/\</&lt;/g;
    $in{'DESCRIPTION'} =~ s/\>/&gt;/g;
  }

$HTML = <<HTML;
<tr>
<td width="250" valign="top" nowrap><font class="title"><b>$in{'TITLE'}$in{'REQUIRED'}</b></font></td>
<td width="100%" valign="top"><input type="text" name="$in{'NAME'}" value="$in{'VALUE'}"$in{'SIZE'}$in{'MAXLENGTH'} style="width:100%" class="TextField"></td>
</tr>
<tr>
<td width="250" nowrap>&nbsp;</td>
<td width="100%" valign="top" bgcolor="#EEEEEE"><font class="description">&nbsp;^&nbsp;$in{'DESCRIPTION'}</font></td>
</tr>
HTML

  return $HTML;
}

###############################################################################
# PasswordField function
sub PasswordField {
  my %in = (
    TITLE       => "",
    DESCRIPTION => "",
    NAME        => "",
    VALUE       => "",
    REQUIRED    => "",

    MAXLENGTH   => "",
    SIZE        => "",

    @_
  );
  my $HTML;

  if ($in{'REQUIRED'}) {
    $in{'REQUIRED'}  = qq~ <font color="Red"><b>*</b></font>~;
  } else {
    $in{'REQUIRED'}  = qq~~;
  }

  $in{'MAXLENGTH'} = qq~ maxlength="$in{'MAXLENGTH'}"~      if $in{'MAXLENGTH'};
  $in{'SIZE'}      = qq~ size="$in{'SIZE'}"~                if $in{'SIZE'};

  if ($in{'DESCRIPTION'}) {
    $in{'DESCRIPTION'} =~ s/\"/\&quot\;/g;
    $in{'DESCRIPTION'} =~ s/\</&lt;/g;
    $in{'DESCRIPTION'} =~ s/\>/&gt;/g;
  }

$HTML = <<HTML;
<tr>
<td width="250" valign="top" nowrap><font class="title"><b>$in{'TITLE'}$in{'REQUIRED'}</b></font></td>
<td width="100%" valign="top"><input type="password" name="$in{'NAME'}" value="$in{'VALUE'}"$in{'SIZE'}$in{'MAXLENGTH'} style="width:100%" class="TextField"></td>
</tr>
<tr>
<td width="250" nowrap>&nbsp;</td>
<td width="100%" valign="top" bgcolor="#EEEEEE"><font class="description">&nbsp;^&nbsp;$in{'DESCRIPTION'}</font></td>
</tr>
HTML

  return $HTML;
}

###############################################################################
# TextArea function
sub TextArea {
  my %in = (
    TITLE       => "",
    DESCRIPTION => "",
    NAME        => "",
    VALUE       => "",
    REQUIRED    => "",

    COLS        => "30",
    ROWS        => "3" ,

    @_
  );
  my $HTML;

  if ($in{'REQUIRED'}) {
    $in{'REQUIRED'}  = qq~ <font color="Red"><b>*</b></font>~;
  } else {
    $in{'REQUIRED'}  = qq~~;
  }

  if ($in{'DESCRIPTION'}) {
    $in{'DESCRIPTION'} =~ s/\"/\&quot\;/g;
    $in{'DESCRIPTION'} =~ s/\</&lt;/g;
    $in{'DESCRIPTION'} =~ s/\>/&gt;/g;
  }

$HTML = <<HTML;
<tr>
<td width="250" valign="top" nowrap><font class="title"><b>$in{'TITLE'}$in{'REQUIRED'}</b></font></td>
<td width="100%" valign="top"><textarea cols="$in{'COLS'}" rows="$in{'ROWS'}" name="$in{'NAME'}" style="width:100%" class="TextArea">$in{'VALUE'}</textarea></td>
</tr>
<tr>
<td width="250" nowrap>&nbsp;</td>
<td width="100%" valign="top" bgcolor="#EEEEEE"><font class="description">&nbsp;^&nbsp;$in{'DESCRIPTION'}</font></td>
</tr>
HTML

  return $HTML;
}

###############################################################################
# Radio function
sub Radio {
  my %in = (
    TITLE       => "",
    DESCRIPTION => "",
    NAME        => "",
    VALUE       => [],
    SELECT      => "",
    REQUIRED    => "",
    WRAP        =>  1,
    @_
  );
  my $HTML;

  my $Radios;
  for (my $index = 0; $index <= $#{ $in{'VALUE'} }; $index++) {
    my $checked;
    $checked = " checked" if $in{'VALUE'}->[$index]{'VALUE'} eq $in{'SELECT'};
    $Radios .= "<tr>" if $in{'WRAP'} == 1;
    $Radios .= "<td width=\"20\" nowrap><input type=\"radio\" name=\"".$in{'NAME'}."\" value=\"".$in{'VALUE'}->[$index]{'VALUE'}."\"$checked></td>";
    $Radios .= "<td nowrap><font class=\"title\">".$in{'VALUE'}->[$index]{'TITLE'}."</font></td>";
    $Radios .= "</tr>" if $in{'WRAP'} == 1;
  }
  $Radios = "<tr>".$Radios."<td width=\"100%\" nowrap></td></tr>" if $in{'WRAP'} != 1;

  if ($in{'REQUIRED'}) {
    $in{'REQUIRED'}  = qq~ <font color="Red"><b>*</b></font>~;
  } else {
    $in{'REQUIRED'}  = qq~~;
  }

  $in{'CHECKED'}  = qq~ checked~ if $in{'VALUE'};

  if ($in{'DESCRIPTION'}) {
    $in{'DESCRIPTION'} =~ s/\"/\&quot\;/g;
    $in{'DESCRIPTION'} =~ s/\</&lt;/g;
    $in{'DESCRIPTION'} =~ s/\>/&gt;/g;
  }

$HTML = <<HTML;
<tr>
<td width="250" valign="top" nowrap><font class="title"><b>$in{'TITLE'}$in{'REQUIRED'}</b></font></td>
<td width="100%" valign="top"><table width="100%" border="0" cellspacing="0" cellpadding="0">$Radios</table></td>
</tr>
<tr>
<td width="250" nowrap>&nbsp;</td>
<td width="100%" valign="top" bgcolor="#EEEEEE"><font class="description">&nbsp;^&nbsp;$in{'DESCRIPTION'}</font></td>
</tr>
HTML

  return $HTML;
}