#!#%PERL.PATH%#

###############################################################################
# Others.cgi                                                                  #
###############################################################################
# UltraBoard 2000 by UltraScripts.com, Inc.                                   #
# Scripts written by Jacky Wing Wa Yung, WebMaster@UltraScripts.com           #
# Available from http://www.UltraBoard.org/                                   #
# =========================================================================== #
# COPYRIGHT NOTICE :                                                          #
#                                                                             #
# Copyright (c) 1999-2000 UltraScripts.com, Inc. All Rights Reserved.         #
#                                                                             #
# This program is being distributed as shareware. It may be used and modified #
# free for personal, government or non-profit. Any commercial use must be     #
# registered. However, modified versions cannot be sold or distributed. You   #
# cannot alter the copyright and "powered by" notices throughout the scripts. #
# These notices must be clearly visible to the end users.                     #
#                                                                             #
# WARRANTY DISCLAIMER:                                                        #
#                                                                             #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT #
# ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR       #
# FITNESS FOR A PARTICULAR PURPOSE.                                           #
###############################################################################

package UB;

use strict;

BEGIN {
  # if you having problem on the script, set $UB::PATH to the full path to your
  # ultraboard directory.
  $UB::PATH    = "#%UB.PATH%#";

  $SYSTEM::EXT = "#%PERL.EXT%#" || $ENV{'SCRIPT_NAME'} || $ENV{'SCRIPT_FILENAME'} || $0;
  $SYSTEM::EXT =~s/^.+\.(\w+)$/$1/g;

  ($0 =~ m/(.*)\/[^\/]+/) && unshift (@INC, "$1");
  ($0 =~ m/(.*)\\[^\\]+/) && unshift (@INC, "$1");

  eval {
    unless (-e $UB::PATH."/Others.$SYSTEM::EXT") {
      foreach my $P ( $ENV{'SCRIPT_FILENAME'}, $ENV{'PATH_TRANSLATED'}, $ENV{'DOCUMENT_ROOT'}.$ENV{'SCRIPT_NAME'}, $0 ) {
        $P =~s/\\/\//g;
        $P =~s/(.*)\/[^\/]+/$1/g;
        if (-e $P."/Others.$SYSTEM::EXT") {
          $UB::PATH = $P;
          last;
        }
      }
    }
  };

  unshift (@INC, "$UB::PATH");
}

# required using at least perl v5.004.
eval {
  require 5.004;
} || &UB::CGIError("Can't load the perl v5.004 or higher version. $@", "");

###############################################################################
# Variables

$| = 1;

$UB::VERSION         = "2.00";

$UB::SOURCES_PATH    = "$UB::PATH/Private/Sources";
$UB::VARIABLES_PATH  = "$UB::PATH/Private/Variables";
$UB::LIBRARIES_PATH  = "$UB::SOURCES_PATH/Libraries";
$UB::INTERFACES_PATH = "$UB::PATH/Private/Interfaces";

$UB::CONTENT_TYPE    = 0;

%UB::MEMBER          = ();
@UB::COOKIES         = ();
%UB::QUERY           = &ParseForm();

###############################################################################
# Loading Required Libraries

unless (my $Return = do "$UB::VARIABLES_PATH/System.cfg") {
  &UB::CGIError("Couldn't parse system variables. $@", "$UB::VARIABLES_PATH/System.cfg") if ($@);
  &UB::CGIError("Couldn't do system variables. $_"   , "$UB::VARIABLES_PATH/System.cfg") unless (defined $Return);
  &UB::CGIError("Couldn't run system variables."     , "$UB::VARIABLES_PATH/System.cfg") unless ($Return);
}

# error running main function
eval { &UB::Main } || &UB::CGIError("Can't run your request. $@", "");

exit;

###############################################################################
# Main function
# - function of executing all functions
sub Main {
  if ( ($UB::QUERY{'action'} eq "HTML") && ($UB::QUERY{'BID'} ne "") && ($UB::QUERY{'HID'} ne "") ) {
    if ($UB::QUERY{'TMP'}) {
      open  (HTML, $SYSTEM::TEMP_PATH."/B".$UB::QUERY{'BID'}."-".$UB::QUERY{'TMP'}."-".$UB::QUERY{'HID'}.".html");
        print "Content-type: text/html\n\n";
        print join ("", <HTML>);
      close (HTML);
    } else {
      open  (HTML, $SYSTEM::DB_PATH."/B".$UB::QUERY{'BID'}."/".$UB::QUERY{'PID'}."-".$UB::QUERY{'HID'}.".html");
        print "Content-type: text/html\n\n";
        print join ("", <HTML>);
      close (HTML);
    }
  } elsif ( ($UB::QUERY{'action'} eq "Help") && ($UB::QUERY{'HID'} ne "") ) {
    unless (my $Return = do "$UB::VARIABLES_PATH/General.cfg") {
      &UB::CGIError("Couldn't parse general variables. $@", "$UB::VARIABLES_PATH/General.cfg") if ($@);
      &UB::CGIError("Couldn't do general variables. $_"   , "$UB::VARIABLES_PATH/General.cfg") unless (defined $Return);
      &UB::CGIError("Couldn't run general variables"      , "$UB::VARIABLES_PATH/General.cfg") unless ($Return);
    }

    unless (my $Return = do "$SYSTEM::THEME_PATH/$SYSTEM::DEFAULT_THEME/Style/Style.cfg") {
      &UB::CGIError("Couldn't parse style variables. $@", "$SYSTEM::THEME_PATH/$SYSTEM::DEFAULT_THEME/Style/Style.cfg") if ($@);
      &UB::CGIError("Couldn't do style variables. $_"   , "$SYSTEM::THEME_PATH/$SYSTEM::DEFAULT_THEME/Style/Style.cfg") unless (defined $Return);
      &UB::CGIError("Couldn't run style variables"      , "$SYSTEM::THEME_PATH/$SYSTEM::DEFAULT_THEME/Style/Style.cfg") unless ($Return);
    }

    require "$UB::SOURCES_PATH/UB_Help.pl";
    &Source::Help;
  }
}

###############################################################################
# CGIError function
# - function of display error message with form and environment information during internal error.
sub CGIError {
  my ($message, $path) = @_;

  my ($key, $space);

  # checking the html header is it printed
  unless ($UB::CONTENT_TYPE == 1) {
    print "Content-type: text/html\n\n";
    $UB::CONTENT_TYPE = 1;
  }

  print "<html>\n";
  print "<head>\n";
  print "<title>CGI Script Error</title>\n";
  print "</head>\n";
  print "<body>\n";
  print "<font face=\"Verdana\">\n";
  print "<font size=\"4\"><b>CGI Script Error</b></font><p>\n";
  print "<font size=\"2\">\n";

  # printing error message
  $message =~ s/\n/<br>\n/g;
  $message and print $message;
  print "<p>";

  # printing general infomation
  print "<font size=\"4\"><b>General Infomation</b></font><p>\n";
  print "<table cellpadding=\"0\" cellspacing=\"0\">\n";

  if ($path) {
    $path =~ s/\\/\//g;
    print "<tr>\n";
    print "<td width=\"200\" valign=\"TOP\"><font face=\"Verdana\" size=\"2\"><b>Error Path</b></font></td>\n";
    print "<td><font face=\"Verdana\" size=\"2\">$path</font></td>\n";
    print "</tr>\n";
  }
  if ($0) {
    $0 =~ s/\\/\//g;
    print "<tr>\n";
    print "<td width=\"200\" valign=\"TOP\"><font face=\"Verdana\" size=\"2\"><b>Script Path</b></font></td>\n";
    print "<td><font face=\"Verdana\" size=\"2\">$0</font></td>\n";
    print "</tr>\n";
  }
  if ($]) {
    print "<tr>\n";
    print "<td width=\"200\" valign=\"TOP\"><font face=\"Verdana\" size=\"2\"><b>Perl Version</b></font></td>\n";
    print "<td><font face=\"Verdana\" size=\"2\">$]</font></td>\n";
    print "</tr>\n";
  }
  if ($CGI::VERSION) {
    print "<tr>\n";
    print "<td width=\"200\" valign=\"TOP\"><font face=\"Verdana\" size=\"2\"><b>CGI.pm Version</b></font></td>\n";
    print "<td><font face=\"Verdana\" size=\"2\">$CGI::VERSION</font></td>\n";
    print "</tr>\n";
  }
  print "</table><p>\n";

  if (defined %UB::QUERY) {
    # printing form variables
    print "<font size=\"4\"><b>Form Variables</b></font><p>\n";
    print "<table cellpadding=\"0\" cellspacing=\"0\">\n";
    foreach my $KEY (sort keys %UB::QUERY) {
      print "<tr>\n";
      print "<td width=\"200\" valign=\"TOP\"><font face=\"Verdana\" size=\"2\"><b>$KEY</b></font></td>\n";
      print "<td><font face=\"Verdana\" size=\"2\">".$UB::QUERY{$KEY}."</font></td>\n";
      print "</tr>\n";
    }
    print "</table><p>\n";
  }


  # printing environment variables
  print "<font size=\"4\"><b>Environment Variables</b></font><p>\n";
  print "<table cellpadding=\"0\" cellspacing=\"0\">\n";
  foreach $key (sort keys %ENV) {
    print "<tr>\n";
    print "<td width=\"200\" valign=\"TOP\"><font face=\"Verdana\" size=\"2\"><b>$key</b></font></td>\n";
    print "<td><font face=\"Verdana\" size=\"2\">".$ENV{$key}."</font></td>\n";
    print "</tr>\n";
  }
  print "</table><p>\n";
  print "</font>\n";
  print "</font>\n";
  print "</body>\n";
  print "</html>\n";

  exit;
}

###############################################################################
# ParseForm
sub ParseForm {
  my ($Buffer, @Pairs, $Pair, $Name, $Value);
  my %in;

  if($ENV{'REQUEST_METHOD'} eq "POST"){
      read(STDIN, $Buffer, $ENV{'CONTENT_LENGTH'});
  }elsif($ENV{'REQUEST_METHOD'} eq "GET"){
    $Buffer=$ENV{'QUERY_STRING'};
  }

  @Pairs = split(/&/, $Buffer);
  foreach $Pair (@Pairs) {
    ($Name, $Value) = split(/=/, $Pair);
    $Value =~ tr/+/ /;
    $Value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $Value =~ s/\r//g;
    $Value =~ s/^\s+//g;
    $Value =~ s/\s+$//g;
    $in{$Name} = $Value;
  }

  return %in;
}

package HTML;

sub Error {
  my %args = (
    CODE    => "",
    MESSAGE => "",
    @_
  );

  require "$UB::INTERFACES_PATH/$SYSTEM::DEFAULT_THEME/UB_Error.src";

  my %FORM = (
    "ERROR.MESSAGE" => $Error::DYNAMIC{"LANGUAGE.".$args{'CODE'}} || $args{'MESSAGE'}
  );

  print "Content-type: text/html\n\n";
  print &Error::Parse(\%FORM);
  exit;
}