###############################################################################
# CP_DoModifyBoard.pl                                                         #
###############################################################################
# UltraBoard 2000 by UltraScripts.com, Inc.                                   #
# Scripts written by Jacky Wing Wa Yung, WebMaster@UltraScripts.com           #
# Available from http://www.UltraBoard.org/                                   #
# =========================================================================== #
# COPYRIGHT NOTICE :                                                          #
#                                                                             #
# Copyright (c) 1999-2000 UltraScripts.com, Inc. All Rights Reserved.         #
#                                                                             #
# This program is being distributed as shareware. It may be used and modified #
# free for personal, government or non-profit. Any commercial use must be     #
# registered. However, modified versions cannot be sold or distributed. You   #
# cannot alter the copyright and "powered by" notices throughout the scripts. #
# These notices must be clearly visible to the end users.                     #
#                                                                             #
# WARRANTY DISCLAIMER:                                                        #
#                                                                             #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT #
# ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR       #
# FITNESS FOR A PARTICULAR PURPOSE.                                           #
###############################################################################

package Source;

use strict;

sub DoModifyBoard {

# =========================================================================== #
# Verify Variables

  # checking missing fields
  if ($UB::QUERY{'FORM_TITLE'}    eq "") { &Error("zѤFJ \"ݪOW\" .") };
  if ($UB::QUERY{'FORM_CATEGORY'} eq "") { &Error("zѤFJ \"ݪO\" .") };

  # checking length of fields
  if (length($UB::QUERY{'FORM_TITLE'}) > 128) {
    &Error("\"ݪOW\" 椣iWL 128 r.");
  }

  if (length($UB::QUERY{'FORM_DESCRIPTION'}) > 512) {
    &Error("\"ݪO\" 椣iWL 512 r.");
  }

# =========================================================================== #
# Assign Variables

  my %FORM;

  $FORM{'TITLE'}            = $UB::QUERY{'FORM_TITLE'};
  $FORM{'TITLE'}            = &Standard::EncodeHTML($FORM{'TITLE'});

  $FORM{'DESCRIPTION'}      = $UB::QUERY{'FORM_DESCRIPTION'};
  $FORM{'DESCRIPTION'}      = &Standard::EncodeHTML($FORM{'DESCRIPTION'});

  $FORM{'CATEGORY'}         = $UB::QUERY{'FORM_CATEGORY'};

  $FORM{'MAJOR_MODERATOR'}  = $UB::QUERY{'FORM_MAJOR_MODERATOR'};

  if ($FORM{'MAJOR_MODERATOR'} ne "") {
    if (
      my ($Profile) = &DB::BinarySelect (
        TABLE   => "Accounts",
        COLUMNS => ["USERNAME", "NICKNAME", "EMAIL"],
        KEY     => $FORM{'MAJOR_MODERATOR'}
      )
    ) {
      $FORM{'MAJOR_MODERATOR_NICKNAME'} = $Profile->{'NICKNAME'};
      $FORM{'MAJOR_MODERATOR_EMAIL'}    = $Profile->{'EMAIL'};
    } else {
      &HTML::Error("Ʈw~", $DB::Error);
    }
  }

  $FORM{'MINOR_MODERATORS'} = join ( ",", $UB::CGI->param('FORM_MINOR_MODERATORS') );

  if (
    ($UB::QUERY{'FORM_STATUS'} eq          "70")  ||  # id of activated status
    ($UB::QUERY{'FORM_STATUS'} eq    "Activate")
  ) {
    $FORM{'STATUS'}   = 70;                                 # id of activated status
  } elsif (
    ($UB::QUERY{'FORM_STATUS'} eq            "50")  ||  # id of activated status
    ($UB::QUERY{'FORM_STATUS'} eq "OnlyActivate")
  ) {
    $FORM{'STATUS'}   = 50;                                 # id of only activated status
  } else {
    $FORM{'STATUS'}   = 30;                                 # id of deactivated status
  }

  $FORM{'HEADER'} = $UB::QUERY{'FORM_HEADER'};

  $FORM{'FOOTER'} = $UB::QUERY{'FORM_FOOTER'};

  if (
    ($UB::QUERY{'FORM_ULTRABOARD_CODES'} eq "1" ) ||
    ($UB::QUERY{'FORM_ULTRABOARD_CODES'} eq "on")
  ) {
    $FORM{'UB_CODES'} = 1;
    if (
      ($UB::QUERY{'FORM_HTML_TAGS'} eq "1" ) ||
      ($UB::QUERY{'FORM_HTML_TAGS'} eq "on")
    ) {
      $FORM{'HTML_TAGS'} = 1;
    }
  }

  if (
    ($UB::QUERY{'FORM_FILE_ATTACH'} eq "1" ) ||
    ($UB::QUERY{'FORM_FILE_ATTACH'} eq "on")
  ) {
    $FORM{'FILE_ATTACH'} = 1;
  }

  if (
    ($UB::QUERY{'FORM_SUBSCRIPTION'} eq "1" ) ||
    ($UB::QUERY{'FORM_SUBSCRIPTION'} eq "on")
  ) {
    $FORM{'SUBSCRIPTION'} = 1;
  }

  if (
    ($UB::QUERY{'FORM_APPROVED'} eq "1" ) ||
    ($UB::QUERY{'FORM_APPROVED'} eq "on")
  ) {
    $FORM{'NEED_APROVED'} = 1;
  }

  if (
    ($UB::QUERY{'FORM_EXPIRE'} eq "1" ) ||
    ($UB::QUERY{'FORM_EXPIRE'} eq "on")
  ) {
    if ($UB::QUERY{'FORM_EXPIRE_DAYS'} =~ /^\d+$/) {
      $FORM{'EXPIRE'} = $UB::QUERY{'FORM_EXPIRE_DAYS'};
    }
  }

  ($FORM{'TITLE'}, $FORM{'DESCRIPTION'}) = &Standard::WordFilter($FORM{'TITLE'}, $FORM{'DESCRIPTION'});

# =========================================================================== #
# Update Board from Database

  my $ID = $UB::QUERY{'BID'};

  (
    &DB::Update (
      TABLE  => "Boards",
      VALUES => {
        TITLE                     => $FORM{'TITLE'}                   ||   "",
        DESCRIPTION               => $FORM{'DESCRIPTION'}             ||   "",
        CATEGORY                  => $FORM{'CATEGORY'}                ||   "",
        MAJOR_MODERATOR           => $FORM{'MAJOR_MODERATOR'}         ||   "",
        MAJOR_MODERATOR_NICKNAME  => $FORM{'MAJOR_MODERATOR_NICKNAME'}||   "",
        MAJOR_MODERATOR_EMAIL     => $FORM{'MAJOR_MODERATOR_EMAIL'}   ||   "",
        MINOR_MODERATORS          => $FORM{'MINOR_MODERATORS'}        ||   "",
        STATUS                    => $FORM{'STATUS'}                  || "30",
        UB_CODES                  => $FORM{'UB_CODES'}                ||  "0",
        HTML_TAGS                 => $FORM{'HTML_TAGS'}               ||  "0",
        NEED_APROVED              => $FORM{'NEED_APROVED'}            ||  "0",
        SUBSCRIPTION              => $FORM{'SUBSCRIPTION'}            ||  "0",
        FILE_ATTACH               => $FORM{'FILE_ATTACH'}             ||  "0",
        EXPIRE                    => $FORM{'EXPIRE'}                  ||  "0"

      },
      KEY    => $ID
    )
  ) || &HTML::Error("Ʈw~", $DB::Error);

  &Standard::lock("file.lock") if ($SYSTEM::FLOCK == 1);

  chmod (0777, $SYSTEM::DB_PATH."/B$ID");

  &Standard::FileOpen(*TEXT, "w", "$SYSTEM::DB_PATH/B$ID/header.inc");
    print TEXT $FORM{'HEADER'};
  close (TEXT);

  &Standard::FileOpen(*TEXT, "w", "$SYSTEM::DB_PATH/B$ID/footer.inc");
    print TEXT $FORM{'FOOTER'};
  close (TEXT);

  if (
    ($UB::QUERY{'FORM_POST_LEVEL_00'} eq "1"  ) ||
    ($UB::QUERY{'FORM_POST_LEVEL_00'} eq "on" ) ||
    ($UB::QUERY{'FORM_POST_LEVEL_00'} eq "y"  ) ||
    ($UB::QUERY{'FORM_POST_LEVEL_00'} eq "yes")
  ) {
    &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/READ-LEVEL-00.dat");
      print DATA "*";
    close (DATA);
    &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/READ-LEVEL-30.dat");
      print DATA "*";
    close (DATA);
    &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/READ-LEVEL-50.dat");
      print DATA "*";
    close (DATA);

    &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/REPLY-LEVEL-00.dat");
      print DATA "*";
    close (DATA);
    &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/REPLY-LEVEL-30.dat");
      print DATA "*";
    close (DATA);
    &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/REPLY-LEVEL-50.dat");
      print DATA "*";
    close (DATA);

    &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/POST-LEVEL-00.dat");
      print DATA "*";
    close (DATA);
    &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/POST-LEVEL-30.dat");
      print DATA "*";
    close (DATA);
    &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/POST-LEVEL-50.dat");
      print DATA "*";
    close (DATA);
  } elsif (
    ($UB::QUERY{'FORM_READ_LEVEL_50'} eq ""  )
  ) {
    &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/READ-LEVEL-00.dat");
    close (DATA);
    &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/READ-LEVEL-30.dat");
    close (DATA);
    &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/READ-LEVEL-50.dat");
    close (DATA);

    &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/REPLY-LEVEL-00.dat");
    close (DATA);
    &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/REPLY-LEVEL-30.dat");
    close (DATA);
    &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/REPLY-LEVEL-50.dat");
    close (DATA);

    &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/POST-LEVEL-00.dat");
    close (DATA);
    &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/POST-LEVEL-30.dat");
    close (DATA);
    &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/POST-LEVEL-50.dat");
    close (DATA);
  } else {
    my @Permission;
    my %Level;

    if ($UB::QUERY{'FORM_READ_LEVEL_00'} eq "1") {
      &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/READ-LEVEL-00.dat");
        print DATA "*";
      close (DATA);
      &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/READ-LEVEL-30.dat");
        print DATA "*";
      close (DATA);
      &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/READ-LEVEL-50.dat");
        print DATA "*";
      close (DATA);
    } else {
      &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/READ-LEVEL-00.dat");
      close (DATA);

      if ( # checking the reading permission of normal member groups
        ($UB::QUERY{'FORM_READ_LEVEL_30'} eq "1"  ) ||
        ($UB::QUERY{'FORM_READ_LEVEL_30'} eq "on" ) ||
        ($UB::QUERY{'FORM_READ_LEVEL_30'} eq "y"  ) ||
        ($UB::QUERY{'FORM_READ_LEVEL_30'} eq "yes")
      ) {
        my @Input = $UB::CGI->param('FORM_READ_GROUP_30');
        &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/READ-LEVEL-30.dat");
          if ($#Input != -1) {
            if ($Input[0] eq "*") {
              print DATA "*";
            } else {
              print DATA join ( "\n", @Input );
            }
          }
        close (DATA);
      } else {
        &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/READ-LEVEL-30.dat");
        close (DATA);
      }

      if ( # checking the reading permission of premium member groups
        ($UB::QUERY{'FORM_READ_LEVEL_50'} eq "1"  ) ||
        ($UB::QUERY{'FORM_READ_LEVEL_50'} eq "on" ) ||
        ($UB::QUERY{'FORM_READ_LEVEL_50'} eq "y"  ) ||
        ($UB::QUERY{'FORM_READ_LEVEL_50'} eq "yes")
      ) {
        my @Input = $UB::CGI->param('FORM_READ_GROUP_50');
        &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/READ-LEVEL-50.dat");
          if ($#Input != -1) {
            if ($Input[0] eq "*") {
              print DATA "*";
            } else {
              print DATA join ( "\n", @Input );
            }
          }
        close (DATA);
      } else {
        &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/READ-LEVEL-50.dat");
        close (DATA);
      }
    }

    if ($UB::QUERY{'FORM_REPLY_LEVEL_00'} eq "1") {
      &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/REPLY-LEVEL-00.dat");
        print DATA "*";
      close (DATA);
      &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/REPLY-LEVEL-30.dat");
        print DATA "*";
      close (DATA);
      &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/REPLY-LEVEL-50.dat");
        print DATA "*";
      close (DATA);
    } else {
      &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/REPLY-LEVEL-00.dat");
      close (DATA);

      if ( # posting replies permission of normal member groups
        ($UB::QUERY{'FORM_REPLY_LEVEL_30'} eq "1"  ) ||
        ($UB::QUERY{'FORM_REPLY_LEVEL_30'} eq "on" ) ||
        ($UB::QUERY{'FORM_REPLY_LEVEL_30'} eq "y"  ) ||
        ($UB::QUERY{'FORM_REPLY_LEVEL_30'} eq "yes")
      ) {
        my @Input = $UB::CGI->param('FORM_REPLY_GROUP_30');
        &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/REPLY-LEVEL-30.dat");
          if ($#Input != -1) {
            if ($Input[0] eq "*") {
              print DATA "*";
            } else {
              print DATA join ( "\n", @Input );
            }
          }
        close (DATA);
      } else {
        &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/REPLY-LEVEL-30.dat");
        close (DATA);
      }

      if ( # posting replies permission of premium member groups
        ($UB::QUERY{'FORM_REPLY_LEVEL_50'} eq "1"  ) ||
        ($UB::QUERY{'FORM_REPLY_LEVEL_50'} eq "on" ) ||
        ($UB::QUERY{'FORM_REPLY_LEVEL_50'} eq "y"  ) ||
        ($UB::QUERY{'FORM_REPLY_LEVEL_50'} eq "yes")
      ) {
        my @Input = $UB::CGI->param('FORM_REPLY_GROUP_50');
        &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/REPLY-LEVEL-50.dat");
          if ($#Input != -1) {
            if ($Input[0] eq "*") {
              print DATA "*";
            } else {
              print DATA join ( "\n", @Input );
            }
          }
        close (DATA);
      } else {
        &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/REPLY-LEVEL-50.dat");
        close (DATA);
      }
    }

    &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/POST-LEVEL-00.dat");
    close (DATA);

    # posting topics permission of normal member groups
    if ($UB::QUERY{'FORM_POST_LEVEL_30'} eq "1") {
      my @Input = $UB::CGI->param('FORM_POST_GROUP_30');
      &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/POST-LEVEL-30.dat");
        if ($#Input != -1) {
          if ($Input[0] eq "*") {
            print DATA "*";
          } else {
            print DATA join ( "\n", @Input );
          }
        }
      close (DATA);
    } else {
      &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/POST-LEVEL-30.dat");
      close (DATA);
    }

    # posting topics permission of normal premium groups
    if ($UB::QUERY{'FORM_POST_LEVEL_50'} eq "1") {
      my @Input = $UB::CGI->param('FORM_POST_GROUP_50');
      &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/POST-LEVEL-50.dat");
        if ($#Input != -1) {
          if ($Input[0] eq "*") {
            print DATA "*";
          } else {
            print DATA join ( "\n", @Input );
          }
        }
      close (DATA);
    } else {
      &Standard::FileOpen(*DATA, "w", "$SYSTEM::DB_PATH/B$ID/POST-LEVEL-50.dat");
      close (DATA);
    }
  }

  &Standard::unLock("file.lock") if ($SYSTEM::FLOCK == 1);

  &Success(\%FORM);
}

###############################################################################
# Error function
# - function of printing error message of modifying board
sub Error {
  my ($message) = @_;

  require "$UB::SOURCES_PATH/CP_ModifyBoard.pl";
  &Source::ModifyBoard($message);

  exit;
}

###############################################################################
# Success function
# - function of printing success message of modifying board
sub Success {
  my ($FORM) = @_;

  ( # querying data from categories table
    my ($DB) = &DB::BinarySelect (
      TABLE   => "Categories",
      COLUMNS => ["ID", "TITLE"],
      KEY     => $FORM->{'CATEGORY'}
    )
  ) || &HTML::Error("ݪO޲z / קݪO", "ثeSiܪݪO.<br>p, z <a href=\"$SYSTEM::CP_URL/Panel.$SYSTEM::EXT?action=CreateCategory\" target=\"UBBODY\">إ߷sݪO</a>!");

  my $Category = $DB->{'TITLE'};

  my %Status = (
    30 => "",
    50 => "ϥΪ̥i",
    70 => "ҥ"
  );

  &Standard::PrintHTMLHeader();
  print &HTML::Header;
  print<<HTML;
<table width="100%" border="0" cellspacing="0" cellpadding="5">
  <tr bgcolor="Gray">
    <td><font color="White"><b>
      <a href="$SYSTEM::CP_URL/Panel.$SYSTEM::EXT?action=body" target="UBBODY" class="address">x</a> / ݪO޲z / קݪO
    </b></font></td>
  </tr>
</table>
<table width="100%" border="0" cellspacing="0" cellpadding="3">
  <tr>
    <td>
      <table width="100%" border="0" cellspacing="0" cellpadding="2">
        <tr>
          <td>
            <table width="100%" border="1" cellspacing="0" cellpadding="3" bordercolordark="White" bordercolorlight="Gray">
              <tr>
                <td>
                  <table width="100%" border="0" cellspacing="0" cellpadding="2">
                    <tr>
                      <td>ݪOwإߧ, HUOoӬݪOT.</td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table>
            &nbsp;<br>
            &nbsp;&nbsp;@T
            <table width="100%" border="1" cellspacing="0" cellpadding="3" bordercolordark="White" bordercolorlight="Gray">
              <tr>
                <td>
                  <table width="100%" border="0" cellspacing="0" cellpadding="2">
                    <tr>
                      <td width="100" valign="top" nowrap>ݪOW</td>
                      <td width="100%">$FORM->{'TITLE'}</td>
                    </tr>
                    <tr>
                      <td width="100" valign="top" nowrap>ݪO</td>
                      <td width="100%">$FORM->{'DESCRIPTION'}</td>
                    </tr>
                    <tr>
                      <td width="100" valign="top" nowrap>ݪO</td>
                      <td width="100%">$Category</td>
                    </tr>
                    <tr>
                      <td width="100" valign="top" nowrap>D</td>
                      <td width="100%">$FORM->{'MAJOR_MODERATOR'}</td>
                    </tr>
                    <tr>
                      <td width="100" valign="top" nowrap>ƪD</td>
                      <td width="100%">$FORM->{'MINOR_MODERATORS'}</td>
                    </tr>
                    <tr>
                      <td width="100" valign="top" nowrap>A</td>
                      <td width="100%">$Status{ $FORM->{'STATUS'} }</td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table>
          </td>
        </tr>
      </table>
    </td>
  </tr>
</table>
</body>
</html>
HTML

  exit;
}

###############################################################################
1; # end of CP_DoModifyBoard.pl file
###############################################################################