###############################################################################
# CP_DoRemoveAccounts.pl                                                      #
###############################################################################
# UltraBoard 2000 by UltraScripts.com, Inc.                                   #
# Scripts written by Jacky Wing Wa Yung, WebMaster@UltraScripts.com           #
# Available from http://www.UltraBoard.org/                                   #
# =========================================================================== #
# COPYRIGHT NOTICE :                                                          #
#                                                                             #
# Copyright (c) 1999-2000 UltraScripts.com, Inc. All Rights Reserved.         #
#                                                                             #
# This program is being distributed as shareware. It may be used and modified #
# free for personal, government or non-profit. Any commercial use must be     #
# registered. However, modified versions cannot be sold or distributed. You   #
# cannot alter the copyright and "powered by" notices throughout the scripts. #
# These notices must be clearly visible to the end users.                     #
#                                                                             #
# WARRANTY DISCLAIMER:                                                        #
#                                                                             #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT #
# ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR       #
# FITNESS FOR A PARTICULAR PURPOSE.                                           #
###############################################################################

package Source;

use strict;

sub DoRemoveAccounts {

# =========================================================================== #
# Remove members accounts from Database

  my @Index;
  my @UIDS = $UB::CGI->param('UID');
  for (my $i = 0; $i <= $#UIDS; $i++) {
    (
      my ($Accounts) = &DB::BinarySelect (
        TABLE   => "Accounts",
        COLUMNS => ["USERNAME", "NICKNAME", "EMAIL", "GROUP"],
        KEY     => $UIDS[$i]
      )
    ) || &HTML::Error("Ʈw~", $DB::Error);

    push (@Index , $UIDS[$i]);
    &Standard::UpdateFromList($SYSTEM::DB_PATH."/accounts.username", $Accounts->{'USERNAME'}, "");
    &Standard::UpdateFromList($SYSTEM::DB_PATH."/accounts.nickname", $Accounts->{'NICKNAME'}, "");
    &Standard::UpdateFromList($SYSTEM::DB_PATH."/accounts.email"   , $Accounts->{'EMAIL'}   , "");

    (
      &DB::Update (
        TABLE   => "Groups",
        VALUES  => {
          TOTAL_MEMBERS => "--\${TOTAL_MEMBERS}"
        },
        KEY     => $Accounts->{'GROUP'}
      )
    ) || &HTML::Error("Ʈw~", $DB::Error);
  }

  (
    &DB::Delete (
      TABLE  => "Accounts",
      KEYS   => \@Index
    )
  ) || &HTML::Error("Ʈw~", $DB::Error);

  (
    &DB::Delete (
      TABLE  => "Profiles",
      KEYS   => \@Index
    )
  ) || &HTML::Error("Ʈw~", $DB::Error);

  &Success();
}

###############################################################################
# Success function
# - function of printing success message of removing members accounts
sub Success {
  &Standard::PrintHTMLHeader();
  print &HTML::Header;
  print<<HTML;
<table width="100%" border="0" cellspacing="0" cellpadding="5">
  <tr bgcolor="Gray">
    <td><font color="White"><b>
      <a href="$SYSTEM::CP_URL/Panel.$SYSTEM::EXT?action=body" target="UBBODY" class="address">x</a> / ϥΪ̱b޲z / ϥΪ̱b
    </b></font></td>
  </tr>
</table>
<table width="100%" border="0" cellspacing="0" cellpadding="3">
  <tr>
    <td>
      <table width="100%" border="0" cellspacing="0" cellpadding="2">
        <tr>
          <td>
            <table width="100%" border="1" cellspacing="0" cellpadding="3" bordercolordark="White" bordercolorlight="Gray">
              <tr>
                <td>
                  <table width="100%" border="0" cellspacing="0" cellpadding="2">
                    <tr>
                      <td>HWϥΪ̱bwQ.</td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table>
          </td>
        </tr>
      </table>
    </td>
  </tr>
</table>
</body>
</html>
HTML

  exit;
}

###############################################################################
1; # end of CP_DoRemoveAccounts.pl file
###############################################################################