###############################################################################
# Cfg.lib.pl                                                                  #
###############################################################################
# UltraBoard 2000 by UltraScripts.com, Inc.                                   #
# Scripts written by Jacky Wing Wa Yung, WebMaster@UltraScripts.com           #
# Available from http://www.UltraBoard.org/                                   #
# =========================================================================== #
# COPYRIGHT NOTICE :                                                          #
#                                                                             #
# Copyright (c) 1999-2000 UltraScripts.com, Inc. All Rights Reserved.         #
#                                                                             #
# This program is being distributed as shareware. It may be used and modified #
# free for personal, government or non-profit. Any commercial use must be     #
# registered. However, modified versions cannot be sold or distributed. You   #
# cannot alter the copyright and "powered by" notices throughout the scripts. #
# These notices must be clearly visible to the end users.                     #
#                                                                             #
# WARRANTY DISCLAIMER:                                                        #
#                                                                             #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT #
# ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR       #
# FITNESS FOR A PARTICULAR PURPOSE.                                           #
###############################################################################
package Source;

use strict;

sub TextField {
  my %in = (
    TITLE       => "",
    DESCRIPTION => "",
    NAME        => "",
    VALUE       => "",
    REQUIRED    => "",

    MAXLENGTH   => "",
    SIZE        => "",

    @_
  );
  my $HTML;

  if ($in{'REQUIRED'}) {
    $in{'REQUIRED'}  = qq~ <font color="Red"><b>*</b></font>~;
  } else {
    $in{'REQUIRED'}  = qq~~;
  }

  $in{'MAXLENGTH'} = qq~ maxlength="$in{'MAXLENGTH'}"~      if $in{'MAXLENGTH'};
  $in{'SIZE'}      = qq~ size="$in{'SIZE'}"~                if $in{'SIZE'};

  if ($in{'DESCRIPTION'}) {
    $in{'DESCRIPTION'} =~ s/\"/\&quot\;/g;
    $in{'DESCRIPTION'} =~ s/\</&lt;/g;
    $in{'DESCRIPTION'} =~ s/\>/&gt;/g;
  }

$HTML = <<HTML;
<tr>
  <td width="200" valign="top" nowrap>$in{'TITLE'}$in{'REQUIRED'}</td>
  <td width="100%"><input type="text" name="$in{'NAME'}" value="$in{'VALUE'}"$in{'SIZE'}$in{'MAXLENGTH'} style="width:100%" class="TextField"></td>
  <td width="20" valign="top" nowrap><img src="$SYSTEM::IMAGE_URL/help.gif" width=20 height=20 border=0 alt="$in{'DESCRIPTION'}"></td>
</tr>
HTML

  return $HTML;
}

sub TextArea {
  my %in = (
    TITLE       => "",
    DESCRIPTION => "",
    NAME        => "",
    VALUE       => "",
    REQUIRED    => "",

    COLS        => "30",
    ROWS        => "3",

    @_
  );
  my $HTML;

  if ($in{'REQUIRED'}) {
    $in{'REQUIRED'}  = qq~ <font color="Red"><b>*</b></font>~;
  } else {
    $in{'REQUIRED'}  = qq~~;
  }

  if ($in{'DESCRIPTION'}) {
    $in{'DESCRIPTION'} =~ s/\"/\&quot\;/g;
    $in{'DESCRIPTION'} =~ s/\</&lt;/g;
    $in{'DESCRIPTION'} =~ s/\>/&gt;/g;
  }

$HTML = <<HTML;
<tr>
  <td width="200" valign="top" nowrap>$in{'TITLE'}$in{'REQUIRED'}</td>
  <td width="100%"><textarea cols="$in{'COLS'}" rows="$in{'ROWS'}" name="$in{'NAME'}" style="width:100%" class="TextArea">$in{'VALUE'}</textarea></td>
  <td width="20" valign="top" nowrap><img src="$SYSTEM::IMAGE_URL/help.gif" width=20 height=20 border=0 alt="$in{'DESCRIPTION'}"></td>
</tr>
HTML

  return $HTML;
}

sub CheckBox {
  my %in = (
    TITLE       => "",
    DESCRIPTION => "",
    NAME        => "",
    VALUE       => "",
    REQUIRED    => "",

    @_
  );
  my $HTML;

  if ($in{'REQUIRED'}) {
    $in{'REQUIRED'}  = qq~ <font color="Red"><b>*</b></font>~;
  } else {
    $in{'REQUIRED'}  = qq~~;
  }

  $in{'CHECKED'}   = qq~ checked~ if $in{'VALUE'};

  if ($in{'DESCRIPTION'}) {
    $in{'DESCRIPTION'} =~ s/\"/\&quot\;/g;
    $in{'DESCRIPTION'} =~ s/\</&lt;/g;
    $in{'DESCRIPTION'} =~ s/\>/&gt;/g;
  }

$HTML = <<HTML;
<tr>
  <td width="200" valign="top" nowrap>$in{'TITLE'}$in{'REQUIRED'}</td>
  <td width="100%"><input type="checkbox" name="$in{'NAME'}"$in{'CHECKED'} class="CheckBox"></td>
  <td width="20" valign="top" nowrap><img src="$SYSTEM::IMAGE_URL/help.gif" width=20 height=20 border=0 alt="$in{'DESCRIPTION'}"></td>
</tr>
HTML

  return $HTML;
}

sub Radio {
  my %in = (
    TITLE       => "",
    DESCRIPTION => "",
    NAME        => "",
    VALUE       => [],
    SELECT      => "",
    REQUIRED    => "",
    WRAP        =>  1,
    @_
  );
  my $HTML;

  my $Radios;
  for (my $index = 0; $index <= $#{ $in{'VALUE'} }; $index++) {
    my $checked;
    $checked = " checked" if $in{'VALUE'}->[$index]{'VALUE'} eq $in{'SELECT'};
    $Radios .= "<tr>" if $in{'WRAP'} == 1;
    $Radios .= "<td width=\"20\" nowrap><input type=\"radio\" name=\"".$in{'NAME'}."\" value=\"".$in{'VALUE'}->[$index]{'VALUE'}."\"$checked></td>";
    $Radios .= "<td nowrap>".$in{'VALUE'}->[$index]{'TITLE'}."</td>";
    $Radios .= "</tr>" if $in{'WRAP'} == 1;
  }
  $Radios = "<tr>".$Radios."<td width=\"100%\" nowrap></td></tr>" if $in{'WRAP'} != 1;

  if ($in{'REQUIRED'}) {
    $in{'REQUIRED'}  = qq~ <font color="Red"><b>*</b></font>~;
  } else {
    $in{'REQUIRED'}  = qq~~;
  }

  $in{'CHECKED'}  = qq~ checked~ if $in{'VALUE'};

  if ($in{'DESCRIPTION'}) {
    $in{'DESCRIPTION'} =~ s/\"/\&quot\;/g;
    $in{'DESCRIPTION'} =~ s/\</&lt;/g;
    $in{'DESCRIPTION'} =~ s/\>/&gt;/g;
  }

$HTML = <<HTML;
<tr>
  <td width="200" valign="top" nowrap>$in{'TITLE'}$in{'REQUIRED'}</td>
  <td width="100%"><table width="100%" border="0" cellspacing="0" cellpadding="0">$Radios</table></td>
  <td width="20" valign="top" nowrap><img src="$SYSTEM::IMAGE_URL/help.gif" width=20 height=20 border=0 alt="$in{'DESCRIPTION'}"></td>
</tr>
HTML

  return $HTML;
}

sub Select {
  my %in = (
    TITLE       => "",
    DESCRIPTION => "",
    NAME        => "",
    VALUE       => [],
    SELECT      => "",
    REQUIRED    => "",

    SIZE        => "",
    MULTIPLE    => "",
    @_
  );
  $in{'SELECT'} = join ("|", @{ $in{'SELECT'} });
  $in{'SELECT'} = "\|".$in{'SELECT'}."\|";

  my $HTML;

  my $Options;
  for (my $index = 0; $index <= $#{ $in{'VALUE'} }; $index++) {
    my $selected;
    if ($in{'SELECT'} =~ /\Q|$in{'VALUE'}->[$index]{'VALUE'}|\E/) {
      $selected = qq~ selected~;
    }
    $Options .= "<option value=\"".$in{'VALUE'}->[$index]{'VALUE'}."\"$selected>".$in{'VALUE'}->[$index]{'TITLE'}."</option>";
  }

  if ($in{'REQUIRED'}) {
    $in{'REQUIRED'}  = qq~ <font color="Red"><b>*</b></font>~;
  } else {
    $in{'REQUIRED'}  = qq~~;
  }

  $in{'SIZE'}     = qq~ size="$in{'SIZE'}"~ if $in{'SIZE'};
  $in{'MULTIPLE'} = qq~ multiple~             if $in{'MULTIPLE'};

  if ($in{'DESCRIPTION'}) {
    $in{'DESCRIPTION'} =~ s/\"/\&quot\;/g;
    $in{'DESCRIPTION'} =~ s/\</&lt;/g;
    $in{'DESCRIPTION'} =~ s/\>/&gt;/g;
  }

$HTML = <<HTML;
<tr>
  <td width="200" valign="top" nowrap>$in{'TITLE'}$in{'REQUIRED'}</td>
  <td width="100%"><table width="100%" border="0" cellspacing="0" cellpadding="0"><select name="$in{'NAME'}"$in{'SIZE'} class="Select"$in{'MULTIPLE'} style="width:100%">$Options</select></table></td>
  <td width="20" valign="top" nowrap><img src="$SYSTEM::IMAGE_URL/help.gif" width=20 height=20 border=0 alt="$in{'DESCRIPTION'}"></td>
</tr>
HTML

  return $HTML;
}

sub Encode {
  my ($data) = @_;

  if (ref ($data) eq "ARRAY") {
    for (my $i = 0; $i <= $#{$data}; $i++) {
      $data->[$i] =~ s/\\/\\\\/g;
      $data->[$i] =~ s/\$/\\\$/g;
      $data->[$i] =~ s/\@/\\\@/g;
      $data->[$i] =~ s/\%/\\\%/g;
      $data->[$i] =~ s/\~/\\\~/g;

      $data->[$i] =~ s/\"/\&quot\;/g;
      $data->[$i] =~ s/\'/\&\#39\;/g;
      $data->[$i] =~ s/\r//g;
      $data->[$i] =~ s/\s+$//;
    }
  } elsif (ref ($data) eq "HASH") {
    foreach my $key (keys %{$data}) {
      $data->{$key} =~ s/\\/\\\\/g;
      $data->{$key} =~ s/\$/\\\$/g;
      $data->{$key} =~ s/\@/\\\@/g;
      $data->{$key} =~ s/\%/\\\%/g;
      $data->{$key} =~ s/\~/\\\~/g;

      $data->{$key} =~ s/\"/\&quot\;/g;
      $data->{$key} =~ s/\'/\&\#39\;/g;
      $data->{$key} =~ s/\r//g;
      $data->{$key} =~ s/\s+$//;
    }
  } else {
    $data =~ s/\\/\\\\/g;
    $data =~ s/\$/\\\$/g;
    $data =~ s/\@/\\\@/g;
    $data =~ s/\%/\\\%/g;
    $data =~ s/\~/\\\~/g;

    $data =~ s/\"/\&quot\;/g;
    $data =~ s/\'/\&\#39\;/g;
    $data =~ s/\r//g;
    $data =~ s/\s+$//;
  }

  return $data;
}

###############################################################################
1; # end of Cfg.lib.pl file
###############################################################################