###############################################################################
# Clean.lib.pl                                                                #
###############################################################################
# UltraBoard 2000 by UltraScripts.com, Inc.                                   #
# Scripts written by Jacky Wing Wa Yung, WebMaster@UltraScripts.com           #
# Available from http://www.UltraBoard.org/                                   #
# =========================================================================== #
# COPYRIGHT NOTICE :                                                          #
#                                                                             #
# Copyright (c) 1999-2000 UltraScripts.com, Inc. All Rights Reserved.         #
#                                                                             #
# This program is being distributed as shareware. It may be used and modified #
# free for personal, government or non-profit. Any commercial use must be     #
# registered. However, modified versions cannot be sold or distributed. You   #
# cannot alter the copyright and "powered by" notices throughout the scripts. #
# These notices must be clearly visible to the end users.                     #
#                                                                             #
# WARRANTY DISCLAIMER:                                                        #
#                                                                             #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT #
# ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR       #
# FITNESS FOR A PARTICULAR PURPOSE.                                           #
###############################################################################

package Clean;

use strict;

###############################################################################
# Sessions function
sub Sessions {
  my ($Sessions) = &DB::Query (
    TABLE   => "Sessions",
    COLUMNS => [
      "ID"          ,
      "LOGIN_SECOND",
    ]                    ,
    WHERE   => {
      LOGIN_SECOND => [("<".(time - $SYSTEM::SESSIONS_EXPIRE))]
    }
  );

  my @IDs = ();
  foreach my $Session ( @{ $Sessions } ) {
    push (@IDs, $Session->{'ID'});
  }

  &DB::Delete (
    TABLE  => "Sessions",
    KEYS   => \@IDs
  );

  (-e "$SYSTEM::LOGS_PATH/clean.log") ?
  (&Standard::FileOpen(*LOG, "a", "$SYSTEM::LOGS_PATH/clean.log")) :
  (&Standard::FileOpen(*LOG, "w", "$SYSTEM::LOGS_PATH/clean.log"));
    print LOG time."\n";
  close (DATA);
}

###############################################################################
# Temp function
sub Temp {
  opendir (CGI_PATH, $SYSTEM::TEMP_PATH);
    while (my $F = readdir (CGI_PATH)) {
      if (-A "$SYSTEM::TEMP_PATH/$F" < (time - (60 * 60 * 24))) {
        unlink ("$SYSTEM::TEMP_PATH/$F");
      }
    }
  closedir(CGI_PATH);
  (-e "$SYSTEM::LOGS_PATH/clean.log") ?
  (&Standard::FileOpen(*LOG, "a", "$SYSTEM::LOGS_PATH/clean.log")) :
  (&Standard::FileOpen(*LOG, "w", "$SYSTEM::LOGS_PATH/clean.log"));
    print LOG time."\n";
  close (DATA);
}

###############################################################################
1; # end of Clean.lib.pl file
###############################################################################