###############################################################################
# Sendmail.lib.pl                                                             #
###############################################################################
# UltraBoard 2000 by UltraScripts.com, Inc.                                   #
# Scripts written by Jacky Wing Wa Yung, WebMaster@UltraScripts.com           #
# Available from http://www.UltraBoard.org/                                   #
# =========================================================================== #
# COPYRIGHT NOTICE :                                                          #
#                                                                             #
# Copyright (c) 1999-2000 UltraScripts.com, Inc. All Rights Reserved.         #
#                                                                             #
# This program is being distributed as shareware. It may be used and modified #
# free for personal, government or non-profit. Any commercial use must be     #
# registered. However, modified versions cannot be sold or distributed. You   #
# cannot alter the copyright and "powered by" notices throughout the scripts. #
# These notices must be clearly visible to the end users.                     #
#                                                                             #
# WARRANTY DISCLAIMER:                                                        #
#                                                                             #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT #
# ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR       #
# FITNESS FOR A PARTICULAR PURPOSE.                                           #
###############################################################################

package Mail;

use Socket;

sub Send {

# =========================================================================== #
# Verify Variables

  my %args = (
    TO          => "",
    FROM        => "$GENERAL::ULTRABOARD_NAME <$GENERAL::CONTACT_EMAIL>",
    REPLY       => "",
    CC          => "",
    BCC         => "",
    SUBJECT     => "",
    MESSAGE     => "",
    HEADER      => "Content-type: text/html", # Content-type: text/plain; charset=\"iso-8859-1\"
    SMTP        => $SYSTEM::SMTP_PATH,
    SENDMAIL    => $SYSTEM::SENDMAIL_PATH,
    @_
  );

  return unless ($args{'TO'});

  $args{'TO'}       =~ s/[ \t]+/ /g;
  $args{'CC'}       =~ s/[ \t]+/ /g;
  $args{'BCC'}      =~ s/[ \t]+/ /g;

  $args{'TO'}       =~ s/,,/,/g;
  $args{'CC'}       =~ s/,,/,/g;
  $args{'BCC'}      =~ s/,,/,/g;

  $args{'SENDMAIL'} =~ s/\|//g;

  my $FromAddress   = $args{'FROM'};
     $FromAddress   =~ s/.*<([^\s]*?)>/$1/;

  my $ReplyAddress  = $args{'REPLY'};
     $ReplyAddress  =~ s/.*<([^\s]*?)>/$1/;
     $ReplyAddress  =~ s/^([^\s]+).*/$1/;

  my ($CRLF)        = "\n"; #"\015\012";

# =========================================================================== #
# Connecting the Sendmail Server

  open (SENDMAIL, "|$args{'SENDMAIL'} -t") || &UB::CGIError("Cannot open the sendmail server. $!", "$args{'SMTP'}");

# =========================================================================== #
# Sending Message

  print SENDMAIL "To: "         . $args{'TO'}   . $CRLF;
  print SENDMAIL "From: "       . $args{'FROM'} . $CRLF;
  print SENDMAIL "Reply-to: "   . $ReplyAddress . $CRLF if ($ReplyAddress  );
  print SENDMAIL "Bcc: "        . $args{'BCC'}  . $CRLF if ($args{'BCC'}   );
  print SENDMAIL "Cc: "         . $args{'CC'}   . $CRLF if ($args{'CC'}    );
  print SENDMAIL $args{'HEADER'}                . $CRLF if ($args{'HEADER'});

  print SENDMAIL "X-Mailer: UltraBoard 2000"                . $CRLF;
  print SENDMAIL "X-Mailer-Info: http://www.UltraBoard.org/". $CRLF;

  print SENDMAIL "Subject: "  . $args{'SUBJECT'}. $CRLF     . $CRLF;
  print SENDMAIL                $args{'MESSAGE'}. $CRLF     . $CRLF;

  close (SENDMAIL);

# =========================================================================== #
# Track Down Current Send Mail Infomation

  if ($SYSTEM::LOGS) {
    &Standard::lock("sendmail.lock") unless ($SYSTEM::FLOCK == 1);

    (-e "$SYSTEM::LOGS_PATH/sendmail.log") ?
    (&Standard::FileOpen(*LOG, "a", "$SYSTEM::LOGS_PATH/sendmail.log")) :
    (&Standard::FileOpen(*LOG, "w", "$SYSTEM::LOGS_PATH/sendmail.log"));
      print LOG "$ENV{'REMOTE_ADDR'}|$args{'TO'}|$args{'FROM'}|$args{'BCC'}|$args{'CC'}|$ReplyAddress|$args{'SUBJECT'}\n";
    close (LOG);

    &Standard::unLock("sendmail.lock") unless ($SYSTEM::FLOCK == 1);
  }

  return 1;
}

###############################################################################
1; # end of Sendmail.lib.pl file
###############################################################################