###############################################################################
# Track.lib.pl                                                                #
###############################################################################
# UltraBoard 2000 by UltraScripts.com, Inc.                                   #
# Scripts written by Jacky Wing Wa Yung, WebMaster@UltraScripts.com           #
# Available from http://www.UltraBoard.org/                                   #
# =========================================================================== #
# COPYRIGHT NOTICE :                                                          #
#                                                                             #
# Copyright (c) 1999-2000 UltraScripts.com, Inc. All Rights Reserved.         #
#                                                                             #
# This program is being distributed as shareware. It may be used and modified #
# free for personal, government or non-profit. Any commercial use must be     #
# registered. However, modified versions cannot be sold or distributed. You   #
# cannot alter the copyright and "powered by" notices throughout the scripts. #
# These notices must be clearly visible to the end users.                     #
#                                                                             #
# WARRANTY DISCLAIMER:                                                        #
#                                                                             #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT #
# ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR       #
# FITNESS FOR A PARTICULAR PURPOSE.                                           #
###############################################################################

package Standard;

use strict;
use Fcntl;

###############################################################################
# Track function
sub Track {
  my (@Info, $Log);

  return if ((!$SYSTEM::LOGS) && (!$SYSTEM::STATS));

  my $IP         = $ENV{'REMOTE_ADDR'};
  my $RemoteHost = $ENV{'REMOTE_HOST'};
  my $Referer    = $ENV{'HTTP_REFERER'};
     $Referer    = "Bookmark" unless $Referer;
     $Referer    =~ s/\?(.|\n)*//ig;
  my $Agent      = $ENV{'HTTP_USER_AGENT'};
  my $Time       = time;

  my ($sec, $min, $hour, $mDay, $Mon, $Year, $wDay) = (localtime ($Time)) [0..6];

  $Year += 1900;

  #if ( (!$RemoteHost) || ($RemoteHost =~ /^\d+\.\d+\.\d+\.\d+$/)) {
  #  if ($ENV{'REMOTE_ADDR'} =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/) {
  #    $RemoteHost = ( gethostbyaddr ( pack ('C4', $1, $2, $3, $4), 2 ) ) [0] || $ENV{'REMOTE_ADDR'};
  #  }
  #  $RemoteHost =~ tr[A-Z][a-z];
  #  $ENV{'REMOTE_HOST'} = $RemoteHost;
  #}

  if ($SYSTEM::LOGS) {
    my $Query =  "U=".$UB::MEMBER{'USERNAME'}.
                "&A=".$UB::QUERY{'action'}.
                "&C=".$UB::QUERY{'CID'}.
                "&B=".$UB::QUERY{'BID'}.
                "&T=".$UB::QUERY{'TID'}.
                "&P=".$UB::QUERY{'PID'};

    push (@Info, $Time, $RemoteHost, $IP, $Agent, $Referer, $Query);

    for (my $i = 0; $i <= $#Info; $i++) {
      $Info[$i] =~ s/\||\r|\n//g;
    }

    $Log = join ("|", @Info);

    (-e "$SYSTEM::LOGS_PATH/access.$Year.$Mon.$mDay.log") ?
    (&Standard::FileOpen(*LOG, "a", "$SYSTEM::LOGS_PATH/access.$Year.$Mon.$mDay.log")) :
    (&Standard::FileOpen(*LOG, "w", "$SYSTEM::LOGS_PATH/access.$Year.$Mon.$mDay.log"));
      print LOG $Log."\n";
    close (LOG);
  }

  if ($SYSTEM::STATS) {
    &Standard::FileOpen(*IPs, "rw", "$SYSTEM::LOGS_PATH/ips.stats");
      my @IPs = <IPs>;
    close (IPs);

    my $CURRENT_DATE = sprintf ("%04d%02d%02d", $Year, $Mon + 1, $mDay);

    &Standard::FileOpen(*CURRENT_DATE, "rw", "$SYSTEM::LOGS_PATH/currect_date.stats");
      my $LAST_DATE = <CURRENT_DATE>;
    close (CURRENT_DATE);

    my $NEW;
       $NEW = 1 if ($CURRENT_DATE ne $LAST_DATE);

    if (("@IPs" ne "$IP") || ($NEW)) {
      &Standard::FileOpen(*TOTAL_HITS, "rw", "$SYSTEM::LOGS_PATH/total_hits.stats");
        my $TOTAL_HITS = <TOTAL_HITS>;
      close (TOTAL_HITS);
      &Standard::FileOpen(*TOTAL_HITS, "w", "$SYSTEM::LOGS_PATH/total_hits.stats");
        print TOTAL_HITS ++$TOTAL_HITS;
      close (TOTAL_HITS);

      if ($NEW) {
        &Standard::FileOpen(*CURRENT_DATE, "w", "$SYSTEM::LOGS_PATH/currect_date.stats");
          print CURRENT_DATE $CURRENT_DATE;
        close (CURRENT_DATE);
      }

      ($NEW) ?
      (&Standard::FileOpen(*IPs, "w", "$SYSTEM::LOGS_PATH/ips.stats")) :
      (&Standard::FileOpen(*IPs, "a", "$SYSTEM::LOGS_PATH/ips.stats"));
        print IPs $IP."\n";
      close (IPs);

      &Standard::FileOpen(*TODAY_HITS, "rw", "$SYSTEM::LOGS_PATH/today_hits.stats");
        my $TODAY_HITS = <TODAY_HITS>;
      close (TODAY_HITS);
      $TODAY_HITS = 0 unless ($TODAY_HITS);

      if ($NEW) {
        &Standard::FileOpen(*TODAY_HITS, "w", "$SYSTEM::LOGS_PATH/today_hits.stats");
          print TODAY_HITS "1";
        close (TODAY_HITS);

        if ($LAST_DATE) {
          &Standard::FileOpen(*OTHER_DAYS_HITS, "a", "$SYSTEM::LOGS_PATH/other_days_hits.stats");
            print OTHER_DAYS_HITS $LAST_DATE."|^|".$TODAY_HITS."\n";
          close (OTHER_DAYS_HITS);
        }
      } else {
        &Standard::FileOpen(*TODAY_HITS, "w", "$SYSTEM::LOGS_PATH/today_hits.stats");
          print TODAY_HITS ++$TODAY_HITS;
        close (TODAY_HITS);
      }

      my ($Browser, $Version) = &Agent($Agent);
      tie (my %AGENTS, $AnyDBM_File::ISA[0], "$SYSTEM::LOGS_PATH/agents.stats", O_RDWR|O_CREAT, 0777);
       $AGENTS{ $Browser.".".$Version }++;
      untie (%AGENTS);

      my ($Platform) = &Platform($Agent);
      tie (my %PLATFORMS, $AnyDBM_File::ISA[0], "$SYSTEM::LOGS_PATH/platforms.stats", O_RDWR|O_CREAT, 0777);
       $PLATFORMS{ $Platform }++;
      untie (%PLATFORMS);

      tie (my %DAY, $AnyDBM_File::ISA[0], "$SYSTEM::LOGS_PATH/day_hits.stats", O_RDWR|O_CREAT, 0777);
       $DAY{ $hour }++;
      untie (%DAY);

      tie (my %WEEK, $AnyDBM_File::ISA[0], "$SYSTEM::LOGS_PATH/week_hits.stats", O_RDWR|O_CREAT, 0777);
       $WEEK{ $wDay }++;
      untie (%WEEK);

      tie (my %YEAR, $AnyDBM_File::ISA[0], "$SYSTEM::LOGS_PATH/year_hits.stats", O_RDWR|O_CREAT, 0777);
       $YEAR{ $Mon }++;
      untie (%YEAR);
    }
  }

  return 1;
}

###############################################################################
# Agent function
sub Agent {
  $_ = $_[0];
  if (m/opera.(\d)/io) {
    return ("Opera", "$1");
  } elsif (m/opera/io) {
    return ("Opera", "");
  } elsif (m/mosaic/io) {
    return ("MOSAIC", "");
  } elsif (m/java/io) {
    return ("JAVA", "");
  } elsif (m/macweb/io) {
    return ("MacWeb", "");
  } elsif (m/webexplorer/io) {
    return ("WebExplorer", "");
  } elsif (m/omniweb/io) {
    return ("OmniWeb", "");
  } elsif (m/mozilla/io) {
    if (m/compatible/io) {
      if (m/webtv/io) {
        return ("WebTV", "");
      } elsif (m/aol (\d)/io) {
        return ("AOL Browser", "$1");
      } elsif (m/iweng (\d)/io) {
        return ("AOL Browser", "$1");
      } elsif (m/msie (\d)/io) {
        return ("MS Internet Explorer", "$1");
      } elsif (m/msie/io) {
        return ("MS Internet Explorer", "$1");
      } elsif (m/bot|frontpage|powermarks|spider|webwhacker/io) {
        return ("Spider/Robot", "");
      } else {
        return ("Mozilla Compatible Browser", "");
      }
    } elsif (m/msie/io) {
      return ("MS Internet Explorer", "");
    } elsif (m/bot|spider/io) {
      return ("Spider/Robot", "");
    } else {
      if (m/mozilla\/(\d)/io) {
        return ("Netscape Navigator", "$1");
      } else {
        return ("Netscape Navigator", "");
      }
    }
  } elsif (m/iweng\/(\d)/io) {
    return ("AOL Browser", "$1");
  } elsif (m/aolbrowser\/(\d)/io) {
    return ("AOL Browser", "$1");
  } elsif (m/microsoft internet explorer\/(\d)/io) {
    return ("MS Internet Explorer", "$1");
  } elsif (m/lynx/io) {
    return ("Lynx", "");
  } elsif (m/teleport pro/io) {
    return ("Teleport Pro Offline Browser", "");
  } elsif (m/analyzer|batch|bot|check|frontpage|getright|harvest|infoseek|links|offline|powermarks|spider|url|validator|/io) {
    return ("Spider/Robot", "");
  } else {
    return ("Other Agent", "");
  }
}

###############################################################################
# Platform function
sub Platform {
  $_ = $_[0];
  if (m/win/io) {
    if (m/95\/nt|98\/nt/io) {
      return ("Windows");
    } elsif (m/win95|windows 95/io) {
      return ("Windows 95");
    } elsif (m/win98|windows 98/io) {
      return ("Windows 98");
    } elsif (m/windows nt 5/io) {
      return ("Windows 2000");
    } elsif (m/windows nt (\d)/io) {
      return ("Windows NT $1");
    } elsif (m/winnt|windows nt/io) {
      return ("Windows NT");
    } elsif (m/win3.1|windows 3.1/io) {
      return ("Windows 3.1");
    } elsif (m/win16|win32|winweb|windows/io) {
      return ("Windows");
    } elsif (m/window/io) {
      return ("X Windows");
    } else {
      return ("Windows");
    }
  } elsif (m/mac/io) {
    if (m/ppc|powerpc/io) {
      return ("Macintosh PowerPC");
    } else {
      return ("Macintosh 68K");
    }
  } elsif (m/amiga/io) {
    return ("Amiga");
  } elsif (m/os\/2/io) {
    return ("OS/2");
  } elsif (m/os\/2/io) {
    return ("OS/2");
  } elsif (m/os\/2/io) {
    return ("OS/2");
  } elsif (m/x11/io) {
    if (m/hp-ux/io) {
      return ("UNIX (HP-UX)");
    } elsif (m/linux/io) {
      return ("UNIX (Linux)");
    } elsif (m/sunos/io) {
      return ("UNIX (SunOS)");
    } elsif (m/freebsd/io) {
      return ("UNIX (FreeBSD)");
    } elsif (m/netbsd/io) {
      return ("UNIX (NetBSD)");
    } elsif (m/bsd/io) {
      return ("UNIX (BSD)");
    } elsif (m/aix/io) {
      return ("UNIX (AIX)");
    } elsif (m/osf1/io) {
      return ("UNIX (OSF1)");
    } elsif (m/irix/io) {
      return ("UNIX (IRIX)");
    } else {
      return ("UNIX");
    }
  } elsif (m/iweng|teleport/io) {
    return ("Windows");
  } elsif (m/lynx/io) {
    return ("UNIX");
  } elsif (m/webtv/io) {
    return ("WebTV");
  } else {
    return ("Unknown Platform");
  }
}

###############################################################################
1; # end of Track.lib.pl file
###############################################################################