###############################################################################
# UltraBoard.lib.pl                                                           #
###############################################################################
# UltraBoard 2000 by UltraScripts.com, Inc.                                   #
# Scripts written by Jacky Wing Wa Yung, WebMaster@UltraScripts.com           #
# Available from http://www.UltraBoard.org/                                   #
# =========================================================================== #
# COPYRIGHT NOTICE :                                                          #
#                                                                             #
# Copyright (c) 1999-2000 UltraScripts.com, Inc. All Rights Reserved.         #
#                                                                             #
# This program is being distributed as shareware. It may be used and modified #
# free for personal, government or non-profit. Any commercial use must be     #
# registered. However, modified versions cannot be sold or distributed. You   #
# cannot alter the copyright and "powered by" notices throughout the scripts. #
# These notices must be clearly visible to the end users.                     #
#                                                                             #
# WARRANTY DISCLAIMER:                                                        #
#                                                                             #
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT WITHOUT #
# ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF MERCHANTABILITY OR       #
# FITNESS FOR A PARTICULAR PURPOSE.                                           #
###############################################################################

package UltraBoard;

use strict;

###############################################################################
# Encode function
sub Encode {
  my ($data, $signature, $html, $BID, $PID, $TMP) = @_;

  $data =~ s/\\\[/[<!-- -->/ig;
  $data =~ s/\\\(/(<!-- -->/ig;

  if ($signature != 1) {
    my $Counter = 0;
    if ($html == 1) {
      $data =~ s/\[html\]\n*(.*?)\n*\[\/html\]/
        $Counter++;
        my $HTML = $1;
        $HTML = &Standard::DecodeHTML($HTML);
        $HTML =~ s\/<!--(.|\n)*-->\/\/g;
        if ($HTML !~ \/^\\s*$\/) {
          if ($TMP) {
            &Standard::FileOpen(*HTML, "w", $SYSTEM::TEMP_PATH."\/B".$BID."-".$TMP."-".$Counter.".html");
              print HTML $HTML;
            close(HTML);
          } else {
            &Standard::FileOpen(*HTML, "w", $SYSTEM::DB_PATH."\/B".$BID."\/".$PID."-".$Counter.".html");
              print HTML $HTML;
            close(HTML);
          }

          "<blockquote><iframe class=\"iframe\" src=\"$SYSTEM::UB_URL\/Others.$SYSTEM::EXT?action=HTML&BID=$BID&PID=$PID&HID=$Counter&TMP=$TMP\" name=\"UB_CODES.HTML_TAGS\" width=\"100%\" height=\"150\"><a href=\"$SYSTEM::UB_URL\/HTML.$SYSTEM::EXT?action=HTML&BID=$BID&PID=$PID&HID=$Counter&TMP=$TMP\" target=\"_blank\">CLICK HERE FOR THE HTML CODES<\/a><\/iframe><\/blockquote>"
        }
      /iges;
    }
  }
##### doG change starts #######
  #if ($signature != 1) {
  # if ($UB::QUERY{'action'} eq "DoReply") {
  #   $data =~ s/\&gt\;\s\&gt\;\s\&gt\;\s\&gt\;\s(.*)\n/<font color=\"\#CC3300\">\&gt\;<!--re--> \&gt\;<!--re--> \&gt\;<!--re--> \&gt\;<!--re--> $1<\/font>\n/ig;
  #   $data =~ s/\&gt\;\s\&gt\;\s\&gt\;\s(.*)\n/<font color=\"\#006600\">\&gt\;<!--re--> \&gt\;<!--re--> \&gt\;<!--re--> $1<\/font>\n/ig;
  #   $data =~ s/\&gt\;\s\&gt\;\s(.*)\n/<font color=\"\#0000CC\">\&gt\;<!--re--> \&gt\;<!--re--> $1<\/font>\n/ig;
  #   $data =~ s/\&gt\;\s(.*)\n/<font color=\"\#990099\">\&gt\;<!--re--> $1<\/font>\n/ig;
  # }
  #}

  if ($signature != 1) {
   if (($UB::QUERY{'action'} eq "DoReply") || ($UB::QUERY{'action'} eq "DoModifyPost")) {
     $data =~ s/\&gt\;\s\&gt\;\s\&gt\;\s\&gt\;\s(.*)\n/<font color=\"\#CC3300\">\&gt\;<!--re--> \&gt\;<!--re--> \&gt\;<!--re--> \&gt\;<!--re--> $1<\/font>\n/ig;
     $data =~ s/\&gt\;\s\&gt\;\s\&gt\;\s(.*)\n/<font color=\"\#006600\">\&gt\;<!--re--> \&gt\;<!--re--> \&gt\;<!--re--> $1<\/font>\n/ig;
     $data =~ s/\&gt\;\s\&gt\;\s(.*)\n/<font color=\"\#0000CC\">\&gt\;<!--re--> \&gt\;<!--re--> $1<\/font>\n/ig;
     $data =~ s/\&gt\;\s(.*)\n/<font color=\"\#990099\">\&gt\;<!--re--> $1<\/font>\n/ig;
   }
  }
##### doG change ends #######

  $data =~ s/(^|\s)(http:\/\/\S+)/$1<a href=\"$2\" target=\"_blank\">$2<\/a>/ig;
  $data =~ s/(^|\s)(ftp:\/\/\S+)/$1<a href=\"$2\" target=\"_blank\">$2<\/a>/ig;
  $data =~ s/(^|\s)([\.\w\-]+\@[\.\w\-]+\.[\.\w\-]+)/$1<a href=\"mailto:$2\">$2<\/a>/ig;

  $data =~ s/(^|\s)\\(http:\/\/\S+)/$1$2/ig;
  $data =~ s/(^|\s)\\(ftp:\/\/\S+)/$1$2/ig;
  $data =~ s/(^|\s)\\([\.\w\-]+\@[\.\w\-]+\.[\.\w\-]+)/$1$2/ig;

  $data =~ s/\[img\s*=\s*\"?\s*(\S+)\s*\"?\]/<img src=\"$1\" border=\"0\">/ig;

  $data =~ s/\[url\s*=\s*\"?\s*(\S+)\s*\"?\](.*?)\[\/url\]/<a href=\"$1\" target=\"_blank\">$2<\/a>/isg;

  $data =~ s/\[email\s*=\s*\"?\s*([\.\w\-]+\@[\.\w\-]+\.[\.\w\-]+)\s*\"?\](.*?)\[\/email\]/<a href=\"mailto:$1\">$2<\/a>/isg;

  $data =~ s/\[b\](.*?)\[\/b\]/<b>$1<\/b>/isg;
  $data =~ s/\[i\](.*?)\[\/i\]/<i>$1<\/i>/isg;
  $data =~ s/\[u\](.*?)\[\/u\]/<u>$1<\/u>/isg;

  $data =~ s/\[1\](.*?)\[\/1\]/<font size=\"1\">$1<\/font>/isg;
  $data =~ s/\[2\](.*?)\[\/2\]/<font size=\"2\">$1<\/font>/isg;
  $data =~ s/\[3\](.*?)\[\/3\]/<font size=\"3\">$1<\/font>/isg;
  $data =~ s/\[4\](.*?)\[\/4\]/<font size=\"4\">$1<\/font>/isg;

  $data =~ s/\[fixed\](.*?)\[\/fixed\]/<font face=\"Courier New\">$1<\/font>/isg;

  $data =~ s/\[color\s*=\s*\"?\s*([#0-9a-fA-F]+)\s*\"?\s*\](.*?)\[\/color\]/<font color=\"$1\">$2<\/font>/isg;

  $data =~ s/\[sup\](.*?)\[\/sup\]/<sup>$1<\/sup>/isg;
  $data =~ s/\[sub\](.*?)\[\/sub\]/<sub>$1<\/sub>/isg;

  $data =~ s/\[center\](.*?)\[\/center\]/<center>$1<\/center>/isg;

  $data =~ s/\(c\)/\&copy\;/ig;
  $data =~ s/\(r\)/\&reg\;/ig;
  $data =~ s/\(tm\)/\&\#153\;/ig;

  foreach my $Emotion (sort { length ($b) <=> length ($a) } keys %{ $UB::STYLE{'EMOTIONS'} }) {
    next unless $Emotion;
    next unless $UB::STYLE{'EMOTIONS'}->{ $Emotion };
    my $Replacement = $UB::STYLE{'EMOTIONS'}->{$Emotion};
    $Emotion = quotemeta ($Emotion);
    next if ($data =~ s/(^|\s)\\$Emotion(\s|$)/$1$Emotion$2/ig);
    $data =~ s/(^|\s)$Emotion(\s|$)/$1<img src=\"$SYSTEM::IMAGE_URL\/$SYSTEM::DEFAULT_THEME\/$Replacement\" border=\"0\" valign=\"absmiddle\">$2/ig;
  }

  if ($signature != 1) {
    my %Size = (
      "1" => "xx-small",
      "2" => "x-small",
      "3" => "small",
      "4" => "medium",
      "5" => "large",
      "6" => "x-large",
      "7" => "xx-large",

      "+1" => "larger",
      "+2" => "large",
      ""   => "medium",
      "-1" => "small",
      "-2" => "smaller"
    );

    $data =~ s/\[order(=(1|a|A|i|I))?\](.*?)\[\/order\]/<ol type=\"$1\">$3<\/ol>/isg;
    $data =~ s/\[unorder(=(circle|square|disc))?\](.*?)\[\/unorder\]/<ul type=\"$1\">$3<\/ul>/isg;

    $data =~ s/(^|[^\\])\[\+\s*(\d)?\]/($2) ? "$1<li value=\"$2\">" : "$1<li>"/ieg;

    while ($data =~ s/\[quote\](.*?)\[\/quote\]/<blockquote><hr>$1<hr><\/blockquote>/isg) {}
    while ($data =~ s/\[code\](.*?)\[\/code\]/<blockquote><pre style=\"font-family: Courier New; font-size: $Size{$UB::STYLE{'BODY_TEXT_SIZE'}};\"><font size=\"1\" face=\"Arial\">code:<\/font><hr>$1<hr><\/pre><\/blockquote>/isg) {}
    while ($data =~ s/\[pre\](.*?)\[\/pre\]/<pre style=\"font-family: $UB::STYLE{'FONT_FACE'}; font-size: $Size{$UB::STYLE{'BODY_TEXT_SIZE'}};\">$1<\/pre>/isg) {}
  }

  $data =~ s/\n\n/\<p\>/g;
  $data =~ s/\n/\<br\>/g;

##### doG change starts #######
$data =~ s/\ &gt;<!--re-->/&gt;<!--re-->/g;

$data =~ s/\&gt;<!--re-->&gt;<!--re-->&gt;<!--re-->&gt;<!--re--> <\/font><br>/<\/font>\<br\>/g;
$data =~ s/\&gt;<!--re-->&gt;<!--re-->&gt;<!--re--> <\/font><br>/<\/font>\<br\>/g;
$data =~ s/\&gt;<!--re-->&gt;<!--re--> <\/font><br>/<\/font>\<br\>/g;
$data =~ s/\&gt;<!--re--> <\/font><br>/<\/font>\<br\>/g;
##### doG change ends #######
  return $data;
}

###############################################################################
1; # end of UltraBoard.lib.pl file
###############################################################################